//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_ef "bufio";_d "bytes";_a "encoding/hex";_e "errors";_eg "fmt";_ffc "github.com/unidoc/unipdf/v3/common";_gg "github.com/unidoc/unipdf/v3/core";_b "io";_ff "os";_c "regexp";_dd "sort";_f "strconv";_gb "strings";);func (_de *fdfParser )skipComments ()error {if _ ,_gf :=_de .skipSpaces ();
_gf !=nil {return _gf ;};_aaa :=true ;for {_cfa ,_aag :=_de ._gde .Peek (1);if _aag !=nil {_ffc .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_aag .Error ());return _aag ;};if _aaa &&_cfa [0]!='%'{return nil ;};_aaa =false ;if (_cfa [0]!='\r')&&(_cfa [0]!='\n'){_de ._gde .ReadByte ();
}else {break ;};};return _de .skipComments ();};func (_eb *fdfParser )getFileOffset ()int64 {_fg ,_ :=_eb ._bd .Seek (0,_b .SeekCurrent );_fg -=int64 (_eb ._gde .Buffered ());return _fg ;};func (_ed *fdfParser )parseArray ()(*_gg .PdfObjectArray ,error ){_ge :=_gg .MakeArray ();
_ed ._gde .ReadByte ();for {_ed .skipSpaces ();_aea ,_cdb :=_ed ._gde .Peek (1);if _cdb !=nil {return _ge ,_cdb ;};if _aea [0]==']'{_ed ._gde .ReadByte ();break ;};_fff ,_cdb :=_ed .parseObject ();if _cdb !=nil {return _ge ,_cdb ;};_ge .Append (_fff );
};return _ge ,nil ;};func (_faa *fdfParser )skipSpaces ()(int ,error ){_dfg :=0;for {_dda ,_dge :=_faa ._gde .ReadByte ();if _dge !=nil {return 0,_dge ;};if _gg .IsWhiteSpace (_dda ){_dfg ++;}else {_faa ._gde .UnreadByte ();break ;};};return _dfg ,nil ;
};var _bcb =_c .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");func (_agb *fdfParser )readTextLine ()(string ,error ){var _feg _d .Buffer ;for {_fdb ,_bb :=_agb ._gde .Peek (1);
if _bb !=nil {_ffc .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_bb .Error ());return _feg .String (),_bb ;};if (_fdb [0]!='\r')&&(_fdb [0]!='\n'){_eaa ,_ :=_agb ._gde .ReadByte ();_feg .WriteByte (_eaa );}else {break ;};};return _feg .String (),nil ;
};

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_gce ,_egf :=_ff .Open (fdfPath );if _egf !=nil {return nil ,_egf ;};defer _gce .Close ();return Load (_gce );};

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_gg .PdfObject ,error ){_cf ,_agc :=fdf .FieldDictionaries ();if _agc !=nil {return nil ,_agc ;};var _bg []string ;for _cff :=range _cf {_bg =append (_bg ,_cff );};_dd .Strings (_bg );_egc :=map[string ]_gg .PdfObject {};
for _ ,_ade :=range _bg {_gd :=_cf [_ade ];_cc :=_gg .TraceToDirectObject (_gd .Get ("\u0056"));_egc [_ade ]=_cc ;};return _egc ,nil ;};func _gfb (_bbe string )(_gg .PdfObjectReference ,error ){_ce :=_gg .PdfObjectReference {};_aeb :=_fde .FindStringSubmatch (_bbe );
if len (_aeb )< 3{_ffc .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");return _ce ,_e .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");
};_egg ,_acf :=_f .Atoi (_aeb [1]);if _acf !=nil {_ffc .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_aeb [1]);
return _ce ,nil ;};_ce .ObjectNumber =int64 (_egg );_bfa ,_acf :=_f .Atoi (_aeb [2]);if _acf !=nil {_ffc .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_aeb [2]);
return _ce ,nil ;};_ce .GenerationNumber =int64 (_bfa );return _ce ,nil ;};func _adeb (_accb string )(*fdfParser ,error ){_bedff :=fdfParser {};_cbdb :=[]byte (_accb );_abgg :=_d .NewReader (_cbdb );_bedff ._bd =_abgg ;_bedff ._dbc =map[int64 ]_gg .PdfObject {};
_eefb :=_ef .NewReader (_abgg );_bedff ._gde =_eefb ;_bedff ._ebg =int64 (len (_accb ));return &_bedff ,_bedff .parse ();};func (_cb *fdfParser )parseName ()(_gg .PdfObjectName ,error ){var _ac _d .Buffer ;_bf :=false ;for {_gcbc ,_ae :=_cb ._gde .Peek (1);
if _ae ==_b .EOF {break ;};if _ae !=nil {return _gg .PdfObjectName (_ac .String ()),_ae ;};if !_bf {if _gcbc [0]=='/'{_bf =true ;_cb ._gde .ReadByte ();}else if _gcbc [0]=='%'{_cb .readComment ();_cb .skipSpaces ();}else {_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_gcbc ,_gcbc );
return _gg .PdfObjectName (_ac .String ()),_eg .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_gcbc [0]);};}else {if _gg .IsWhiteSpace (_gcbc [0]){break ;}else if (_gcbc [0]=='/')||(_gcbc [0]=='[')||(_gcbc [0]=='(')||(_gcbc [0]==']')||(_gcbc [0]=='<')||(_gcbc [0]=='>'){break ;
}else if _gcbc [0]=='#'{_gdee ,_eaad :=_cb ._gde .Peek (3);if _eaad !=nil {return _gg .PdfObjectName (_ac .String ()),_eaad ;};_cb ._gde .Discard (3);_ebb ,_eaad :=_a .DecodeString (string (_gdee [1:3]));if _eaad !=nil {return _gg .PdfObjectName (_ac .String ()),_eaad ;
};_ac .Write (_ebb );}else {_cfg ,_ :=_cb ._gde .ReadByte ();_ac .WriteByte (_cfg );};};};return _gg .PdfObjectName (_ac .String ()),nil ;};func (_ddbd *fdfParser )parseDict ()(*_gg .PdfObjectDictionary ,error ){_ffc .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");
_acd :=_gg .MakeDict ();_cbf ,_ :=_ddbd ._gde .ReadByte ();if _cbf !='<'{return nil ,_e .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_cbf ,_ =_ddbd ._gde .ReadByte ();if _cbf !='<'{return nil ,_e .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");
};for {_ddbd .skipSpaces ();_ddbd .skipComments ();_bff ,_dfd :=_ddbd ._gde .Peek (2);if _dfd !=nil {return nil ,_dfd ;};_ffc .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_bff ),string (_bff ));
if (_bff [0]=='>')&&(_bff [1]=='>'){_ffc .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_ddbd ._gde .ReadByte ();_ddbd ._gde .ReadByte ();break ;};_ffc .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");
_gab ,_dfd :=_ddbd .parseName ();_ffc .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_gab );if _dfd !=nil {_ffc .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_dfd );
return nil ,_dfd ;};if len (_gab )> 4&&_gab [len (_gab )-4:]=="\u006e\u0075\u006c\u006c"{_daa :=_gab [0:len (_gab )-4];_ffc .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_gab );
_ffc .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_daa );_ddbd .skipSpaces ();_beb ,_ :=_ddbd ._gde .Peek (1);if _beb [0]=='/'{_acd .Set (_daa ,_gg .MakeNull ());continue ;};};_ddbd .skipSpaces ();
_eca ,_dfd :=_ddbd .parseObject ();if _dfd !=nil {return nil ,_dfd ;};_acd .Set (_gab ,_eca );_ffc .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_gab ,_eca .String ());};_ffc .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");
return _acd ,nil ;};func (_gbg *fdfParser )parseObject ()(_gg .PdfObject ,error ){_ffc .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");_gbg .skipSpaces ();for {_ecd ,_bdb :=_gbg ._gde .Peek (2);if _bdb !=nil {return nil ,_bdb ;
};_ffc .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_ecd ));if _ecd [0]=='/'{_dee ,_egd :=_gbg .parseName ();_ffc .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_dee );
return &_dee ,_egd ;}else if _ecd [0]=='('{_ffc .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _gbg .parseString ();}else if _ecd [0]=='['{_ffc .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");return _gbg .parseArray ();
}else if (_ecd [0]=='<')&&(_ecd [1]=='<'){_ffc .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _gbg .parseDict ();}else if _ecd [0]=='<'{_ffc .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");return _gbg .parseHexString ();
}else if _ecd [0]=='%'{_gbg .readComment ();_gbg .skipSpaces ();}else {_ffc .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_ecd ,_ =_gbg ._gde .Peek (15);_cbg :=string (_ecd );_ffc .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_cbg );
if (len (_cbg )> 3)&&(_cbg [:4]=="\u006e\u0075\u006c\u006c"){_bcd ,_aad :=_gbg .parseNull ();return &_bcd ,_aad ;}else if (len (_cbg )> 4)&&(_cbg [:5]=="\u0066\u0061\u006cs\u0065"){_dade ,_abb :=_gbg .parseBool ();return &_dade ,_abb ;}else if (len (_cbg )> 3)&&(_cbg [:4]=="\u0074\u0072\u0075\u0065"){_abd ,_dga :=_gbg .parseBool ();
return &_abd ,_dga ;};_gfc :=_fde .FindStringSubmatch (_cbg );if len (_gfc )> 1{_ecd ,_ =_gbg ._gde .ReadBytes ('R');_ffc .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_ecd [:]));_fbd ,_acc :=_gfb (string (_ecd ));
return &_fbd ,_acc ;};_dac :=_fba .FindStringSubmatch (_cbg );if len (_dac )> 1{_ffc .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _gbg .parseNumber ();};_dac =_eedb .FindStringSubmatch (_cbg );if len (_dac )> 1{_ffc .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");
_ffc .Log .Trace ("\u0025\u0020\u0073",_dac );return _gbg .parseNumber ();};_ffc .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_cbg );return nil ,_e .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");
};};};var _fba =_c .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");type fdfParser struct{_dbf int ;_be int ;_dbc map[int64 ]_gg .PdfObject ;_bd _b .ReadSeeker ;_gde *_ef .Reader ;_ebg int64 ;
_bcc *_gg .PdfObjectDictionary ;};func (_daca *fdfParser )trace (_fcc _gg .PdfObject )_gg .PdfObject {switch _dbfb :=_fcc .(type ){case *_gg .PdfObjectReference :_gec ,_baf :=_daca ._dbc [_dbfb .ObjectNumber ].(*_gg .PdfIndirectObject );if _baf {return _gec .PdfObject ;
};_ffc .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_gg .PdfIndirectObject :return _dbfb .PdfObject ;};return _fcc ;};var _eedb =_c .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");
func (_ecb *fdfParser )parseFdfVersion ()(int ,int ,error ){_ecb ._bd .Seek (0,_b .SeekStart );_aef :=20;_ddbe :=make ([]byte ,_aef );_ecb ._bd .Read (_ddbe );_fcb :=_efb .FindStringSubmatch (string (_ddbe ));if len (_fcb )< 3{_bgb ,_bga ,_cdd :=_ecb .seekFdfVersionTopDown ();
if _cdd !=nil {_ffc .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");return 0,0,_cdd ;
};return _bgb ,_bga ,nil ;};_ccg ,_eaab :=_f .Atoi (_fcb [1]);if _eaab !=nil {return 0,0,_eaab ;};_bbf ,_eaab :=_f .Atoi (_fcb [2]);if _eaab !=nil {return 0,0,_eaab ;};_ffc .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_ccg ,_bbf );
return _ccg ,_bbf ,nil ;};

// Data represents forms data format (FDF) file data.
type Data struct{_gc *_gg .PdfObjectDictionary ;_ad *_gg .PdfObjectArray ;};func (_dedd *fdfParser )parse ()error {_dedd ._bd .Seek (0,_b .SeekStart );_dedd ._gde =_ef .NewReader (_dedd ._bd );for {_dedd .skipComments ();_gee ,_aage :=_dedd ._gde .Peek (20);
if _aage !=nil {_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");return _aage ;};if _gb .HasPrefix (string (_gee ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_dedd ._gde .Discard (7);
_dedd .skipSpaces ();_dedd .skipComments ();_geg ,_ :=_dedd .parseDict ();_dedd ._bcc =_geg ;break ;};_dgd :=_bcb .FindStringSubmatchIndex (string (_gee ));if len (_dgd )< 6{_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_gee ));
return _e .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_eab ,_aage :=_dedd .parseIndirectObject ();if _aage !=nil {return _aage ;};switch _fgbf :=_eab .(type ){case *_gg .PdfIndirectObject :_dedd ._dbc [_fgbf .ObjectNumber ]=_fgbf ;case *_gg .PdfObjectStream :_dedd ._dbc [_fgbf .ObjectNumber ]=_fgbf ;default:return _e .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");
};};return nil ;};

// Load loads FDF form data from `r`.
func Load (r _b .ReadSeeker )(*Data ,error ){_df ,_fa :=_gdg (r );if _fa !=nil {return nil ,_fa ;};_ee ,_fa :=_df .Root ();if _fa !=nil {return nil ,_fa ;};_ag ,_dff :=_gg .GetArray (_ee .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_dff {return nil ,_e .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");
};return &Data {_ad :_ag ,_gc :_ee },nil ;};var _fb =_c .MustCompile ("\u0025\u0025\u0045O\u0046");func (_bed *fdfParser )parseHexString ()(*_gg .PdfObjectString ,error ){_bed ._gde .ReadByte ();var _dgb _d .Buffer ;for {_fbg ,_cdc :=_bed ._gde .Peek (1);
if _cdc !=nil {return _gg .MakeHexString (""),_cdc ;};if _fbg [0]=='>'{_bed ._gde .ReadByte ();break ;};_ggg ,_ :=_bed ._gde .ReadByte ();if !_gg .IsWhiteSpace (_ggg ){_dgb .WriteByte (_ggg );};};if _dgb .Len ()%2==1{_dgb .WriteRune ('0');};_dae ,_cffg :=_a .DecodeString (_dgb .String ());
if _cffg !=nil {_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_dgb .String ());
return _gg .MakeHexString (""),nil ;};return _gg .MakeHexString (string (_dae )),nil ;};func (_fd *fdfParser )readAtLeast (_cfe []byte ,_fc int )(int ,error ){_cd :=_fc ;_afa :=0;_gcb :=0;for _cd > 0{_fe ,_ffe :=_fd ._gde .Read (_cfe [_afa :]);if _ffe !=nil {_ffc .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_fe ,_gcb ,_ffe .Error ());
return _afa ,_e .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_gcb ++;_afa +=_fe ;_cd -=_fe ;};return _afa ,nil ;};var _fde =_c .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");


// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_gg .PdfObjectDictionary ,error ){_eec :=map[string ]*_gg .PdfObjectDictionary {};for _fac :=0;_fac < fdf ._ad .Len ();_fac ++{_dg ,_af :=_gg .GetDict (fdf ._ad .Get (_fac ));if _af {_ggf ,_ :=_gg .GetString (_dg .Get ("\u0054"));
if _ggf !=nil {_eec [_ggf .Str ()]=_dg ;};};};return _eec ,nil ;};func (_eedc *fdfParser )parseNull ()(_gg .PdfObjectNull ,error ){_ ,_bda :=_eedc ._gde .Discard (4);return _gg .PdfObjectNull {},_bda ;};func (_adb *fdfParser )setFileOffset (_afaa int64 ){_adb ._bd .Seek (_afaa ,_b .SeekStart );
_adb ._gde =_ef .NewReader (_adb ._bd );};

// Root returns the Root of the FDF document.
func (_bec *fdfParser )Root ()(*_gg .PdfObjectDictionary ,error ){if _bec ._bcc !=nil {if _ead ,_ca :=_bec .trace (_bec ._bcc .Get ("\u0052\u006f\u006f\u0074")).(*_gg .PdfObjectDictionary );_ca {if _gbc ,_fbab :=_bec .trace (_ead .Get ("\u0046\u0044\u0046")).(*_gg .PdfObjectDictionary );
_fbab {return _gbc ,nil ;};};};var _cffa []int64 ;for _fgg :=range _bec ._dbc {_cffa =append (_cffa ,_fgg );};_dd .Slice (_cffa ,func (_gfg ,_cgf int )bool {return _cffa [_gfg ]< _cffa [_cgf ]});for _ ,_gfga :=range _cffa {_afc :=_bec ._dbc [_gfga ];if _ebgb ,_bdd :=_bec .trace (_afc ).(*_gg .PdfObjectDictionary );
_bdd {if _fegd ,_acg :=_bec .trace (_ebgb .Get ("\u0046\u0044\u0046")).(*_gg .PdfObjectDictionary );_acg {return _fegd ,nil ;};};};return nil ,_e .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func _gdg (_gdgb _b .ReadSeeker )(*fdfParser ,error ){_accf :=&fdfParser {};
_accf ._bd =_gdgb ;_accf ._dbc =map[int64 ]_gg .PdfObject {};_gbb ,_cgc ,_fgb :=_accf .parseFdfVersion ();if _fgb !=nil {_ffc .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_fgb );
return nil ,_fgb ;};_accf ._dbf =_gbb ;_accf ._be =_cgc ;_fgb =_accf .parse ();return _accf ,_fgb ;};func (_bedf *fdfParser )parseBool ()(_gg .PdfObjectBool ,error ){_dgf ,_ddb :=_bedf ._gde .Peek (4);if _ddb !=nil {return _gg .PdfObjectBool (false ),_ddb ;
};if (len (_dgf )>=4)&&(string (_dgf [:4])=="\u0074\u0072\u0075\u0065"){_bedf ._gde .Discard (4);return _gg .PdfObjectBool (true ),nil ;};_dgf ,_ddb =_bedf ._gde .Peek (5);if _ddb !=nil {return _gg .PdfObjectBool (false ),_ddb ;};if (len (_dgf )>=5)&&(string (_dgf [:5])=="\u0066\u0061\u006cs\u0065"){_bedf ._gde .Discard (5);
return _gg .PdfObjectBool (false ),nil ;};return _gg .PdfObjectBool (false ),_e .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");};func (_dgc *fdfParser )parseIndirectObject ()(_gg .PdfObject ,error ){_ebge :=_gg .PdfIndirectObject {};
_ffc .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");_gga ,_adbd :=_dgc ._gde .Peek (20);if _adbd !=nil {_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return &_ebge ,_adbd ;};_ffc .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_gga ));_fec :=_bcb .FindStringSubmatchIndex (string (_gga ));if len (_fec )< 6{_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_gga ));
return &_ebge ,_e .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_dgc ._gde .Discard (_fec [0]);_ffc .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_fec );_aed :=_fec [1]-_fec [0];_ebe :=make ([]byte ,_aed );_ ,_adbd =_dgc .readAtLeast (_ebe ,_aed );if _adbd !=nil {_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_adbd );
return nil ,_adbd ;};_ffc .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_ebe );_dc :=_bcb .FindStringSubmatch (string (_ebe ));if len (_dc )< 3{_ffc .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_ebe ));
return &_ebge ,_e .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_ecf ,_ :=_f .Atoi (_dc [1]);_aca ,_ :=_f .Atoi (_dc [2]);_ebge .ObjectNumber =int64 (_ecf );_ebge .GenerationNumber =int64 (_aca );for {_dfc ,_abg :=_dgc ._gde .Peek (2);if _abg !=nil {return &_ebge ,_abg ;};_ffc .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_dfc ),string (_dfc ));
if _gg .IsWhiteSpace (_dfc [0]){_dgc .skipSpaces ();}else if _dfc [0]=='%'{_dgc .skipComments ();}else if (_dfc [0]=='<')&&(_dfc [1]=='<'){_ffc .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_ebge .PdfObject ,_abg =_dgc .parseDict ();
_ffc .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_abg );if _abg !=nil {return &_ebge ,_abg ;};_ffc .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");
}else if (_dfc [0]=='/')||(_dfc [0]=='(')||(_dfc [0]=='[')||(_dfc [0]=='<'){_ebge .PdfObject ,_abg =_dgc .parseObject ();if _abg !=nil {return &_ebge ,_abg ;};_ffc .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");
}else {if _dfc [0]=='e'{_fcd ,_ded :=_dgc .readTextLine ();if _ded !=nil {return nil ,_ded ;};if len (_fcd )>=6&&_fcd [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _dfc [0]=='s'{_dfc ,_ =_dgc ._gde .Peek (10);if string (_dfc [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_cffe :=6;
if len (_dfc )> 6{if _gg .IsWhiteSpace (_dfc [_cffe ])&&_dfc [_cffe ]!='\r'&&_dfc [_cffe ]!='\n'{_ffc .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");
_cffe ++;};if _dfc [_cffe ]=='\r'{_cffe ++;if _dfc [_cffe ]=='\n'{_cffe ++;};}else if _dfc [_cffe ]=='\n'{_cffe ++;};};_dgc ._gde .Discard (_cffe );_fga ,_ccga :=_ebge .PdfObject .(*_gg .PdfObjectDictionary );if !_ccga {return nil ,_e .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");
};_ffc .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_fga );_cg ,_agg :=_fga .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_gg .PdfObjectInteger );if !_agg {return nil ,_e .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");
};_adfa :=*_cg ;if _adfa < 0{return nil ,_e .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_adfa )> _dgc ._ebg {_ffc .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");
return nil ,_e .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_gcee :=make ([]byte ,_adfa );
_ ,_abg =_dgc .readAtLeast (_gcee ,int (_adfa ));if _abg !=nil {_ffc .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_gcee ),_gcee );_ffc .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_abg );
return nil ,_abg ;};_ceg :=_gg .PdfObjectStream {};_ceg .Stream =_gcee ;_ceg .PdfObjectDictionary =_ebge .PdfObject .(*_gg .PdfObjectDictionary );_ceg .ObjectNumber =_ebge .ObjectNumber ;_ceg .GenerationNumber =_ebge .GenerationNumber ;_dgc .skipSpaces ();
_dgc ._gde .Discard (9);_dgc .skipSpaces ();return &_ceg ,nil ;};};_ebge .PdfObject ,_abg =_dgc .parseObject ();return &_ebge ,_abg ;};};_ffc .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");
return &_ebge ,nil ;};func (_bfe *fdfParser )parseNumber ()(_gg .PdfObject ,error ){return _gg .ParseNumber (_bfe ._gde )};func (_ffb *fdfParser )parseString ()(*_gg .PdfObjectString ,error ){_ffb ._gde .ReadByte ();var _bcbd _d .Buffer ;_bfg :=1;for {_da ,_faaa :=_ffb ._gde .Peek (1);
if _faaa !=nil {return _gg .MakeString (_bcbd .String ()),_faaa ;};if _da [0]=='\\'{_ffb ._gde .ReadByte ();_dad ,_afae :=_ffb ._gde .ReadByte ();if _afae !=nil {return _gg .MakeString (_bcbd .String ()),_afae ;};if _gg .IsOctalDigit (_dad ){_fcg ,_ebdf :=_ffb ._gde .Peek (2);
if _ebdf !=nil {return _gg .MakeString (_bcbd .String ()),_ebdf ;};var _aagc []byte ;_aagc =append (_aagc ,_dad );for _ ,_ega :=range _fcg {if _gg .IsOctalDigit (_ega ){_aagc =append (_aagc ,_ega );}else {break ;};};_ffb ._gde .Discard (len (_aagc )-1);
_ffc .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_aagc );_gfa ,_ebdf :=_f .ParseUint (string (_aagc ),8,32);if _ebdf !=nil {return _gg .MakeString (_bcbd .String ()),_ebdf ;};_bcbd .WriteByte (byte (_gfa ));
continue ;};switch _dad {case 'n':_bcbd .WriteRune ('\n');case 'r':_bcbd .WriteRune ('\r');case 't':_bcbd .WriteRune ('\t');case 'b':_bcbd .WriteRune ('\b');case 'f':_bcbd .WriteRune ('\f');case '(':_bcbd .WriteRune ('(');case ')':_bcbd .WriteRune (')');
case '\\':_bcbd .WriteRune ('\\');};continue ;}else if _da [0]=='('{_bfg ++;}else if _da [0]==')'{_bfg --;if _bfg ==0{_ffb ._gde .ReadByte ();break ;};};_fbc ,_ :=_ffb ._gde .ReadByte ();_bcbd .WriteByte (_fbc );};return _gg .MakeString (_bcbd .String ()),nil ;
};func (_fgf *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_fgf ._bd .Seek (0,_b .SeekStart );_fgf ._gde =_ef .NewReader (_fgf ._bd );_ebc :=20;_ffea :=make ([]byte ,_ebc );for {_bgf ,_ffee :=_fgf ._gde .ReadByte ();if _ffee !=nil {if _ffee ==_b .EOF {break ;
}else {return 0,0,_ffee ;};};if _gg .IsDecimalDigit (_bgf )&&_ffea [_ebc -1]=='.'&&_gg .IsDecimalDigit (_ffea [_ebc -2])&&_ffea [_ebc -3]=='-'&&_ffea [_ebc -4]=='F'&&_ffea [_ebc -5]=='D'&&_ffea [_ebc -6]=='P'{_fgag :=int (_ffea [_ebc -2]-'0');_dgae :=int (_bgf -'0');
return _fgag ,_dgae ,nil ;};_ffea =append (_ffea [1:_ebc ],_bgf );};return 0,0,_e .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};func (_aac *fdfParser )readComment ()(string ,error ){var _gcbf _d .Buffer ;
_ ,_ab :=_aac .skipSpaces ();if _ab !=nil {return _gcbf .String (),_ab ;};_eef :=true ;for {_ea ,_beg :=_aac ._gde .Peek (1);if _beg !=nil {_ffc .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_beg .Error ());return _gcbf .String (),_beg ;
};if _eef &&_ea [0]!='%'{return _gcbf .String (),_e .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");};_eef =false ;if (_ea [0]!='\r')&&(_ea [0]!='\n'){_bea ,_ :=_aac ._gde .ReadByte ();
_gcbf .WriteByte (_bea );}else {break ;};};return _gcbf .String (),nil ;};var _efb =_c .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");func (_afd *fdfParser )seekToEOFMarker (_gag int64 )error {_bef :=int64 (0);
_faad :=int64 (1000);for _bef < _gag {if _gag <=(_faad +_bef ){_faad =_gag -_bef ;};_ ,_gggd :=_afd ._bd .Seek (-_bef -_faad ,_b .SeekEnd );if _gggd !=nil {return _gggd ;};_fbb :=make ([]byte ,_faad );_afd ._bd .Read (_fbb );_ffc .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_fbb ));
_efba :=_fb .FindAllStringIndex (string (_fbb ),-1);if _efba !=nil {_fda :=_efba [len (_efba )-1];_ffc .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_efba );_afd ._bd .Seek (-_bef -_faad +int64 (_fda [0]),_b .SeekEnd );return nil ;};_ffc .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");
_bef +=_faad ;};_ffc .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _e .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
};