//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package pdfa provides abstraction to optimize and verify documents with respect to the PDF/A standards.
// NOTE: This implementation is in experimental development state.
// 	Keep in mind that it might change in the subsequent minor versions.
package pdfa ;import (_fc "errors";_eg "fmt";_ad "github.com/adrg/sysfont";_b "github.com/trimmer-io/go-xmp/models/dc";_ede "github.com/trimmer-io/go-xmp/models/pdf";_cb "github.com/trimmer-io/go-xmp/models/xmp_base";_cc "github.com/trimmer-io/go-xmp/models/xmp_mm";
_c "github.com/trimmer-io/go-xmp/models/xmp_rights";_df "github.com/trimmer-io/go-xmp/xmp";_ef "github.com/unidoc/unipdf/v3/common";_be "github.com/unidoc/unipdf/v3/contentstream";_cg "github.com/unidoc/unipdf/v3/core";_gf "github.com/unidoc/unipdf/v3/internal/cmap";
_eb "github.com/unidoc/unipdf/v3/internal/imageutil";_ea "github.com/unidoc/unipdf/v3/internal/timeutils";_dg "github.com/unidoc/unipdf/v3/model";_bg "github.com/unidoc/unipdf/v3/model/internal/colorprofile";_cbf "github.com/unidoc/unipdf/v3/model/internal/docutil";
_ee "github.com/unidoc/unipdf/v3/model/internal/fonts";_egf "github.com/unidoc/unipdf/v3/model/xmputil";_gb "github.com/unidoc/unipdf/v3/model/xmputil/pdfaextension";_efc "github.com/unidoc/unipdf/v3/model/xmputil/pdfaid";_g "image/color";_ed "math";_f "sort";
_d "strings";_a "time";);func _bfbda (_defae *_dg .CompliancePdfReader )(_badcd []ViolatedRule ){_fcce ,_fbfff :=_febce (_defae );if !_fbfff {return _badcd ;};_dggbf ,_fbfff :=_cg .GetDict (_fcce .Get ("\u0050\u0065\u0072m\u0073"));if !_fbfff {return _badcd ;
};_dfgab :=_dggbf .Keys ();for _ ,_ddeb :=range _dfgab {if _ddeb .String ()!="\u0055\u0052\u0033"&&_ddeb .String ()!="\u0044\u006f\u0063\u004d\u0044\u0050"{_badcd =append (_badcd ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0031","\u004e\u006f\u0020\u006b\u0065\u0079\u0073 \u006f\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0055\u0052\u0033 \u0061n\u0064\u0020\u0044\u006f\u0063\u004dD\u0050\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0065\u0072\u006d\u0069\u0073\u0073i\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u002e"));
};};return _badcd ;};

// Profile2B is the implementation of the PDF/A-2B standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile2B struct{profile2 };func _feg (_ebcc *_cbf .Document )error {_beea ,_dgaf :=_ebcc .FindCatalog ();if !_dgaf {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_dbaf ,_dgaf :=_cg .GetDict (_beea .Object .Get ("\u004e\u0061\u006de\u0073"));
if !_dgaf {return nil ;};if _dbaf .Get ("\u0041\u006c\u0074\u0065rn\u0061\u0074\u0065\u0050\u0072\u0065\u0073\u0065\u006e\u0074\u0061\u0074\u0069\u006fn\u0073")!=nil {_dbaf .Remove ("\u0041\u006c\u0074\u0065rn\u0061\u0074\u0065\u0050\u0072\u0065\u0073\u0065\u006e\u0074\u0061\u0074\u0069\u006fn\u0073");
};return nil ;};func _cde (_gbb *_cbf .Document )error {_bedd ,_abd :=_gbb .FindCatalog ();if !_abd {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_bedd .SetVersion ();return nil ;
};func _febce (_bgega *_dg .CompliancePdfReader )(*_cg .PdfObjectDictionary ,bool ){_efggg ,_gfaec :=_bgega .GetTrailer ();if _gfaec !=nil {_ef .Log .Debug ("\u0043\u0061\u006en\u006f\u0074\u0020\u0067e\u0074\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u003a\u0020\u0025\u0076",_gfaec );
return nil ,false ;};_bfef ,_bcbg :=_efggg .Get ("\u0052\u006f\u006f\u0074").(*_cg .PdfObjectReference );if !_bcbg {_ef .Log .Debug ("\u0043a\u006e\u006e\u006f\u0074 \u0066\u0069\u006e\u0064\u0020d\u006fc\u0075m\u0065\u006e\u0074\u0020\u0072\u006f\u006ft");
return nil ,false ;};_afgda ,_bcbg :=_cg .GetDict (_cg .ResolveReference (_bfef ));if !_bcbg {_ef .Log .Debug ("\u0063\u0061\u006e\u006e\u006f\u0074 \u0072\u0065\u0073\u006f\u006c\u0076\u0065\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
return nil ,false ;};return _afgda ,true ;};func _befaf (_bega *_cg .PdfObjectDictionary ,_fgbf map[*_cg .PdfObjectStream ][]byte ,_gbaef map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_faca ="\u0036.\u0033\u002e\u0033\u002d\u0033";_fbgg ="\u0041\u006cl \u0043\u004d\u0061\u0070\u0073\u0020\u0075\u0073e\u0064 \u0077i\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072m\u0069n\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020a\u006e\u0064\u0020\u0049\u0064\u0065\u006et\u0069\u0074\u0079-\u0056\u002c\u0020\u0073\u0068a\u006c\u006c \u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0074h\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u0020\u0061\u0073\u0020\u0064es\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u00205\u002e\u0036\u002e\u0034\u002e";
);var _dcaaf string ;if _ffef ,_gcad :=_cg .GetName (_bega .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_gcad {_dcaaf =_ffef .String ();};if _dcaaf !="\u0054\u0079\u0070e\u0030"{return _cd ;};_ffcb :=_bega .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _cefb ,_cfgc :=_cg .GetName (_ffcb );_cfgc {switch _cefb .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _cd ;default:return _fd (_faca ,_fbgg );};};
_eeag ,_gcbag :=_cg .GetStream (_ffcb );if !_gcbag {return _fd (_faca ,_fbgg );};_ ,_ffbc :=_cefgf (_eeag ,_fgbf ,_gbaef );if _ffbc !=nil {return _fd (_faca ,_fbgg );};return _cd ;};

// StandardName gets the name of the standard.
func (_fagc *profile1 )StandardName ()string {return _eg .Sprintf ("\u0050D\u0046\u002f\u0041\u002d\u0031\u0025s",_fagc ._eab ._ca );};func _edfb (_ace *_cbf .Document ,_cgdg int )error {for _ ,_cdd :=range _ace .Objects {_bcf ,_gge :=_cg .GetDict (_cdd );
if !_gge {continue ;};_ffaa :=_bcf .Get ("\u0054\u0079\u0070\u0065");if _ffaa ==nil {continue ;};if _dbf ,_fgc :=_cg .GetName (_ffaa );_fgc &&_dbf .String ()!="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_aea ,_bbbe :=_cg .GetName (_bcf .Get ("\u0053"));
if !_bbbe {continue ;};switch _dg .PdfActionType (*_aea ){case _dg .ActionTypeLaunch ,_dg .ActionTypeSound ,_dg .ActionTypeMovie ,_dg .ActionTypeResetForm ,_dg .ActionTypeImportData ,_dg .ActionTypeJavaScript :_bcf .Remove ("\u0053");case _dg .ActionTypeHide ,_dg .ActionTypeSetOCGState ,_dg .ActionTypeRendition ,_dg .ActionTypeTrans ,_dg .ActionTypeGoTo3DView :if _cgdg ==2{_bcf .Remove ("\u0053");
};case _dg .ActionTypeNamed :_bce ,_dgd :=_cg .GetName (_bcf .Get ("\u004e"));if !_dgd {continue ;};switch *_bce {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_bcf .Remove ("\u004e");
};};};return nil ;};func _beeb (_gfcd *_dg .CompliancePdfReader )(_fccdcg ViolatedRule ){_egffb ,_cggaf :=_febce (_gfcd );if !_cggaf {return _cd ;};_dbac ,_cggaf :=_cg .GetDict (_egffb .Get ("\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"));if !_cggaf {return _cd ;
};_cagf ,_cggaf :=_cg .GetArray (_dbac .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_cggaf {return _cd ;};for _abbfa :=0;_abbfa < _cagf .Len ();_abbfa ++{_eacedf ,_fad :=_cg .GetDict (_cagf .Get (_abbfa ));if !_fad {continue ;};if _eacedf .Get ("\u0041\u0041")!=nil {return _fd ("\u0036.\u0036\u002e\u0032\u002d\u0032","\u0041\u0020F\u0069\u0065\u006cd\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079 s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061n\u0020A\u0041\u0020\u0065\u006e\u0074\u0072y f\u006f\u0072\u0020\u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069on\u0061l\u002d\u0061\u0063\u0074i\u006fn\u0073 \u0064\u0069c\u0074\u0069on\u0061\u0072\u0079\u002e");
};};return _cd ;};type standardType struct{_fg int ;_ca string ;};

// Profile is the model.StandardImplementer enhanced by the information about the profile conformance level.
type Profile interface{_dg .StandardImplementer ;Conformance ()string ;Part ()int ;};

// ValidateStandard checks if provided input CompliancePdfReader matches rules that conforms PDF/A-2 standard.
func (_ebdc *profile2 )ValidateStandard (r *_dg .CompliancePdfReader )error {_efdb :=VerificationError {ConformanceLevel :_ebdc ._becece ._fg ,ConformanceVariant :_ebdc ._becece ._ca };if _aadc :=_cddac (r );_aadc !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_aadc );
};if _fagb :=_baf (r );_fagb !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_fagb );};if _dbecg :=_fedb (r );_dbecg !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_dbecg );};if _affd :=_bddac (r );_affd !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_affd );
};if _cfge :=_dadd (r );_cfge !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_cfge );};if _efdf :=_dggcb (r );len (_efdf )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_efdf ...);};if _geeee :=_adbac (r );len (_geeee )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_geeee ...);
};if _faad :=_gecgd (r );len (_faad )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_faad ...);};if _caedd :=_ccdac (r );_caedd !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_caedd );};if _efag :=_bfbda (r );len (_efag )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_efag ...);
};if _eeefg :=_cfecf (r );len (_eeefg )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_eeefg ...);};if _ddcff :=_faaa (r );_ddcff !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_ddcff );};if _gbda :=_ggcf (r );len (_gbda )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_gbda ...);
};if _ebfc :=_ffacc (r );len (_ebfc )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_ebfc ...);};if _edfgd :=_dgdfd (r );_edfgd !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_edfgd );};if _egfa :=_fbcge (r );len (_egfa )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_egfa ...);
};if _fagbc :=_eacgf (r );len (_fagbc )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_fagbc ...);};if _ccge :=_gaeg (r );_ccge !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_ccge );};if _dgfb :=_eaec (r );len (_dgfb )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_dgfb ...);
};if _aaed :=_edafe (r ,_ebdc ._becece );len (_aaed )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_aaed ...);};if _gaab :=_gbee (r );len (_gaab )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_gaab ...);};if _dggb :=_gaba (r );len (_dggb )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_dggb ...);
};if _aefe :=_fbbfd (r );len (_aefe )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_aefe ...);};if _abdf :=_geaab (r );_abdf !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_abdf );};if _eef :=_bagbd (r );len (_eef )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_eef ...);
};if _afbb :=_dagg (r );_afbb !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_afbb );};if _cbfg :=_cbgac (r ,_ebdc ._becece ,false );len (_cbfg )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_cbfg ...);};if _ebdc ._becece ==_cf (){if _bbfd :=_cdfb (r );
len (_bbfd )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_bbfd ...);};};if _fdgf :=_dfee (r );len (_fdgf )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_fdgf ...);};if _bea :=_dbaag (r );len (_bea )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_bea ...);
};if _adc :=_fffb (r );len (_adc )!=0{_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_adc ...);};if _caae :=_ggbfe (r );_caae !=_cd {_efdb .ViolatedRules =append (_efdb .ViolatedRules ,_caae );};if len (_efdb .ViolatedRules )> 0{_f .Slice (_efdb .ViolatedRules ,func (_aegb ,_dggc int )bool {return _efdb .ViolatedRules [_aegb ].RuleNo < _efdb .ViolatedRules [_dggc ].RuleNo ;
});return _efdb ;};return nil ;};func _gdda (_fdcd standardType ,_bdbg *_cbf .OutputIntents )error {_ebbfg ,_dcee :=_bg .NewCmykIsoCoatedV2OutputIntent (_fdcd .outputIntentSubtype ());if _dcee !=nil {return _dcee ;};if _dcee =_bdbg .Add (_ebbfg .ToPdfObject ());
_dcee !=nil {return _dcee ;};return nil ;};func _gcbb (_egcgd *_dg .CompliancePdfReader )(_ddae []ViolatedRule ){var _bbbeb ,_gfgd ,_aaaa ,_efba ,_egbg ,_ccfe bool ;_ffdff :=map[*_cg .PdfObjectStream ]struct{}{};for _ ,_cgef :=range _egcgd .GetObjectNums (){if _bbbeb &&_gfgd &&_egbg &&_aaaa &&_efba &&_ccfe {return _ddae ;
};_gabb ,_fced :=_egcgd .GetIndirectObjectByNumber (_cgef );if _fced !=nil {continue ;};_aeag ,_bdad :=_cg .GetStream (_gabb );if !_bdad {continue ;};if _ ,_bdad =_ffdff [_aeag ];_bdad {continue ;};_ffdff [_aeag ]=struct{}{};_eecf ,_bdad :=_cg .GetName (_aeag .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));
if !_bdad {continue ;};if !_efba {if _aeag .Get ("\u0052\u0065\u0066")!=nil {_ddae =append (_ddae ,_fd ("\u0036.\u0032\u002e\u0036\u002d\u0031","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e"));
_efba =true ;};};if _eecf .String ()=="\u0050\u0053"{if !_ccfe {_ddae =append (_ddae ,_fd ("\u0036.\u0032\u002e\u0037\u002d\u0031","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073."));
_ccfe =true ;continue ;};};if _eecf .String ()=="\u0046\u006f\u0072\u006d"{if _gfgd &&_aaaa &&_efba {continue ;};if !_gfgd &&_aeag .Get ("\u004f\u0050\u0049")!=nil {_ddae =append (_ddae ,_fd ("\u0036.\u0032\u002e\u0034\u002d\u0032","\u0041\u006e\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u0028\u0049\u006d\u0061\u0067\u0065\u0020\u006f\u0072\u0020\u0046\u006f\u0072\u006d\u0029\u0020\u0073\u0068\u0061\u006cl\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u004fP\u0049\u0020\u006b\u0065\u0079\u002e"));
_gfgd =true ;};if !_aaaa {if _aeag .Get ("\u0050\u0053")!=nil {_aaaa =true ;};if _adbdbf :=_aeag .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");_adbdbf !=nil &&!_aaaa {if _cbag ,_ebaf :=_cg .GetName (_adbdbf );_ebaf &&*_cbag =="\u0050\u0053"{_aaaa =true ;
};};if _aaaa {_ddae =append (_ddae ,_fd ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e"));
};};continue ;};if _eecf .String ()!="\u0049\u006d\u0061g\u0065"{continue ;};if !_bbbeb &&_aeag .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_ddae =append (_ddae ,_fd ("\u0036.\u0032\u002e\u0034\u002d\u0031","\u0041\u006e\u0020\u0049m\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
_bbbeb =true ;};if !_egbg &&_aeag .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065")!=nil {_dffag ,_eadg :=_cg .GetBool (_aeag .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));if _eadg &&bool (*_dffag ){continue ;
};_ddae =append (_ddae ,_fd ("\u0036.\u0032\u002e\u0034\u002d\u0033","\u0049\u0066 a\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0063o\u006e\u0074\u0061\u0069n\u0073\u0020\u0074\u0068e \u0049\u006et\u0065r\u0070\u006f\u006c\u0061\u0074\u0065 \u006b\u0065\u0079,\u0020\u0069t\u0073\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020b\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
_egbg =true ;};};return _ddae ;};

// Validate checks if provided input document reader matches given PDF/A profile.
func Validate (d *_dg .CompliancePdfReader ,profile Profile )error {return profile .ValidateStandard (d )};func _baf (_bbbc *_dg .CompliancePdfReader )ViolatedRule {_becb :=_bbbc .ParserMetadata ().HeaderCommentBytes ();if _becb [0]> 127&&_becb [1]> 127&&_becb [2]> 127&&_becb [3]> 127{return _cd ;
};return _fd ("\u0036.\u0031\u002e\u0032\u002d\u0032","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061\u0064\u0065\u0072\u0020\u006c\u0069\u006e\u0065\u0020\u0073\u0068\u0061\u006c\u006c b\u0065\u0020i\u006d\u006d\u0065\u0064\u0069a\u0074\u0065\u006c\u0079 \u0066\u006f\u006c\u006co\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0063\u006f\u006d\u006d\u0065n\u0074\u0020\u0063\u006f\u006e\u0073\u0069s\u0074\u0069\u006e\u0067\u0020o\u0066\u0020\u0061\u0020\u0025\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0066\u006f\u006c\u006c\u006fwe\u0064\u0020\u0062y\u0020a\u0074\u0009\u006c\u0065a\u0073\u0074\u0020f\u006f\u0075\u0072\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u002c\u0020e\u0061\u0063\u0068\u0020\u006f\u0066\u0020\u0077\u0068\u006f\u0073\u0065 \u0065\u006e\u0063\u006f\u0064e\u0064\u0020\u0062\u0079\u0074e\u0020\u0076\u0061\u006c\u0075\u0065s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u0020\u0064e\u0063\u0069\u006d\u0061\u006c \u0076\u0061\u006c\u0075\u0065\u0020\u0067\u0072\u0065\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u0032\u0037\u002e");
};func _geaff (_aadd string ,_aadda string ,_cbcb string )(string ,bool ){_fgga :=_d .Index (_aadd ,_aadda );if _fgga ==-1{return "",false ;};_fgga +=len (_aadda );_badf :=_d .Index (_aadd [_fgga :],_cbcb );if _badf ==-1{return "",false ;};_badf =_fgga +_badf ;
return _aadd [_fgga :_badf ],true ;};func _ggde (_cbfa *_cbf .Document ,_befa *_cbf .Page ,_gfad []*_cbf .Image )error {for _ ,_fffd :=range _gfad {if _fffd .SMask ==nil {continue ;};_ebca ,_cdgf :=_dg .NewXObjectImageFromStream (_fffd .Stream );if _cdgf !=nil {return _cdgf ;
};_eafe ,_cdgf :=_ebca .ToImage ();if _cdgf !=nil {return _cdgf ;};_fgec ,_cdgf :=_eafe .ToGoImage ();if _cdgf !=nil {return _cdgf ;};_ecgc ,_cdgf :=_eb .RGBAConverter .Convert (_fgec );if _cdgf !=nil {return _cdgf ;};_cgfg :=_ecgc .Base ();_gcce :=&_dg .Image {Width :int64 (_cgfg .Width ),Height :int64 (_cgfg .Height ),BitsPerComponent :int64 (_cgfg .BitsPerComponent ),ColorComponents :_cgfg .ColorComponents ,Data :_cgfg .Data };
_gcce .SetDecode (_cgfg .Decode );_gcce .SetAlpha (_cgfg .Alpha );if _cdgf =_ebca .SetImage (_gcce ,nil );_cdgf !=nil {return _cdgf ;};_ebca .SMask =_cg .MakeNull ();var _ecgb _cg .PdfObject ;_feb :=-1;for _feb ,_ecgb =range _cbfa .Objects {if _ecgb ==_fffd .SMask .Stream {break ;
};};if _feb !=-1{_cbfa .Objects =append (_cbfa .Objects [:_feb ],_cbfa .Objects [_feb +1:]...);};_fffd .SMask =nil ;_ebca .ToPdfObject ();};return nil ;};func _dgde (_gfcf *_dg .CompliancePdfReader )(_gdgef []ViolatedRule ){var _cdba ,_gad ,_eeaef ,_fgge ,_fagd ,_abcc bool ;
_edede :=func ()bool {return _cdba &&_gad &&_eeaef &&_fgge &&_fagd &&_abcc };_bdcfg :=func (_ddcc *_cg .PdfObjectDictionary )bool {if !_cdba &&_ddcc .Get ("\u0054\u0052")!=nil {_cdba =true ;_gdgef =append (_gdgef ,_fd ("\u0036.\u0032\u002e\u0038\u002d\u0031","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0054\u0052\u0020\u006b\u0065\u0079\u002e"));
};if _egcf :=_ddcc .Get ("\u0054\u0052\u0032");!_gad &&_egcf !=nil {_ccbf ,_bfdee :=_cg .GetName (_egcf );if !_bfdee ||(_bfdee &&*_ccbf !="\u0044e\u0066\u0061\u0075\u006c\u0074"){_gad =true ;_gdgef =append (_gdgef ,_fd ("\u0036.\u0032\u002e\u0038\u002d\u0032","\u0041\u006e \u0045\u0078\u0074G\u0053\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069on\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074a\u0069n\u0020\u0074\u0068\u0065\u0020\u0054R2 \u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076al\u0075e\u0020\u006f\u0074\u0068e\u0072 \u0074h\u0061\u006e \u0044\u0065fa\u0075\u006c\u0074\u002e"));
if _edede (){return true ;};};};if _dfgb :=_ddcc .Get ("\u0053\u004d\u0061s\u006b");!_eeaef &&_dfgb !=nil {_fcgc ,_dcad :=_cg .GetName (_dfgb );if !_dcad ||(_dcad &&*_fcgc !="\u004e\u006f\u006e\u0065"){_eeaef =true ;_gdgef =append (_gdgef ,_fd ("\u0036\u002e\u0034-\u0031","\u0049\u0066\u0020\u0061\u006e \u0053\u004d\u0061\u0073\u006b\u0020\u006be\u0079\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0073\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0069\u0074s\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u004e\u006f\u006ee\u002e"));
if _edede (){return true ;};};};if _cdafb :=_ddcc .Get ("\u0043\u0041");!_fagd &&_cdafb !=nil {_defge ,_aeeg :=_cg .GetNumberAsFloat (_cdafb );if _aeeg ==nil &&_defge !=1.0{_fagd =true ;_gdgef =append (_gdgef ,_fd ("\u0036\u002e\u0034-\u0035","\u0054\u0068\u0065\u0020\u0066ol\u006c\u006fw\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0073\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078t\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068a\u006c\u006c\u0020\u0068\u0061v\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0073 \u0073h\u006f\u0077\u006e\u003a\u0020\u0043\u0041 \u002d\u0020\u0031\u002e\u0030\u002e"));
if _edede (){return true ;};};};if _fgaf :=_ddcc .Get ("\u0063\u0061");!_abcc &&_fgaf !=nil {_eeagb ,_gdcdg :=_cg .GetNumberAsFloat (_fgaf );if _gdcdg ==nil &&_eeagb !=1.0{_abcc =true ;_gdgef =append (_gdgef ,_fd ("\u0036\u002e\u0034-\u0036","\u0054\u0068\u0065\u0020\u0066ol\u006c\u006fw\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0073\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078t\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068a\u006c\u006c\u0020\u0068\u0061v\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0073 \u0073h\u006f\u0077\u006e\u003a\u0020\u0063\u0061 \u002d\u0020\u0031\u002e\u0030\u002e"));
if _edede (){return true ;};};};if _aac :=_ddcc .Get ("\u0042\u004d");!_fgge &&_aac !=nil {_aefbf ,_bfdf :=_cg .GetName (_aac );if _bfdf {switch _aefbf .String (){case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065":default:_fgge =true ;
_gdgef =append (_gdgef ,_fd ("\u0036\u002e\u0034-\u0034","T\u0068\u0065\u0020\u0066\u006f\u006cl\u006f\u0077\u0069\u006e\u0067 \u006b\u0065y\u0073\u002c\u0020\u0069\u0066 \u0070res\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078\u0074\u0047S\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065 \u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0073\u0020\u0073\u0068\u006f\u0077n\u003a\u0020\u0042\u004d\u0020\u002d\u0020\u004e\u006f\u0072m\u0061\u006c\u0020\u006f\u0072\u0020\u0043\u006f\u006d\u0070\u0061t\u0069\u0062\u006c\u0065\u002e"));
if _edede (){return true ;};};};};return false ;};for _ ,_fegg :=range _gfcf .PageList {_fbef :=_fegg .Resources ;if _fbef ==nil {continue ;};if _fbef .ExtGState ==nil {continue ;};_efef ,_fgee :=_cg .GetDict (_fbef .ExtGState );if !_fgee {continue ;};
_caec :=_efef .Keys ();for _ ,_feed :=range _caec {_ccggc ,_fecbb :=_cg .GetDict (_efef .Get (_feed ));if !_fecbb {continue ;};if _bdcfg (_ccggc ){return _gdgef ;};};};for _ ,_gfde :=range _gfcf .PageList {_accda :=_gfde .Resources ;if _accda ==nil {continue ;
};_ccfae ,_bfded :=_cg .GetDict (_accda .XObject );if !_bfded {continue ;};for _ ,_cbcf :=range _ccfae .Keys (){_dagbb ,_gbecd :=_cg .GetStream (_ccfae .Get (_cbcf ));if !_gbecd {continue ;};_edcc ,_gbecd :=_cg .GetDict (_dagbb .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_gbecd {continue ;};_agacg ,_gbecd :=_cg .GetDict (_edcc .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_gbecd {continue ;};for _ ,_dcebd :=range _agacg .Keys (){_cefdd ,_gaed :=_cg .GetDict (_agacg .Get (_dcebd ));if !_gaed {continue ;
};if _bdcfg (_cefdd ){return _gdgef ;};};};};return _gdgef ;};type profile1 struct{_eab standardType ;_ceeb Profile1Options ;};func _bgbf (_eagf *_cg .PdfObjectDictionary ,_bdec map[*_cg .PdfObjectStream ][]byte ,_effg map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_fbfd ="\u0046\u006f\u0072 \u0061\u006e\u0079\u0020\u0067\u0069\u0076\u0065\u006e\u0020\u0063\u006f\u006d\u0070\u006f\u0073\u0069\u0074\u0065\u0020\u0028\u0054\u0079\u0070\u0065\u0020\u0030\u0029\u0020\u0066\u006f\u006et \u0072\u0065\u0066\u0065\u0072\u0065\u006ec\u0065\u0064 \u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006fn\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0043I\u0044\u0053y\u0073\u0074\u0065\u006d\u0049nf\u006f\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u006f\u0066\u0020i\u0074\u0073\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0061\u006e\u0064 \u0043\u004d\u0061\u0070 \u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0063\u006f\u006d\u0070\u0061\u0074i\u0062\u006c\u0065\u002e\u0020\u0049\u006e\u0020o\u0074\u0068\u0065\u0072\u0020\u0077\u006f\u0072\u0064\u0073\u002c\u0020\u0074\u0068\u0065\u0020R\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u0020a\u006e\u0064\u0020\u004fr\u0064\u0065\u0072\u0069\u006e\u0067 \u0073\u0074\u0072i\u006e\u0067\u0073\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0066\u006f\u0072 \u0074\u0068\u0061\u0074\u0020\u0066o\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u002c\u0020u\u006el\u0065ss \u0074\u0068\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006eg\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074h\u0065 \u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0069\u0073 \u0049\u0064\u0065\u006e\u0074\u0069t\u0079\u002d\u0048\u0020o\u0072\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074y\u002dV\u002e";
_geed ="\u0036.\u0033\u002e\u0033\u002d\u0031";);var _adce string ;if _gbefa ,_bgfa :=_cg .GetName (_eagf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bgfa {_adce =_gbefa .String ();};if _adce !="\u0054\u0079\u0070e\u0030"{return _cd ;};_gedc :=_eagf .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ecgce ,_accdf :=_cg .GetName (_gedc );_accdf {switch _ecgce .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _cd ;};_cbgd ,_gdeb :=_gf .LoadPredefinedCMap (_ecgce .String ());
if _gdeb !=nil {return _fd (_geed ,_fbfd );};_abbb :=_cbgd .CIDSystemInfo ();if _abbb .Ordering !=_abbb .Registry {return _fd (_geed ,_fbfd );};return _cd ;};_dbbc ,_gacf :=_cg .GetStream (_gedc );if !_gacf {return _fd (_geed ,_fbfd );};_egba ,_efee :=_cefgf (_dbbc ,_bdec ,_effg );
if _efee !=nil {return _fd (_geed ,_fbfd );};_bdgb :=_egba .CIDSystemInfo ();if _bdgb .Ordering !=_bdgb .Registry {return _fd (_geed ,_fbfd );};return _cd ;};func _babe (_aebd *_dg .CompliancePdfReader )ViolatedRule {for _ ,_deff :=range _aebd .PageList {_bfdg ,_edec :=_deff .GetContentStreams ();
if _edec !=nil {continue ;};for _ ,_efdfd :=range _bfdg {_fddf :=_be .NewContentStreamParser (_efdfd );_ ,_edec =_fddf .Parse ();if _edec !=nil {return _fd ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0031","\u0041\u0020\u0063onten\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079 \u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u0020\u006e\u006ft\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0065\u0076\u0065\u006e\u0020\u0069\u0066\u0020s\u0075\u0063\u0068\u0020\u006f\u0070\u0065r\u0061\u0074\u006f\u0072\u0073\u0020\u0061\u0072\u0065\u0020\u0062\u0072\u0061\u0063\u006b\u0065\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0074\u0068\u0065\u0020\u0042\u0058\u002f\u0045\u0058\u0020\u0063\u006f\u006d\u0070\u0061\u0074\u0069\u0062i\u006c\u0069\u0074\u0079\u0020\u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u002e");
};};};return _cd ;};func _bc ()standardType {return standardType {_fg :2,_ca :"\u0055"}};func _ggfa (_aabc *_dg .CompliancePdfReader )ViolatedRule {if _aabc .ParserMetadata ().HeaderPosition ()!=0{return _fd ("\u0036.\u0031\u002e\u0032\u002d\u0031","h\u0065\u0061\u0064\u0065\u0072\u0020\u0070\u006f\u0073\u0069\u0074\u0069\u006f\u006e\u0020\u0069\u0073\u0020n\u006f\u0074\u0020\u0061\u0074\u0020\u0074\u0068\u0065\u0020fi\u0072\u0073\u0074 \u0062y\u0074\u0065");
};return _cd ;};func _caba (_afba *_dg .CompliancePdfReader )(_gbdg []ViolatedRule ){for _ ,_aafb :=range _afba .GetObjectNums (){_fdead ,_cga :=_afba .GetIndirectObjectByNumber (_aafb );if _cga !=nil {continue ;};_bcfd ,_aace :=_cg .GetDict (_fdead );
if !_aace {continue ;};_cbef ,_aace :=_cg .GetName (_bcfd .Get ("\u0054\u0079\u0070\u0065"));if !_aace {continue ;};if _cbef .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;};_effd ,_aace :=_cg .GetBool (_bcfd .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));
if !_aace {return _gbdg ;};if bool (*_effd ){_gbdg =append (_gbdg ,_fd ("\u0036\u002e\u0039-\u0031","\u0054\u0068\u0065\u0020\u004e\u0065e\u0064\u0041\u0070\u0070\u0065a\u0072\u0061\u006e\u0063\u0065\u0073\u0020\u0066\u006c\u0061\u0067\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0069\u006e\u0074\u0065\u0072\u0061\u0063\u0074\u0069\u0076e\u0020\u0066\u006f\u0072\u006d \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u006e\u006f\u0074\u0020b\u0065\u0020\u0070\u0072\u0065se\u006e\u0074\u0020\u006f\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
};};return _gbdg ;};func _dcbb (_abee *_dg .CompliancePdfReader )ViolatedRule {for _ ,_acddf :=range _abee .PageList {_cadd :=_acddf .GetContentStreamObjs ();for _ ,_defa :=range _cadd {_defa =_cg .TraceToDirectObject (_defa );var _aggf string ;switch _dffa :=_defa .(type ){case *_cg .PdfObjectString :_aggf =_dffa .Str ();
case *_cg .PdfObjectStream :_cgdc ,_dbdb :=_cg .GetName (_cg .TraceToDirectObject (_dffa .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if _dbdb {if *_cgdc ==_cg .StreamEncodingFilterNameLZW {return _fd ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0032","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e");
};};_edcb ,_edad :=_cg .DecodeStream (_dffa );if _edad !=nil {_ef .Log .Debug ("\u0045r\u0072\u003a\u0020\u0025\u0076",_edad );continue ;};_aggf =string (_edcb );default:_ef .Log .Debug ("\u0049\u006e\u0076\u0061\u006c\u0069d\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063t\u003a\u0020\u0025\u0054",_defa );
continue ;};_bbfe :=_be .NewContentStreamParser (_aggf );_cecg ,_dceec :=_bbfe .Parse ();if _dceec !=nil {_ef .Log .Debug ("\u0049\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u0063\u006f\u006et\u0065\u006e\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d:\u0020\u0025\u0076",_dceec );
continue ;};for _ ,_ecdcc :=range *_cecg {if !(_ecdcc .Operand =="\u0042\u0049"&&len (_ecdcc .Params )==1){continue ;};_ffee ,_afaa :=_ecdcc .Params [0].(*_be .ContentStreamInlineImage );if !_afaa {continue ;};_gfdg ,_ecfg :=_ffee .GetEncoder ();if _ecfg !=nil {_ef .Log .Debug ("\u0067\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u0069\u006e\u006c\u0069\u006ee\u0020\u0069\u006d\u0061\u0067\u0065 \u0065\u006e\u0063\u006f\u0064\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065d\u003a\u0020\u0025\u0076",_ecfg );
continue ;};if _gfdg .GetFilterName ()==_cg .StreamEncodingFilterNameLZW {return _fd ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0032","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e");
};};};};return _cd ;};func _fd (_dgb string ,_bed string )ViolatedRule {return ViolatedRule {RuleNo :_dgb ,Detail :_bed }};func _ebga (_ffcg *_dg .PdfInfo ,_cffd *_egf .Document )bool {_bgac ,_adaf :=_cffd .GetPdfInfo ();if !_adaf {return false ;};if _bgac .InfoDict ==nil {return false ;
};_bbg ,_fccdb :=_dg .NewPdfInfoFromObject (_bgac .InfoDict );if _fccdb !=nil {return false ;};if _ffcg .Creator !=nil {if _bbg .Creator ==nil ||_bbg .Creator .String ()!=_ffcg .Creator .String (){return false ;};};if _ffcg .CreationDate !=nil {if _bbg .CreationDate ==nil ||!_bbg .CreationDate .ToGoTime ().Equal (_ffcg .CreationDate .ToGoTime ()){return false ;
};};if _ffcg .ModifiedDate !=nil {if _bbg .ModifiedDate ==nil ||!_bbg .ModifiedDate .ToGoTime ().Equal (_ffcg .ModifiedDate .ToGoTime ()){return false ;};};if _ffcg .Producer !=nil {if _bbg .Producer ==nil ||_bbg .Producer .String ()!=_ffcg .Producer .String (){return false ;
};};if _ffcg .Keywords !=nil {if _bbg .Keywords ==nil ||_bbg .Keywords .String ()!=_ffcg .Keywords .String (){return false ;};};if _ffcg .Trapped !=nil {if _bbg .Trapped ==nil {return false ;};switch _ffcg .Trapped .String (){case "\u0054\u0072\u0075\u0065":if _bbg .Trapped .String ()!="\u0054\u0072\u0075\u0065"{return false ;
};case "\u0046\u0061\u006cs\u0065":if _bbg .Trapped .String ()!="\u0046\u0061\u006cs\u0065"{return false ;};default:if _bbg .Trapped .String ()!="\u0046\u0061\u006cs\u0065"{return false ;};};};if _ffcg .Title !=nil {if _bbg .Title ==nil ||_bbg .Title .String ()!=_ffcg .Title .String (){return false ;
};};if _ffcg .Subject !=nil {if _bbg .Subject ==nil ||_bbg .Subject .String ()!=_ffcg .Subject .String (){return false ;};};return true ;};func _gfcaa (_fag *_cbf .Document )error {_bgb ,_afdg :=_fag .FindCatalog ();if !_afdg {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");
};if _bgb .Object .Get ("\u0052\u0065\u0071u\u0069\u0072\u0065\u006d\u0065\u006e\u0074\u0073")!=nil {_bgb .Object .Remove ("\u0052\u0065\u0071u\u0069\u0072\u0065\u006d\u0065\u006e\u0074\u0073");};return nil ;};func _eag (_gdbf *_dg .CompliancePdfReader )(_ebdb []ViolatedRule ){_faea ,_bdda :=_febce (_gdbf );
if !_bdda {return _ebdb ;};_aedd :=_fd ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u0020\u0069\u0073\u0020a\u006e \u004f\u0075\u0074\u0070\u0075\u0074\u0049n\u0074\u0065\u006e\u0074\u0020\u0064i\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0062y\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0031\u0030.4\u002c\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073 \u0069\u006e\u0063\u006c\u0075\u0064e\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0027\u0073\u0020O\u0075\u0074p\u0075\u0074I\u006e\u0074\u0065\u006e\u0074\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u0020a\u006e\u0064\u0020h\u0061\u0073\u0020\u0047\u0054\u0053\u005f\u0050\u0044\u0046\u0041\u0031\u0020\u0061\u0073 \u0074\u0068\u0065\u0020\u0076a\u006c\u0075e\u0020\u006f\u0066\u0020i\u0074\u0073 \u0053\u0020\u006b\u0065\u0079\u0020\u0061\u006e\u0064\u0020\u0061\u0020\u0076\u0061\u006c\u0069\u0064\u0020I\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006ce\u0020s\u0074\u0072\u0065\u0061\u006d \u0061\u0073\u0020\u0074h\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0074\u0073\u0020\u0044\u0065\u0073t\u004f\u0075t\u0070\u0075\u0074P\u0072\u006f\u0066\u0069\u006c\u0065 \u006b\u0065\u0079\u002e");
_cecd ,_bdda :=_cg .GetArray (_faea .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));if !_bdda {_ebdb =append (_ebdb ,_aedd );return _ebdb ;};_dcca :=_fd ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e");
if _cecd .Len ()> 1{_gcba :=map[*_cg .PdfObjectDictionary ]struct{}{};for _ccgb :=0;_ccgb < _cecd .Len ();_ccgb ++{_dgeff ,_accg :=_cg .GetDict (_cecd .Get (_ccgb ));if !_accg {_ebdb =append (_ebdb ,_aedd );return _ebdb ;};if _ccgb ==0{_gcba [_dgeff ]=struct{}{};
continue ;};if _ ,_abaf :=_gcba [_dgeff ];!_abaf {_ebdb =append (_ebdb ,_dcca );break ;};};}else if _cecd .Len ()==0{_ebdb =append (_ebdb ,_aedd );return _ebdb ;};_cafc ,_bdda :=_cg .GetDict (_cecd .Get (0));if !_bdda {_ebdb =append (_ebdb ,_aedd );return _ebdb ;
};if _caac ,_dcgc :=_cg .GetName (_cafc .Get ("\u0053"));!_dcgc ||(*_caac )!="\u0047T\u0053\u005f\u0050\u0044\u0046\u00411"{_ebdb =append (_ebdb ,_aedd );return _ebdb ;};_gbeb ,_egde :=_dg .NewPdfOutputIntentFromPdfObject (_cafc );if _egde !=nil {_ef .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u006f\u0075\u0074\u0070\u0075\u0074\u0020i\u006et\u0065\u006e\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_egde );
return _ebdb ;};_dfb ,_egde :=_bg .ParseHeader (_gbeb .DestOutputProfile );if _egde !=nil {_ef .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006c\u006f\u0072\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061d\u0065\u0072\u0020\u0066\u0061i\u006c\u0065d\u003a\u0020\u0025\u0076",_egde );
return _ebdb ;};if (_dfb .DeviceClass ==_bg .DeviceClassPRTR ||_dfb .DeviceClass ==_bg .DeviceClassMNTR )&&(_dfb .ColorSpace ==_bg .ColorSpaceRGB ||_dfb .ColorSpace ==_bg .ColorSpaceCMYK ||_dfb .ColorSpace ==_bg .ColorSpaceGRAY ){return _ebdb ;};_ebdb =append (_ebdb ,_aedd );
return _ebdb ;};func _gdcbe (_afe ,_eedg ,_aeaa ,_aced string )(string ,bool ){_eeef :=_d .Index (_afe ,_eedg );if _eeef ==-1{return "",false ;};_fcb :=_d .Index (_afe ,_aeaa );if _fcb ==-1{return "",false ;};if _fcb < _eeef {return "",false ;};return _afe [:_eeef ]+_eedg +_aced +_afe [_fcb :],true ;
};func _bcg (_afd *_cbf .Document ,_ddcf int )error {_bfg :=map[*_cg .PdfObjectStream ]struct{}{};for _ ,_bebb :=range _afd .Objects {_bgf ,_geee :=_cg .GetStream (_bebb );if !_geee {continue ;};if _ ,_geee =_bfg [_bgf ];_geee {continue ;};_bfg [_bgf ]=struct{}{};
_gff ,_geee :=_cg .GetName (_bgf .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));if !_geee {continue ;};if _bgf .Get ("\u0052\u0065\u0066")!=nil {_bgf .Remove ("\u0052\u0065\u0066");};if _gff .String ()=="\u0050\u0053"{_bgf .Remove ("\u0050\u0053");continue ;
};if _gff .String ()=="\u0046\u006f\u0072\u006d"{if _bgf .Get ("\u004f\u0050\u0049")!=nil {_bgf .Remove ("\u004f\u0050\u0049");};if _bgf .Get ("\u0050\u0053")!=nil {_bgf .Remove ("\u0050\u0053");};if _afdc :=_bgf .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");
_afdc !=nil {if _ccda ,_ffde :=_cg .GetName (_afdc );_ffde &&*_ccda =="\u0050\u0053"{_bgf .Remove ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");};};continue ;};if _gff .String ()=="\u0049\u006d\u0061g\u0065"{_adfg ,_dcb :=_cg .GetBool (_bgf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));
if _dcb &&bool (*_adfg ){_bgf .Set ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065",_cg .MakeBool (false ));};if _ddcf ==2{if _bgf .Get ("\u004f\u0050\u0049")!=nil {_bgf .Remove ("\u004f\u0050\u0049");};};if _bgf .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_bgf .Remove ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073");
};continue ;};};return nil ;};func _dgec (_aeee *_dg .CompliancePdfReader )(_aadf []ViolatedRule ){var _eefa ,_cbeba ,_ddeg ,_gcbf ,_gecf ,_dfcf ,_ebebc bool ;_bdgf :=func ()bool {return _eefa &&_cbeba &&_ddeg &&_gcbf &&_gecf &&_dfcf &&_ebebc };for _ ,_bebe :=range _aeee .PageList {if _bebe .Resources ==nil {continue ;
};_gcdcb ,_fdfe :=_cg .GetDict (_bebe .Resources .Font );if !_fdfe {continue ;};for _ ,_eegcb :=range _gcdcb .Keys (){_aaeg ,_feaga :=_cg .GetDict (_gcdcb .Get (_eegcb ));if !_feaga {if !_eefa {_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0041\u006c\u006c\u0020\u0066\u006fn\u0074\u0073\u0020\u0075\u0073e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0066\u006f\u0072m\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0073\u0020d\u0065\u0066\u0069\u006e\u0065d \u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035\u002e\u0035\u002e"));
_eefa =true ;if _bdgf (){return _aadf ;};};continue ;};if _fdbc ,_fgcf :=_cg .GetName (_aaeg .Get ("\u0054\u0079\u0070\u0065"));!_eefa &&(!_fgcf ||_fdbc .String ()!="\u0046\u006f\u006e\u0074"){_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0054\u0079\u0070e\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0029 Th\u0065\u0020\u0074\u0079\u0070\u0065\u0020\u006f\u0066 \u0050\u0044\u0046\u0020\u006fbj\u0065\u0063\u0074\u0020\u0074\u0068\u0061t\u0020\u0074\u0068\u0069s\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0064\u0065\u0073c\u0072\u0069\u0062\u0065\u0073\u003b\u0020\u006d\u0075\u0073t\u0020\u0062\u0065\u0020\u0046\u006f\u006e\u0074\u0020\u0066\u006fr\u0020\u0061\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_eefa =true ;if _bdgf (){return _aadf ;};};_dadf ,_gfda :=_dg .NewPdfFontFromPdfObject (_aaeg );if _gfda !=nil {continue ;};var _fceb string ;if _cbad ,_bade :=_cg .GetName (_aaeg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bade {_fceb =_cbad .String ();
};if !_cbeba {switch _fceb {case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0031","\u004dM\u0054\u0079\u0070\u0065\u0031","\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":default:_cbeba =true ;
_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0032","\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065d\u0029\u0020\u0054\u0068e \u0074\u0079\u0070\u0065 \u006f\u0066\u0020\u0066\u006f\u006et\u003b\u0020\u006d\u0075\u0073\u0074\u0020b\u0065\u0020\u0022\u0054\u0079\u0070\u0065\u0031\u0022\u0020f\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020f\u006f\u006e\u0074\u0073\u002c\u0020\u0022\u004d\u004d\u0054\u0079\u0070\u0065\u0031\u0022\u0020\u0066\u006f\u0072\u0020\u006d\u0075\u006c\u0074\u0069\u0070\u006c\u0065\u0020\u006da\u0073\u0074e\u0072\u0020\u0066\u006f\u006e\u0074s\u002c\u0020\u0022\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0022\u0054\u0079\u0070\u0065\u0033\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070e\u0020\u0033\u0020\u0066\u006f\u006e\u0074\u0073\u002c\u0020\"\u0054\u0079\u0070\u0065\u0030\"\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006ed\u0020\u0022\u0043\u0049\u0044\u0046\u006fn\u0074\u0054\u0079\u0070\u0065\u0030\u0022 \u006f\u0072\u0020\u0022\u0043\u0049\u0044\u0046\u006f\u006e\u0074T\u0079\u0070e\u0032\u0022\u0020\u0066\u006f\u0072\u0020\u0043\u0049\u0044\u0020\u0066\u006f\u006e\u0074\u0073\u002e"));
if _bdgf (){return _aadf ;};};};if !_ddeg {if _fceb !="\u0054\u0079\u0070e\u0033"{_dbg ,_fdgg :=_cg .GetName (_aaeg .Get ("\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074"));if !_fdgg ||_dbg .String ()==""{_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0033","B\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064)\u0020T\u0068\u0065\u0020\u0050o\u0073\u0074S\u0063\u0072\u0069\u0070\u0074\u0020\u006e\u0061\u006d\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u002e"));
_ddeg =true ;if _bdgf (){return _aadf ;};};};};if _fceb !="\u0054\u0079\u0070e\u0031"{continue ;};_eded :=_ee .IsStdFont (_ee .StdFontName (_dadf .BaseFont ()));if _eded {continue ;};_abaef ,_aggg :=_cg .GetIntVal (_aaeg .Get ("\u0046i\u0072\u0073\u0074\u0043\u0068\u0061r"));
if !_aggg &&!_gcbf {_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0034","\u0046\u0069r\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074h\u0065\u0020\u0073\u0074\u0061\u006e\u0064\u0061\u0072d\u0020\u0031\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u0029\u0020\u0054\u0068\u0065\u0020\u0066\u0069\u0072\u0073\u0074\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064e\u0020\u0064\u0065\u0066i\u006ee\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057i\u0064\u0074\u0068\u0073 \u0061r\u0072\u0061y\u002e"));
_gcbf =true ;if _bdgf (){return _aadf ;};};_ccgf ,_eaceb :=_cg .GetIntVal (_aaeg .Get ("\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072"));if !_eaceb &&!_gecf {_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0035","\u004c\u0061\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069n\u0074\u0065\u0067e\u0072 \u002d\u0020\u0028\u0052\u0065\u0071u\u0069\u0072\u0065d\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020t\u0068\u0065 s\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0031\u0034\u0020\u0066\u006f\u006ets\u0029\u0020\u0054\u0068\u0065\u0020\u006c\u0061\u0073t\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064\u0065\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057\u0069\u0064\u0074h\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u002e"));
_gecf =true ;if _bdgf (){return _aadf ;};};if !_dfcf {_fcgb ,_afefa :=_cg .GetArray (_aaeg .Get ("\u0057\u0069\u0064\u0074\u0068\u0073"));if !_afefa ||!_aggg ||!_eaceb ||_fcgb .Len ()!=_ccgf -_abaef +1{_aadf =append (_aadf ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0036","\u0057\u0069\u0064\u0074\u0068\u0073\u0020\u002d a\u0072\u0072\u0061y \u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0073\u0074a\u006e\u0064a\u0072\u0064\u00201\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u003b\u0020\u0069\u006ed\u0069\u0072\u0065\u0063\u0074\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0070\u0072\u0065\u0066e\u0072\u0072e\u0064\u0029\u0020\u0041\u006e \u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0066\u0020\u0028\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u2212 F\u0069\u0072\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u002b\u00201\u0029\u0020\u0077\u0069\u0064\u0074\u0068\u0073."));
_dfcf =true ;if _bdgf (){return _aadf ;};};};};};return _aadf ;};func _efgb (_afbf *_cbf .Document )error {for _ ,_cfdc :=range _afbf .Objects {_ebd ,_dgdf :=_cg .GetDict (_cfdc );if !_dgdf {continue ;};_efgd :=_ebd .Get ("\u0054\u0079\u0070\u0065");if _efgd ==nil {continue ;
};if _acce ,_bbff :=_cg .GetName (_efgd );_bbff &&_acce .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;};_efdg ,_gedf :=_cg .GetBool (_ebd .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));
if _gedf &&bool (*_efdg ){_ebd .Set ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073",_cg .MakeBool (false ));};if _ebd .Get ("\u0058\u0046\u0041")!=nil {_ebd .Remove ("\u0058\u0046\u0041");};};_abe ,_fggc :=_afbf .FindCatalog ();
if !_fggc {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};if _abe .Object .Get ("\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067")!=nil {_abe .Object .Remove ("\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067");
};return nil ;};func _ggbfe (_eebe *_dg .CompliancePdfReader )(_aafca ViolatedRule ){_cggdf ,_ecdaa :=_febce (_eebe );if !_ecdaa {return _cd ;};if _cggdf .Get ("\u0052\u0065\u0071u\u0069\u0072\u0065\u006d\u0065\u006e\u0074\u0073")!=nil {return _fd ("\u0036\u002e\u0031\u0031\u002d\u0031","Th\u0065\u0020d\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063a\u0074\u0061\u006c\u006f\u0067\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020R\u0065q\u0075\u0069\u0072\u0065\u006d\u0065\u006e\u0074s\u0020k\u0065\u0079.");
};return _cd ;};func _dggcb (_ceada *_dg .CompliancePdfReader )(_dgfg []ViolatedRule ){if _ceada .ParserMetadata ().HasOddLengthHexStrings (){_dgfg =append (_dgfg ,_fd ("\u0036.\u0031\u002e\u0036\u002d\u0031","\u0068\u0065\u0078a\u0064\u0065\u0063\u0069\u006d\u0061\u006c\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020\u006f\u0066\u0020e\u0076\u0065\u006e\u0020\u0073\u0069\u007a\u0065"));
};if _ceada .ParserMetadata ().HasOddLengthHexStrings (){_dgfg =append (_dgfg ,_fd ("\u0036.\u0031\u002e\u0036\u002d\u0032","\u0068\u0065\u0078\u0061\u0064\u0065\u0063\u0069\u006da\u006c\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068o\u0075\u006c\u0064\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u006f\u006e\u006c\u0079\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0073\u0020\u0066\u0072\u006f\u006d\u0020\u0072\u0061n\u0067\u0065\u0020[\u0030\u002d\u0039\u003b\u0041\u002d\u0046\u003b\u0061\u002d\u0066\u005d"));
};return _dgfg ;};func _eafc (_fdcb *_dg .CompliancePdfReader )(_aabcb ViolatedRule ){_ebef ,_ggea :=_febce (_fdcb );if !_ggea {return _cd ;};if _ebef .Get ("\u0041\u0041")!=nil {return _fd ("\u0036.\u0036\u002e\u0032\u002d\u0033","\u0054\u0068e\u0020\u0064\u006f\u0063\u0075\u006d\u0065n\u0074 \u0063\u0061\u0074a\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065n\u0074r\u0079 \u0066\u006f\u0072 \u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063\u0074i\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};return _cd ;};func _edaf (_aaac *_dg .CompliancePdfReader ,_ggca bool )(_fdcc []ViolatedRule ){var _degd ,_egab ,_edcd ,_cgbgg ,_gfgb ,_cdgb ,_adddc bool ;_bcef :=func ()bool {return _degd &&_egab &&_edcd &&_cgbgg &&_gfgb &&_cdgb &&_adddc };_aegbc ,_afce :=_afaag (_aaac );
var _decf _bg .ProfileHeader ;if _afce {_decf ,_ =_bg .ParseHeader (_aegbc .DestOutputProfile );};var _baab bool ;_fcbf :=map[_cg .PdfObject ]struct{}{};var _bcdc func (_acaa _dg .PdfColorspace )bool ;_bcdc =func (_gaag _dg .PdfColorspace )bool {switch _gbeaed :=_gaag .(type ){case *_dg .PdfColorspaceDeviceGray :if !_cdgb {if !_afce {_baab =true ;
_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0033\u002d\u0034","\u0044\u0065\u0076\u0069\u0063\u0065G\u0072\u0061\u0079\u0020\u006da\u0079\u0020\u0062\u0065\u0020\u0075s\u0065\u0064\u0020\u006f\u006el\u0079\u0020\u0069\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006ce\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020O\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u002e"));
_cdgb =true ;if _bcef (){return true ;};};};case *_dg .PdfColorspaceDeviceRGB :if !_cgbgg {if !_afce ||_decf .ColorSpace !=_bg .ColorSpaceRGB {_baab =true ;_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0033\u002d\u0032","\u0044\u0065\u0076\u0069\u0063\u0065\u0052\u0047\u0042\u0020\u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074\u0068\u0065 \u0066\u0069\u006c\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074In\u0074\u0065\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020u\u0073es\u0020a\u006e\u0020\u0052\u0047\u0042\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u002e"));
_cgbgg =true ;if _bcef (){return true ;};};};case *_dg .PdfColorspaceDeviceCMYK :if !_gfgb {if !_afce ||_decf .ColorSpace !=_bg .ColorSpaceCMYK {_baab =true ;_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0033\u002d\u0033","\u0044\u0065\u0076\u0069\u0063e\u0043\u004d\u0059\u004b \u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074h\u0065\u0020\u0066\u0069\u006ce \u0068\u0061\u0073\u0020\u0061 \u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0074\u0068a\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0061\u006e \u0043\u004d\u0059\u004b\u0020\u0063\u006f\u006c\u006f\u0072\u0020s\u0070\u0061\u0063e\u002e"));
_gfgb =true ;if _bcef (){return true ;};};};case *_dg .PdfColorspaceICCBased :if !_edcd ||!_adddc {_cecge ,_gbce :=_bg .ParseHeader (_gbeaed .Data );if _gbce !=nil {_ef .Log .Debug ("\u0070\u0061\u0072si\u006e\u0067\u0020\u0049\u0043\u0043\u0042\u0061\u0073e\u0064 \u0068e\u0061d\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_gbce );
_fdcc =append (_fdcc ,func ()ViolatedRule {return _fd ("\u0036.\u0032\u002e\u0033\u002d\u0031","\u0041\u006cl \u0049\u0043\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006f\u006co\u0072\u0020\u0073\u0070a\u0063e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0061\u0073\u0020\u0049\u0043\u0043 \u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0073 \u0061\u0073\u0020d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020R\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0034\u002e\u0035");
}());_edcd =true ;if _bcef (){return true ;};};if !_edcd {var _eccf ,_bcefg bool ;switch _cecge .DeviceClass {case _bg .DeviceClassPRTR ,_bg .DeviceClassMNTR ,_bg .DeviceClassSCNR ,_bg .DeviceClassSPAC :default:_eccf =true ;};switch _cecge .ColorSpace {case _bg .ColorSpaceRGB ,_bg .ColorSpaceCMYK ,_bg .ColorSpaceGRAY ,_bg .ColorSpaceLAB :default:_bcefg =true ;
};if _eccf ||_bcefg {_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0033\u002d\u0031","\u0041\u006cl \u0049\u0043\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006f\u006co\u0072\u0020\u0073\u0070a\u0063e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0061\u0073\u0020\u0049\u0043\u0043 \u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0073 \u0061\u0073\u0020d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020R\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0034\u002e\u0035"));
_edcd =true ;if _bcef (){return true ;};};};if !_adddc {_bagd ,_ :=_cg .GetStream (_gbeaed .GetContainingPdfObject ());if _bagd .Get ("\u004e")==nil ||(_gbeaed .N ==1&&_cecge .ColorSpace !=_bg .ColorSpaceGRAY )||(_gbeaed .N ==3&&!(_cecge .ColorSpace ==_bg .ColorSpaceRGB ||_cecge .ColorSpace ==_bg .ColorSpaceLAB ))||(_gbeaed .N ==4&&_cecge .ColorSpace !=_bg .ColorSpaceCMYK ){_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0033\u002d\u0035","\u0049\u0066\u0020a\u006e\u0020u\u006e\u0063\u0061\u006c\u0069\u0062\u0072a\u0074\u0065\u0064\u0020\u0063\u006fl\u006f\u0072 \u0073\u0070\u0061c\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u0069\u006c\u0065 \u0074\u0068\u0065\u006e \u0074\u0068\u0061\u0074 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041-\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065d\u0020\u0069\u006e\u0020\u0036\u002e\u0032\u002e\u0032\u002e"));
_adddc =true ;if _bcef (){return true ;};};};};if _gbeaed .Alternate !=nil {return _bcdc (_gbeaed .Alternate );};};return false ;};for _ ,_bfeeb :=range _aaac .GetObjectNums (){_eafg ,_acge :=_aaac .GetIndirectObjectByNumber (_bfeeb );if _acge !=nil {continue ;
};_fgd ,_fbff :=_cg .GetStream (_eafg );if !_fbff {continue ;};_agbg ,_fbff :=_cg .GetName (_fgd .Get ("\u0054\u0079\u0070\u0065"));if !_fbff ||_agbg .String ()!="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_abgag ,_fbff :=_cg .GetName (_fgd .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_fbff {continue ;};_fcbf [_fgd ]=struct{}{};switch _abgag .String (){case "\u0049\u006d\u0061g\u0065":_bgfc ,_babg :=_dg .NewXObjectImageFromStream (_fgd );if _babg !=nil {continue ;};_fcbf [_fgd ]=struct{}{};if _bcdc (_bgfc .ColorSpace ){return _fdcc ;
};case "\u0046\u006f\u0072\u006d":_agcb ,_caaee :=_cg .GetDict (_fgd .Get ("\u0047\u0072\u006fu\u0070"));if !_caaee {continue ;};_dcab :=_agcb .Get ("\u0043\u0053");if _dcab ==nil {continue ;};_ceadc ,_gceba :=_dg .NewPdfColorspaceFromPdfObject (_dcab );
if _gceba !=nil {continue ;};if _bcdc (_ceadc ){return _fdcc ;};};};for _ ,_cefd :=range _aaac .PageList {_gddad ,_abgd :=_cefd .GetContentStreams ();if _abgd !=nil {continue ;};for _ ,_fbad :=range _gddad {_abgef ,_dgfbc :=_be .NewContentStreamParser (_fbad ).Parse ();
if _dgfbc !=nil {continue ;};for _ ,_fdff :=range *_abgef {if len (_fdff .Params )> 1{continue ;};switch _fdff .Operand {case "\u0042\u0049":_ebbe ,_dgefe :=_fdff .Params [0].(*_be .ContentStreamInlineImage );if !_dgefe {continue ;};_gbbg ,_ffdf :=_ebbe .GetColorSpace (_cefd .Resources );
if _ffdf !=nil {continue ;};if _bcdc (_gbbg ){return _fdcc ;};case "\u0044\u006f":_fbdf ,_ddbe :=_cg .GetName (_fdff .Params [0]);if !_ddbe {continue ;};_aagd ,_fbafd :=_cefd .Resources .GetXObjectByName (*_fbdf );if _ ,_edfad :=_fcbf [_aagd ];_edfad {continue ;
};switch _fbafd {case _dg .XObjectTypeImage :_fdd ,_gfgbc :=_dg .NewXObjectImageFromStream (_aagd );if _gfgbc !=nil {continue ;};_fcbf [_aagd ]=struct{}{};if _bcdc (_fdd .ColorSpace ){return _fdcc ;};case _dg .XObjectTypeForm :_ffcc ,_bdeb :=_cg .GetDict (_aagd .Get ("\u0047\u0072\u006fu\u0070"));
if !_bdeb {continue ;};_defb ,_bdeb :=_cg .GetName (_ffcc .Get ("\u0043\u0053"));if !_bdeb {continue ;};_gfae ,_aaea :=_dg .NewPdfColorspaceFromPdfObject (_defb );if _aaea !=nil {continue ;};_fcbf [_aagd ]=struct{}{};if _bcdc (_gfae ){return _fdcc ;};};
};};};};if !_baab {return _fdcc ;};if (_decf .DeviceClass ==_bg .DeviceClassPRTR ||_decf .DeviceClass ==_bg .DeviceClassMNTR )&&(_decf .ColorSpace ==_bg .ColorSpaceRGB ||_decf .ColorSpace ==_bg .ColorSpaceCMYK ||_decf .ColorSpace ==_bg .ColorSpaceGRAY ){return _fdcc ;
};if !_ggca {return _fdcc ;};_cadaf ,_abae :=_febce (_aaac );if !_abae {return _fdcc ;};_gdfa ,_abae :=_cg .GetArray (_cadaf .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));if !_abae {_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u0020\u0069\u0073\u0020a\u006e \u004f\u0075\u0074\u0070\u0075\u0074\u0049n\u0074\u0065\u006e\u0074\u0020\u0064i\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0062y\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0031\u0030.4\u002c\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073 \u0069\u006e\u0063\u006c\u0075\u0064e\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0027\u0073\u0020O\u0075\u0074p\u0075\u0074I\u006e\u0074\u0065\u006e\u0074\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u0020a\u006e\u0064\u0020h\u0061\u0073\u0020\u0047\u0054\u0053\u005f\u0050\u0044\u0046\u0041\u0031\u0020\u0061\u0073 \u0074\u0068\u0065\u0020\u0076a\u006c\u0075e\u0020\u006f\u0066\u0020i\u0074\u0073 \u0053\u0020\u006b\u0065\u0079\u0020\u0061\u006e\u0064\u0020\u0061\u0020\u0076\u0061\u006c\u0069\u0064\u0020I\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006ce\u0020s\u0074\u0072\u0065\u0061\u006d \u0061\u0073\u0020\u0074h\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0074\u0073\u0020\u0044\u0065\u0073t\u004f\u0075t\u0070\u0075\u0074P\u0072\u006f\u0066\u0069\u006c\u0065 \u006b\u0065\u0079\u002e"),_fd ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e"));
return _fdcc ;};if _gdfa .Len ()> 1{_dcda :=map[*_cg .PdfObjectDictionary ]struct{}{};for _fgfe :=0;_fgfe < _gdfa .Len ();_fgfe ++{_eecd ,_agga :=_cg .GetDict (_gdfa .Get (_fgfe ));if !_agga {continue ;};if _fgfe ==0{_dcda [_eecd ]=struct{}{};continue ;
};if _ ,_bbbg :=_dcda [_eecd ];!_bbbg {_fdcc =append (_fdcc ,_fd ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e"));
break ;};};};return _fdcc ;};func _accb (_abcbb *_dg .CompliancePdfReader )(_ffae []ViolatedRule ){_defgcf :=true ;_fgde ,_aaee :=_abcbb .GetCatalogMarkInfo ();if !_aaee {_defgcf =false ;}else {_cfbdd ,_bgfcc :=_cg .GetDict (_fgde );if _bgfcc {_decfa ,_dcdc :=_cg .GetBool (_cfbdd .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));
if !bool (*_decfa )||!_dcdc {_defgcf =false ;};}else {_defgcf =false ;};};if !_defgcf {_ffae =append (_ffae ,_fd ("\u0036.\u0038\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006cog\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020M\u0061r\u006b\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061 \u004d\u0061\u0072\u006b\u0065\u0064\u0020\u0065\u006et\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074,\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0076\u0061lu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0072\u0075\u0065"));
};_fbga ,_aaee :=_abcbb .GetCatalogStructTreeRoot ();if !_aaee {_ffae =append (_ffae ,_fd ("\u0036.\u0038\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u006c\u006f\u0067\u0069\u0063\u0061\u006c\u0020\u0073\u0074\u0072\u0075\u0063\u0074\u0075r\u0065\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065d \u0062\u0079\u0020a\u0020s\u0074\u0072\u0075\u0063\u0074\u0075\u0072e\u0020\u0068\u0069\u0065\u0072\u0061\u0072\u0063\u0068\u0079\u0020\u0072\u006f\u006ft\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065\u0065\u0052\u006f\u006f\u0074\u0020\u0065\u006e\u0074r\u0079\u0020\u006f\u0066\u0020\u0074h\u0065\u0020d\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061t\u0061\u006c\u006fg \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0036\u002e"));
};_fagce ,_aaee :=_cg .GetDict (_fbga );if _aaee {_aece ,_ebbbg :=_cg .GetName (_fagce .Get ("\u0052o\u006c\u0065\u004d\u0061\u0070"));if _ebbbg {_efcfa ,_fbfe :=_cg .GetDict (_aece );if _fbfe {for _ ,_gdgec :=range _efcfa .Keys (){_fdfdg :=_efcfa .Get (_gdgec );
if _fdfdg ==nil {_ffae =append (_ffae ,_fd ("\u0036.\u0038\u002e\u0033\u002d\u0032","\u0041\u006c\u006c\u0020\u006eo\u006e\u002ds\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0073t\u0072\u0075\u0063\u0074ure\u0020\u0074\u0079\u0070\u0065s\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u006d\u0061\u0070\u0070\u0065d\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020n\u0065\u0061\u0072\u0065\u0073\u0074\u0020\u0066\u0075\u006e\u0063t\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0073\u0074a\u006ed\u0061r\u0064\u0020\u0074\u0079\u0070\u0065\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065re\u006e\u0063e\u0020\u0039\u002e\u0037\u002e\u0034\u002c\u0020i\u006e\u0020\u0074\u0068e\u0020\u0072\u006fl\u0065\u0020\u006d\u0061p \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0066 \u0074h\u0065\u0020\u0073\u0074\u0072\u0075c\u0074\u0075r\u0065\u0020\u0074\u0072e\u0065\u0020\u0072\u006f\u006ft\u002e"));
};};};};};return _ffae ;};func _ccdac (_facf *_dg .CompliancePdfReader )ViolatedRule {return _cd };func _dd (_ggf *_dg .XObjectImage ,_dfd imageModifications )error {_bbb ,_efg :=_ggf .ToImage ();if _efg !=nil {return _efg ;};if _dfd ._dag !=nil {_ggf .Filter =_dfd ._dag ;
};_dea :=_cg .MakeDict ();_dea .Set ("\u0051u\u0061\u006c\u0069\u0074\u0079",_cg .MakeInteger (100));_dea .Set ("\u0050r\u0065\u0064\u0069\u0063\u0074\u006fr",_cg .MakeInteger (1));_ggf .Decode =nil ;if _efg =_ggf .SetImage (_bbb ,nil );_efg !=nil {return _efg ;
};_ggf .ToPdfObject ();return nil ;};func (_gfd *documentImages )hasOnlyDeviceGray ()bool {return _gfd ._gc &&!_gfd ._bec &&!_gfd ._cge };func _aee (_ege *Profile1Options ){if _ege .Now ==nil {_ege .Now =_a .Now ;};};func _abea (_cgba *_dg .CompliancePdfReader )(_baae []ViolatedRule ){var (_dbbg ,_ggda ,_egfb ,_eeaee ,_cdde ,_eeeg ,_afaae bool ;
_ecaa func (_cg .PdfObject ););_ecaa =func (_cada _cg .PdfObject ){switch _beae :=_cada .(type ){case *_cg .PdfObjectInteger :if !_dbbg &&(int64 (*_beae )> _ed .MaxInt32 ||int64 (*_beae )< -_ed .MaxInt32 ){_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0031","L\u0061\u0072\u0067e\u0073\u0074\u0020\u0049\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0032\u002c\u0031\u0034\u0037,\u0034\u0038\u0033,\u0036\u0034\u0037\u002e\u0020\u0053\u006d\u0061\u006c\u006c\u0065\u0073\u0074 \u0069\u006e\u0074\u0065g\u0065\u0072\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u002d\u0032\u002c\u0031\u0034\u0037\u002c\u0034\u0038\u0033,\u0036\u0034\u0038\u002e"));
_dbbg =true ;};case *_cg .PdfObjectFloat :if !_ggda &&(_ed .Abs (float64 (*_beae ))> 32767.0){_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0032","\u0041\u0062\u0073\u006f\u006c\u0075\u0074\u0065\u0020\u0072\u0065\u0061\u006c\u0020\u0076\u0061\u006c\u0075\u0065\u0020m\u0075\u0073\u0074\u0020\u0062\u0065\u0020\u006c\u0065s\u0073\u0020\u0074\u0068\u0061\u006e\u0020\u006f\u0072\u0020\u0065\u0071\u0075a\u006c\u0020\u0074\u006f\u0020\u00332\u0037\u0036\u0037.\u0030\u002e"));
};case *_cg .PdfObjectString :if !_egfb &&len ([]byte (_beae .Str ()))> 65535{_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0033","M\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006c\u0065n\u0067\u0074\u0068\u0020\u006f\u0066\u0020a \u0073\u0074\u0072\u0069n\u0067\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074es\u0029\u0020i\u0073\u0020\u0036\u0035\u0035\u0033\u0035\u002e"));
_egfb =true ;};case *_cg .PdfObjectName :if !_eeaee &&len ([]byte (*_beae ))> 127{_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0034","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006c\u0065\u006eg\u0074\u0068\u0020\u006ff\u0020\u0061\u0020\u006e\u0061\u006d\u0065\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074\u0065\u0073\u0029\u0020\u0069\u0073\u0020\u0031\u0032\u0037\u002e"));
_eeaee =true ;};case *_cg .PdfObjectArray :if !_cdde &&_beae .Len ()> 8191{_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0035","\u004d\u0061\u0078\u0069\u006d\u0075m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u0020\u006f\u0066\u0020\u0061\u006e\u0020\u0061\u0072\u0072\u0061\u0079\u0020(\u0069\u006e\u0020\u0065\u006c\u0065\u006d\u0065\u006e\u0074\u0073\u0029\u0020\u0069s\u00208\u0031\u0039\u0031\u002e"));
_cdde =true ;};for _ ,_ebbb :=range _beae .Elements (){_ecaa (_ebbb );};if !_afaae &&(_beae .Len ()==4||_beae .Len ()==5){_ggac ,_gbdde :=_cg .GetName (_beae .Get (0));if !_gbdde {return ;};if *_ggac !="\u0044e\u0076\u0069\u0063\u0065\u004e"{return ;};
_gfgf :=_beae .Get (1);_gfgf =_cg .TraceToDirectObject (_gfgf );_gdcd ,_gbdde :=_cg .GetArray (_gfgf );if !_gbdde {return ;};if _gdcd .Len ()> 8{_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0039","\u004d\u0061\u0078i\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u004e\u0020\u0063\u006f\u006d\u0070\u006f\u006e\u0065n\u0074\u0073\u0020\u0069\u0073\u0020\u0038\u002e"));
_afaae =true ;};};case *_cg .PdfObjectDictionary :_dgc :=_beae .Keys ();if !_eeeg &&len (_dgc )> 4095{_baae =append (_baae ,_fd ("\u0036.\u0031\u002e\u0031\u0032\u002d\u00311","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u0063\u0061\u0070\u0061\u0063\u0069\u0074y\u0020\u006f\u0066\u0020\u0061\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0028\u0069\u006e\u0020\u0065\u006e\u0074\u0072\u0069es\u0029\u0020\u0069\u0073\u0020\u0034\u0030\u0039\u0035\u002e"));
_eeeg =true ;};for _abac ,_gfbgg :=range _dgc {_ecaa (&_dgc [_abac ]);_ecaa (_beae .Get (_gfbgg ));};case *_cg .PdfObjectStream :_ecaa (_beae .PdfObjectDictionary );case *_cg .PdfObjectStreams :for _ ,_cabf :=range _beae .Elements (){_ecaa (_cabf );};case *_cg .PdfObjectReference :_ecaa (_beae .Resolve ());
};};_adbc :=_cgba .GetObjectNums ();if len (_adbc )> 8388607{_baae =append (_baae ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0037","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020in\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0073 \u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u0020\u0066\u0069\u006c\u0065\u0020\u0069\u0073\u00208\u002c\u0033\u0038\u0038\u002c\u0036\u0030\u0037\u002e"));
};for _ ,_cgdgc :=range _adbc {_ebdg ,_ddag :=_cgba .GetIndirectObjectByNumber (_cgdgc );if _ddag !=nil {continue ;};_fecb :=_cg .TraceToDirectObject (_ebdg );_ecaa (_fecb );};return _baae ;};func _efgc (_fbafb *_cg .PdfObjectDictionary )ViolatedRule {const (_afac ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0032";
_faeb ="IS\u004f\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u00209\u002e\u0037\u002e\u0034\u002c\u0020\u0054\u0061\u0062\u006c\u0065\u0020\u0031\u0031\u0037\u0020\u0072\u0065\u0071\u0075\u0069\u0072\u0065\u0073\u0020\u0074\u0068a\u0074\u0020\u0061\u006c\u006c\u0020\u0065m\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0054\u0079\u0070\u0065\u0020\u0032\u0020\u0043\u0049\u0044\u0046\u006fn\u0074\u0073\u0020\u0069n\u0020t\u0068e\u0020\u0043\u0049D\u0046\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u0043\u0049\u0044\u0054\u006fG\u0049\u0044M\u0061\u0070\u0020\u0065\u006e\u0074\u0072\u0079 \u0074\u0068\u0061\u0074\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020\u0061\u0020\u0073t\u0072\u0065\u0061\u006d\u0020\u006d\u0061\u0070p\u0069\u006e\u0067 f\u0072\u006f\u006d \u0043\u0049\u0044\u0073\u0020\u0074\u006f\u0020\u0067\u006c\u0079p\u0068 \u0069\u006e\u0064\u0069c\u0065\u0073\u0020\u006fr\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u0049d\u0065\u006e\u0074\u0069\u0074\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0049\u0053\u004f\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u0020\u0039\u002e\u0037\u002e\u0034\u002c\u0020\u0054\u0061\u0062\u006c\u0065\u0020\u0031\u0031\u0037\u002e";
);var _gdbdf string ;if _dabaa ,_bcbgf :=_cg .GetName (_fbafb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bcbgf {_gdbdf =_dabaa .String ();};if _gdbdf !="\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032"{return _cd ;};if _fbafb .Get ("C\u0049\u0044\u0054\u006f\u0047\u0049\u0044\u004d\u0061\u0070")==nil {return _fd (_afac ,_faeb );
};return _cd ;};func _beb ()standardType {return standardType {_fg :1,_ca :"\u0042"}};

// DefaultProfile1Options are the default options for the Profile1.
func DefaultProfile1Options ()*Profile1Options {return &Profile1Options {Now :_a .Now ,Xmp :XmpOptions {MarshalIndent :"\u0009"}};};func _abbfe (_afbg *_dg .CompliancePdfReader )ViolatedRule {return _cd };func _fcdg (_cfb *_cbf .Document )error {for _ ,_fdb :=range _cfb .Objects {_ebbf ,_eafa :=_cg .GetDict (_fdb );
if !_eafa {continue ;};_aae :=_ebbf .Get ("\u0054\u0079\u0070\u0065");if _aae ==nil {continue ;};if _cgd ,_dafg :=_cg .GetName (_aae );_dafg &&_cgd .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;};_dfge ,_gaf :=_cg .GetBool (_ebbf .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));
if _gaf {if bool (*_dfge ){_ebbf .Set ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073",_cg .MakeBool (false ));};};_gcc :=_ebbf .Get ("\u0041");if _gcc !=nil {_ebbf .Remove ("\u0041");};_acd ,_gaf :=_cg .GetArray (_ebbf .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));
if _gaf {for _gdd :=0;_gdd < _acd .Len ();_gdd ++{_bfd ,_cab :=_cg .GetDict (_acd .Get (_gdd ));if !_cab {continue ;};if _bfd .Get ("\u0041\u0041")!=nil {_bfd .Remove ("\u0041\u0041");};};};};return nil ;};func _ffc (_ddc *_cbf .Document ,_ggfe bool )error {_egaa ,_abbf :=_ddc .GetPages ();
if !_abbf {return nil ;};for _ ,_adbd :=range _egaa {_daa ,_cegg :=_cg .GetArray (_adbd .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_cegg {continue ;};for _ ,_afa :=range _daa .Elements (){_gcg ,_fdbbc :=_cg .GetDict (_afa );if !_fdbbc {continue ;
};_daab :=_gcg .Get ("\u0043");if _daab ==nil {continue ;};_fdg ,_fdbbc :=_cg .GetArray (_daab );if !_fdbbc {continue ;};_cfbd ,_fefd :=_fdg .GetAsFloat64Slice ();if _fefd !=nil {return _fefd ;};switch _fdg .Len (){case 0,1:if _ggfe {_gcg .Set ("\u0043",_cg .MakeArrayFromIntegers ([]int {1,1,1,1}));
}else {_gcg .Set ("\u0043",_cg .MakeArrayFromIntegers ([]int {1,1,1}));};case 3:if _ggfe {_bcff ,_deae ,_ecdc ,_cgcf :=_g .RGBToCMYK (uint8 (_cfbd [0]*255),uint8 (_cfbd [1]*255),uint8 (_cfbd [2]*255));_gcg .Set ("\u0043",_cg .MakeArrayFromFloats ([]float64 {float64 (_bcff )/255,float64 (_deae )/255,float64 (_ecdc )/255,float64 (_cgcf )/255}));
};case 4:if !_ggfe {_ggad ,_gec ,_abce :=_g .CMYKToRGB (uint8 (_cfbd [0]*255),uint8 (_cfbd [1]*255),uint8 (_cfbd [2]*255),uint8 (_cfbd [3]*255));_gcg .Set ("\u0043",_cg .MakeArrayFromFloats ([]float64 {float64 (_ggad )/255,float64 (_gec )/255,float64 (_abce )/255}));
};};};};return nil ;};func _ccbb (_fed *_cbf .Document )error {_ceb :=func (_feag *_cg .PdfObjectDictionary )error {if _feag .Get ("\u0054\u0052")!=nil {_ef .Log .Debug ("\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0054\u0052\u0020\u006b\u0065\u0079");
_feag .Remove ("\u0054\u0052");};_fabg :=_feag .Get ("\u0054\u0052\u0032");if _fabg !=nil {_gfbb :=_fabg .String ();if _gfbb !="\u0044e\u0066\u0061\u0075\u006c\u0074"{_ef .Log .Debug ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074\u0065 o\u0062\u006a\u0065\u0063\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073 \u0054\u00522\u0020\u006b\u0065y\u0020\u0077\u0069\u0074\u0068\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065r\u0020\u0074ha\u006e\u0020\u0044e\u0066\u0061\u0075\u006c\u0074");
_feag .Set ("\u0054\u0052\u0032",_cg .MakeName ("\u0044e\u0066\u0061\u0075\u006c\u0074"));};};if _feag .Get ("\u0048\u0054\u0050")!=nil {_ef .Log .Debug ("\u0045\u0078\u0074\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0073\u0020\u0048\u0054P\u0020\u006b\u0065\u0079");
_feag .Remove ("\u0048\u0054\u0050");};_ffff :=_feag .Get ("\u0042\u004d");if _ffff !=nil {_bebf ,_bebbd :=_cg .GetName (_ffff );if !_bebbd {_ef .Log .Debug ("E\u0078\u0074\u0047\u0053\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0027\u0042\u004d\u0027\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u004e\u0061m\u0065");
_bebf =_cg .MakeName ("");};_dgbd :=_bebf .String ();switch _dgbd {case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065","\u004d\u0075\u006c\u0074\u0069\u0070\u006c\u0079","\u0053\u0063\u0072\u0065\u0065\u006e","\u004fv\u0065\u0072\u006c\u0061\u0079","\u0044\u0061\u0072\u006b\u0065\u006e","\u004ci\u0067\u0068\u0074\u0065\u006e","\u0043\u006f\u006c\u006f\u0072\u0044\u006f\u0064\u0067\u0065","\u0043o\u006c\u006f\u0072\u0042\u0075\u0072n","\u0048a\u0072\u0064\u004c\u0069\u0067\u0068t","\u0053o\u0066\u0074\u004c\u0069\u0067\u0068t","\u0044\u0069\u0066\u0066\u0065\u0072\u0065\u006e\u0063\u0065","\u0045x\u0063\u006c\u0075\u0073\u0069\u006fn","\u0048\u0075\u0065","\u0053\u0061\u0074\u0075\u0072\u0061\u0074\u0069\u006f\u006e","\u0043\u006f\u006co\u0072","\u004c\u0075\u006d\u0069\u006e\u006f\u0073\u0069\u0074\u0079":default:_feag .Set ("\u0042\u004d",_cg .MakeName ("\u004e\u006f\u0072\u006d\u0061\u006c"));
};};return nil ;};_aabe ,_gddf :=_fed .GetPages ();if !_gddf {return nil ;};for _ ,_cdee :=range _aabe {_edc ,_fgbe :=_cdee .GetResources ();if !_fgbe {continue ;};_ecae ,_dgab :=_cg .GetDict (_edc .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));
if !_dgab {return nil ;};_gcdg :=_ecae .Keys ();for _ ,_acecb :=range _gcdg {_dgdc ,_geaa :=_cg .GetDict (_ecae .Get (_acecb ));if !_geaa {continue ;};_gdga :=_ceb (_dgdc );if _gdga !=nil {continue ;};};};for _ ,_fgg :=range _aabe {_fbd ,_ddaa :=_fgg .GetContents ();
if !_ddaa {return nil ;};for _ ,_cbee :=range _fbd {_gbeae ,_geb :=_cbee .GetData ();if _geb !=nil {continue ;};_daga :=_be .NewContentStreamParser (string (_gbeae ));_aedee ,_geb :=_daga .Parse ();if _geb !=nil {continue ;};for _ ,_egcg :=range *_aedee {if len (_egcg .Params )==0{continue ;
};_ ,_gfba :=_cg .GetName (_egcg .Params [0]);if !_gfba {continue ;};_aaaga ,_dbaa :=_fgg .GetResourcesXObject ();if !_dbaa {continue ;};for _ ,_ecda :=range _aaaga .Keys (){_cgfd ,_eedd :=_cg .GetStream (_aaaga .Get (_ecda ));if !_eedd {continue ;};_gage ,_eedd :=_cg .GetDict (_cgfd .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_eedd {continue ;};_agf ,_eedd :=_cg .GetDict (_gage .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_eedd {continue ;};for _ ,_afcb :=range _agf .Keys (){_aebe ,_agd :=_cg .GetDict (_agf .Get (_afcb ));if !_agd {continue ;};_debed :=_ceb (_aebe );
if _debed !=nil {continue ;};};};};};};return nil ;};

// Profile2Options are the options that changes the way how optimizer may try to adapt document into PDF/A standard.
type Profile2Options struct{

// CMYKDefaultColorSpace is an option that refers PDF/A
CMYKDefaultColorSpace bool ;

// Now is a function that returns current time.
Now func ()_a .Time ;

// Xmp is the xmp options information.
Xmp XmpOptions ;};

// Conformance gets the PDF/A conformance.
func (_fdge *profile2 )Conformance ()string {return _fdge ._becece ._ca };func _fcgbg (_abbd *_dg .CompliancePdfReader )(*_cg .PdfObjectDictionary ,bool ){_baec ,_acbeg :=_febce (_abbd );if !_acbeg {return nil ,false ;};_fcff ,_acbeg :=_cg .GetArray (_baec .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));
if !_acbeg {return nil ,false ;};if _fcff .Len ()==0{return nil ,false ;};return _cg .GetDict (_fcff .Get (0));};func _gcabg (_gbgd *_dg .CompliancePdfReader )ViolatedRule {_fbaf ,_bebbe :=_gbgd .GetTrailer ();if _bebbe !=nil {_ef .Log .Debug ("\u0043\u0061\u006en\u006f\u0074\u0020\u0067e\u0074\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u003a\u0020\u0025\u0076",_bebbe );
return _cd ;};_gbae ,_ggbb :=_fbaf .Get ("\u0052\u006f\u006f\u0074").(*_cg .PdfObjectReference );if !_ggbb {_ef .Log .Debug ("\u0043a\u006e\u006e\u006f\u0074 \u0066\u0069\u006e\u0064\u0020d\u006fc\u0075m\u0065\u006e\u0074\u0020\u0072\u006f\u006ft");return _cd ;
};_bfgf ,_ggbb :=_cg .GetDict (_cg .ResolveReference (_gbae ));if !_ggbb {_ef .Log .Debug ("\u0063\u0061\u006e\u006e\u006f\u0074 \u0072\u0065\u0073\u006f\u006c\u0076\u0065\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
return _cd ;};if _bfgf .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073")!=nil {return _fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063u\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u004f\u0043\u0050\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073");
};return _cd ;};func _fbf (_bag *_cbf .Document )error {_eea ,_addda :=_bag .FindCatalog ();if !_addda {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_ ,_addda =_cg .GetDict (_eea .Object .Get ("\u0041\u0041"));
if !_addda {return nil ;};_eea .Object .Remove ("\u0041\u0041");return nil ;};

// XmpOptions are the options used by the optimization of the XMP metadata.
type XmpOptions struct{

// Copyright information.
Copyright string ;

// OriginalDocumentID is the original document identifier.
// By default, if this field is empty the value is extracted from the XMP Metadata or generated UUID.
OriginalDocumentID string ;

// DocumentID is the original document identifier.
// By default, if this field is empty the value is extracted from the XMP Metadata or generated UUID.
DocumentID string ;

// InstanceID is the original document identifier.
// By default, if this field is empty the value is set to generated UUID.
InstanceID string ;

// NewDocumentVersion is a flag that defines if a document was overwritten.
// If the new document was created this should be true. On changing given document file, and overwriting it it should be true.
NewDocumentVersion bool ;

// MarshalIndent defines marshaling indent of the XMP metadata.
MarshalIndent string ;

// MarshalPrefix defines marshaling prefix of the XMP metadata.
MarshalPrefix string ;};func (_deg *documentImages )hasUncalibratedImages ()bool {return _deg ._bec ||_deg ._cge ||_deg ._gc };func _fcca (_fdfd *_dg .CompliancePdfReader ,_gbec standardType )(_edcg []ViolatedRule ){var _gaagb ,_ddegf ,_cgfa ,_addg ,_gffb ,_bdcf ,_bbea ,_ddfg ,_daec ,_bagdf ,_gffac bool ;
_abec :=func ()bool {return _gaagb &&_ddegf &&_cgfa &&_addg &&_gffb &&_bdcf &&_bbea &&_ddfg &&_daec &&_bagdf &&_gffac ;};_bfedc :=map[*_cg .PdfObjectStream ]*_gf .CMap {};_affg :=map[*_cg .PdfObjectStream ][]byte {};_ggfbe :=map[_cg .PdfObject ]*_dg .PdfFont {};
for _ ,_gdge :=range _fdfd .GetObjectNums (){_egcd ,_fdag :=_fdfd .GetIndirectObjectByNumber (_gdge );if _fdag !=nil {continue ;};_fbee ,_ffbff :=_cg .GetDict (_egcd );if !_ffbff {continue ;};_fgbc ,_ffbff :=_cg .GetName (_fbee .Get ("\u0054\u0079\u0070\u0065"));
if !_ffbff {continue ;};if *_fgbc !="\u0046\u006f\u006e\u0074"{continue ;};_cgfc ,_fdag :=_dg .NewPdfFontFromPdfObject (_fbee );if _fdag !=nil {_ef .Log .Debug ("g\u0065\u0074\u0074\u0069\u006e\u0067 \u0066\u006f\u006e\u0074\u0020\u0066r\u006f\u006d\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020%\u0076",_fdag );
continue ;};_ggfbe [_fbee ]=_cgfc ;};for _ ,_cfef :=range _fdfd .PageList {_facb ,_cbc :=_cfef .GetContentStreams ();if _cbc !=nil {_ef .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067 \u0070\u0061\u0067\u0065\u0020\u0063o\u006e\u0074\u0065\u006e\u0074\u0020\u0073t\u0072\u0065\u0061\u006d\u0073\u0020\u0066\u0061\u0069\u006ce\u0064");
continue ;};for _ ,_dafgd :=range _facb {_ecfe :=_be .NewContentStreamParser (_dafgd );_dfgd ,_beag :=_ecfe .Parse ();if _beag !=nil {_ef .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074s\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_beag );
continue ;};var _ebea bool ;for _ ,_fbg :=range *_dfgd {if _fbg .Operand !="\u0054\u0072"{continue ;};if len (_fbg .Params )!=1{_ef .Log .Debug ("\u0069\u006e\u0076\u0061\u006ci\u0064\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0070\u0061\u0072\u0061\u006d\u0065\u0074\u0065\u0072\u0073\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054\u0072\u0027\u0020\u006f\u0070\u0065\u0072\u0061\u006e\u0064\u002c\u0020\u0065\u0078\u0070e\u0063\u0074\u0065\u0064\u0020\u0027\u0031\u0027\u0020\u0062\u0075\u0074 \u0069\u0073\u003a\u0020\u0027\u0025d\u0027",len (_fbg .Params ));
continue ;};_gbgdg ,_debg :=_cg .GetIntVal (_fbg .Params [0]);if !_debg {_ef .Log .Debug ("\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020i\u0073 \u006e\u006f\u0074\u0020\u0061\u006e\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072");
continue ;};if _gbgdg ==3{_ebea =true ;break ;};};for _ ,_efbf :=range *_dfgd {if _efbf .Operand !="\u0054\u0066"{continue ;};if len (_efbf .Params )!=2{_ef .Log .Debug ("i\u006eva\u006ci\u0064 \u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066 \u0070\u0061\u0072\u0061\u006de\u0074\u0065\u0072s\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054f\u0027\u0020\u006fper\u0061\u006e\u0064\u002c\u0020\u0065x\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0027\u0032\u0027\u0020\u0069s\u003a \u0027\u0025\u0064\u0027",len (_efbf .Params ));
continue ;};_cegb ,_egcb :=_cg .GetName (_efbf .Params [0]);if !_egcb {_ef .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a \u0054\u0066\u0020\u006f\u0070\u003d\u0025\u0073\u0020\u0047\u0065\u0074\u004ea\u006d\u0065\u0056\u0061\u006c\u0020\u0066a\u0069\u006c\u0065\u0064",_efbf );
continue ;};_dbdd ,_fbdb :=_cfef .Resources .GetFontByName (*_cegb );if !_fbdb {_ef .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");continue ;};_fafcf ,_egcb :=_cg .GetDict (_dbdd );if !_egcb {_ef .Log .Debug ("\u0066\u006f\u006e\u0074 d\u0069\u0063\u0074\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
continue ;};_dbae ,_egcb :=_ggfbe [_fafcf ];if !_egcb {var _ddfb error ;_dbae ,_ddfb =_dg .NewPdfFontFromPdfObject (_fafcf );if _ddfb !=nil {_ef .Log .Debug ("\u0067\u0065\u0074\u0074i\u006e\u0067\u0020\u0066\u006f\u006e\u0074\u0020\u0066\u0072o\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u003a \u0025\u0076",_ddfb );
continue ;};_ggfbe [_fafcf ]=_dbae ;};if !_gaagb {_dbfa :=_bgbf (_fafcf ,_affg ,_bfedc );if _dbfa !=_cd {_edcg =append (_edcg ,_dbfa );_gaagb =true ;if _abec (){return _edcg ;};};};if !_ddegf {_eabg :=_gdfe (_fafcf );if _eabg !=_cd {_edcg =append (_edcg ,_eabg );
_ddegf =true ;if _abec (){return _edcg ;};};};if !_cgfa {_cdgbe :=_befaf (_fafcf ,_affg ,_bfedc );if _cdgbe !=_cd {_edcg =append (_edcg ,_cdgbe );_cgfa =true ;if _abec (){return _edcg ;};};};if !_addg {_bbcf :=_edbde (_fafcf ,_affg ,_bfedc );if _bbcf !=_cd {_edcg =append (_edcg ,_bbcf );
_addg =true ;if _abec (){return _edcg ;};};};if !_gffb {_bcgf :=_dccg (_dbae ,_fafcf ,_ebea );if _bcgf !=_cd {_gffb =true ;_edcg =append (_edcg ,_bcgf );if _abec (){return _edcg ;};};};if !_bdcf {_abfg :=_defgc (_dbae ,_fafcf );if _abfg !=_cd {_bdcf =true ;
_edcg =append (_edcg ,_abfg );if _abec (){return _edcg ;};};};if !_bbea {_cdf :=_adcg (_dbae ,_fafcf );if _cdf !=_cd {_bbea =true ;_edcg =append (_edcg ,_cdf );if _abec (){return _edcg ;};};};if !_ddfg {_eece :=_eabb (_dbae ,_fafcf );if _eece !=_cd {_ddfg =true ;
_edcg =append (_edcg ,_eece );if _abec (){return _edcg ;};};};if !_daec {_fdaa :=_fecd (_dbae ,_fafcf );if _fdaa !=_cd {_daec =true ;_edcg =append (_edcg ,_fdaa );if _abec (){return _edcg ;};};};if !_bagdf {_egdfe :=_faae (_dbae ,_fafcf );if _egdfe !=_cd {_bagdf =true ;
_edcg =append (_edcg ,_egdfe );if _abec (){return _edcg ;};};};if !_gffac &&_gbec ._ca =="\u0041"{_abfa :=_gddb (_fafcf ,_affg ,_bfedc );if _abfa !=_cd {_gffac =true ;_edcg =append (_edcg ,_abfa );if _abec (){return _edcg ;};};};};};};return _edcg ;};func _geaab (_caecf *_dg .CompliancePdfReader )(_cddadf ViolatedRule ){_fagbe ,_ebbd :=_febce (_caecf );
if !_ebbd {return _cd ;};_cdeac ,_ebbd :=_cg .GetDict (_fagbe .Get ("\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"));if !_ebbd {return _cd ;};_fdeba ,_ebbd :=_cg .GetArray (_cdeac .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_ebbd {return _cd ;
};for _eccfg :=0;_eccfg < _fdeba .Len ();_eccfg ++{_eedgg ,_ebcfc :=_cg .GetDict (_fdeba .Get (_eccfg ));if !_ebcfc {continue ;};if _eedgg .Get ("\u0041")!=nil {return _fd ("\u0036.\u0034\u002e\u0031\u002d\u0032","\u0041\u0020\u0046\u0069\u0065\u006c\u0064\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0041 o\u0072\u0020\u0041\u0041\u0020\u006b\u0065\u0079\u0073\u002e");
};if _eedgg .Get ("\u0041\u0041")!=nil {return _fd ("\u0036.\u0034\u002e\u0031\u002d\u0032","\u0041\u0020\u0046\u0069\u0065\u006c\u0064\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0041 o\u0072\u0020\u0041\u0041\u0020\u006b\u0065\u0079\u0073\u002e");
};};return _cd ;};

// Part gets the PDF/A version level.
func (_cdb *profile2 )Part ()int {return _cdb ._becece ._fg };func _ddff (_cbb *_dg .CompliancePdfReader )(_ecdf ViolatedRule ){for _ ,_bgga :=range _cbb .GetObjectNums (){_egfcd ,_aggc :=_cbb .GetIndirectObjectByNumber (_bgga );if _aggc !=nil {continue ;
};_degdf ,_dcffb :=_cg .GetStream (_egfcd );if !_dcffb {continue ;};_daeaa ,_dcffb :=_cg .GetName (_degdf .Get ("\u0054\u0079\u0070\u0065"));if !_dcffb {continue ;};if *_daeaa !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_ddaef ,_dcffb :=_cg .GetName (_degdf .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032"));
if !_dcffb {continue ;};if *_ddaef =="\u0050\u0053"{return _fd ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};if _degdf .Get ("\u0050\u0053")!=nil {return _fd ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};};return _ecdf ;};func _fgdgg (_adcba *_dg .PdfFont ,_ebaca *_cg .PdfObjectDictionary )ViolatedRule {const (_cdac ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0036\u002d\u0033";_bfefd ="\u0041l\u006c\u0020\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072u\u0065\u0054\u0079p\u0065\u0020\u0066\u006f\u006e\u0074s\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0061\u006e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0065n\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068e\u0020\u0066\u006f\u006e\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e";
);var _gedde string ;if _gbedf ,_gagc :=_cg .GetName (_ebaca .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_gagc {_gedde =_gbedf .String ();};if _gedde !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cd ;};_gabe :=_adcba .FontDescriptor ();
_dafbe ,_effb :=_cg .GetIntVal (_gabe .Flags );if !_effb {_ef .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _fd (_cdac ,_bfefd );};_fcaa :=(uint32 (_dafbe )>>3)&1;_fabc :=_fcaa !=0;if !_fabc {return _cd ;};if _ebaca .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067")!=nil {return _fd (_cdac ,_bfefd );};return _cd ;};func _dagg (_dbaec *_dg .CompliancePdfReader )(_ebeab ViolatedRule ){_deac ,_abba :=_febce (_dbaec );
if !_abba {return _cd ;};if _deac .Get ("\u0041\u0041")!=nil {return _fd ("\u0036.\u0035\u002e\u0032\u002d\u0031","\u0054h\u0065\u0020\u0064\u006fc\u0075m\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0073\u0068\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020a\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079 \u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061c\u0074\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079\u002e");
};return _cd ;};func _dgdfd (_cdea *_dg .CompliancePdfReader )ViolatedRule {return _cd };var _ Profile =(*Profile2B )(nil );func _bddac (_dgfa *_dg .CompliancePdfReader )ViolatedRule {if _dgfa .ParserMetadata ().HasDataAfterEOF (){return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0033","\u004e\u006f\u0020\u0064\u0061ta\u0020\u0073h\u0061\u006c\u006c\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0020\u0074\u0068\u0065\u0020\u006c\u0061\u0073\u0074\u0020\u0065\u006e\u0064\u002d\u006f\u0066\u002d\u0066\u0069l\u0065\u0020\u006da\u0072\u006b\u0065\u0072\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0061 \u0073\u0069\u006e\u0067\u006ce\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c \u0065\u006ed\u002do\u0066\u002d\u006c\u0069\u006e\u0065\u0020m\u0061\u0072\u006b\u0065\u0072\u002e");
};return _cd ;};type imageInfo struct{ColorSpace _cg .PdfObjectName ;BitsPerComponent int ;ColorComponents int ;Width int ;Height int ;Stream *_cg .PdfObjectStream ;_fcg bool ;};func (_af standardType )String ()string {return _eg .Sprintf ("\u0050\u0044\u0046\u002f\u0041\u002d\u0025\u0064\u0025\u0073",_af ._fg ,_af ._ca );
};func _fdba (_acdc standardType ,_fac *_cbf .OutputIntents )error {_ffbdg ,_caf :=_bg .NewISOCoatedV2Gray1CBasOutputIntent (_acdc .outputIntentSubtype ());if _caf !=nil {return _caf ;};if _caf =_fac .Add (_ffbdg .ToPdfObject ());_caf !=nil {return _caf ;
};return nil ;};

// String gets a string representation of the violated rule.
func (_da ViolatedRule )String ()string {return _eg .Sprintf ("\u0025\u0073\u003a\u0020\u0025\u0073",_da .RuleNo ,_da .Detail );};func _faaa (_edbc *_dg .CompliancePdfReader )ViolatedRule {for _ ,_eddd :=range _edbc .PageList {_fgae ,_badfg :=_eddd .GetContentStreams ();
if _badfg !=nil {continue ;};for _ ,_bceg :=range _fgae {_ccab :=_be .NewContentStreamParser (_bceg );_ ,_badfg =_ccab .Parse ();if _badfg !=nil {return _fd ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0063onten\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079 \u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u0020\u006e\u006ft\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0065\u0076\u0065\u006e\u0020\u0069\u0066\u0020s\u0075\u0063\u0068\u0020\u006f\u0070\u0065r\u0061\u0074\u006f\u0072\u0073\u0020\u0061\u0072\u0065\u0020\u0062\u0072\u0061\u0063\u006b\u0065\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0074\u0068\u0065\u0020\u0042\u0058\u002f\u0045\u0058\u0020\u0063\u006f\u006d\u0070\u0061\u0074\u0069\u0062i\u006c\u0069\u0074\u0079\u0020\u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u002e");
};};};return _cd ;};

// NewProfile1A creates a new Profile1A with given options.
func NewProfile1A (options *Profile1Options )*Profile1A {if options ==nil {options =DefaultProfile1Options ();};_aee (options );return &Profile1A {profile1 {_ceeb :*options ,_eab :_de ()}};};func _edbde (_bedg *_cg .PdfObjectDictionary ,_ffeg map[*_cg .PdfObjectStream ][]byte ,_cgfcf map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_bgbfd ="\u0036.\u0033\u002e\u0033\u002d\u0034";
_bcaf ="\u0046\u006f\u0072\u0020\u0074\u0068\u006fs\u0065\u0020\u0043\u004d\u0061\u0070\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072e\u0020\u0065m\u0062\u0065\u0064de\u0064\u002c\u0020\u0074\u0068\u0065\u0020\u0069\u006et\u0065\u0067\u0065\u0072 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0057\u004d\u006f\u0064\u0065\u0020\u0065\u006e\u0074r\u0079\u0020i\u006e t\u0068\u0065\u0020CM\u0061\u0070\u0020\u0064\u0069\u0063\u0074\u0069o\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u0020\u0074\u006f \u0074h\u0065\u0020\u0057\u004d\u006f\u0064e\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064ed\u0020\u0043\u004d\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e";
);var _dbaad string ;if _bdce ,_dbbgf :=_cg .GetName (_bedg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_dbbgf {_dbaad =_bdce .String ();};if _dbaad !="\u0054\u0079\u0070e\u0030"{return _cd ;};_bcgc :=_bedg .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ ,_fgca :=_cg .GetName (_bcgc );_fgca {return _cd ;};_edcbe ,_dbcd :=_cg .GetStream (_bcgc );if !_dbcd {return _fd (_bgbfd ,_bcaf );};_ageee ,_acfg :=_cefgf (_edcbe ,_ffeg ,_cgfcf );if _acfg !=nil {return _fd (_bgbfd ,_bcaf );};_dbdc ,_decc :=_cg .GetIntVal (_edcbe .Get ("\u0057\u004d\u006fd\u0065"));
_ebfcf ,_fcgd :=_ageee .WMode ();if _decc &&_fcgd {if _ebfcf !=_dbdc {return _fd (_bgbfd ,_bcaf );};};if (_decc &&!_fcgd )||(!_decc &&_fcgd ){return _fd (_bgbfd ,_bcaf );};return _cd ;};func _aedf (_cbafa *_dg .CompliancePdfReader )(_acab []ViolatedRule ){var _ffffg ,_egbgg bool ;
_fcbec :=func ()bool {return _ffffg &&_egbgg };for _ ,_bbbec :=range _cbafa .GetObjectNums (){_fccde ,_gaea :=_cbafa .GetIndirectObjectByNumber (_bbbec );if _gaea !=nil {_ef .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0025\u0064\u0020fa\u0069\u006c\u0065d\u003a \u0025\u0076",_bbbec ,_gaea );
continue ;};_ffdfg ,_dcfe :=_cg .GetDict (_fccde );if !_dcfe {continue ;};_cffe ,_dcfe :=_cg .GetName (_ffdfg .Get ("\u0054\u0079\u0070\u0065"));if !_dcfe {continue ;};if *_cffe !="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_dfaf ,_dcfe :=_cg .GetName (_ffdfg .Get ("\u0053"));
if !_dcfe {if !_ffffg {_acab =append (_acab ,_fd ("\u0036.\u0036\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004c\u0061\u0075\u006e\u0063\u0068\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046o\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044\u0061\u0074\u0061\u0020\u0061\u006e\u0064 \u004a\u0061\u0076a\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020s\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e \u0041\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020th\u0065\u0020\u0064\u0065p\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020s\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u002d\u006f\u0070\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062e\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e\u0020T\u0068\u0065\u0020\u0048\u0069\u0064\u0065\u0020a\u0063\u0074\u0069\u006f\u006e \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_ffffg =true ;if _fcbec (){return _acab ;};};continue ;};switch _dg .PdfActionType (*_dfaf ){case _dg .ActionTypeLaunch ,_dg .ActionTypeSound ,_dg .ActionTypeMovie ,_dg .ActionTypeResetForm ,_dg .ActionTypeImportData ,_dg .ActionTypeJavaScript :if !_ffffg {_acab =append (_acab ,_fd ("\u0036.\u0036\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004c\u0061\u0075\u006e\u0063\u0068\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046o\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044\u0061\u0074\u0061\u0020\u0061\u006e\u0064 \u004a\u0061\u0076a\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020s\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e \u0041\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020th\u0065\u0020\u0064\u0065p\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020s\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u002d\u006f\u0070\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062e\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e\u0020T\u0068\u0065\u0020\u0048\u0069\u0064\u0065\u0020a\u0063\u0074\u0069\u006f\u006e \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_ffffg =true ;if _fcbec (){return _acab ;};};continue ;case _dg .ActionTypeNamed :if !_egbgg {_gcadd ,_bcba :=_cg .GetName (_ffdfg .Get ("\u004e"));if !_bcba {_acab =append (_acab ,_fd ("\u0036.\u0036\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_egbgg =true ;if _fcbec (){return _acab ;};continue ;};switch *_gcadd {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_acab =append (_acab ,_fd ("\u0036.\u0036\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_egbgg =true ;if _fcbec (){return _acab ;};continue ;};};};};return _acab ;};func _cddab (_gffa *_cbf .Document )error {_bba ,_eegg :=_gffa .GetPages ();if !_eegg {return nil ;};for _ ,_bbe :=range _bba {_gfeg :=_bbe .FindXObjectForms ();for _ ,_ebeb :=range _gfeg {_ggdd ,_ebed :=_cg .GetDict (_ebeb .Get ("\u0047\u0072\u006fu\u0070"));
if _ebed {if _cdcf :=_ggdd .Get ("\u0053");_cdcf !=nil {_bded ,_bbab :=_cg .GetName (_cdcf );if _bbab &&_bded .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{_ebeb .Remove ("\u0047\u0072\u006fu\u0070");};};};};_gbd ,_bbc :=_bbe .GetResourcesXObject ();
if _bbc {_dceb ,_egfd :=_cg .GetDict (_gbd .Get ("\u0047\u0072\u006fu\u0070"));if _egfd {_fec :=_dceb .Get ("\u0053");if _fec !=nil {_dcbc ,_eaae :=_cg .GetName (_fec );if _eaae &&_dcbc .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{_gbd .Remove ("\u0047\u0072\u006fu\u0070");
};};};};_ebfb ,_cgbb :=_cg .GetDict (_bbe .Object .Get ("\u0047\u0072\u006fu\u0070"));if _cgbb {_abga :=_ebfb .Get ("\u0053");if _abga !=nil {_faf ,_acbe :=_cg .GetName (_abga );if _acbe &&_faf .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{_bbe .Object .Remove ("\u0047\u0072\u006fu\u0070");
};};};};return nil ;};func (_ae *documentImages )hasOnlyDeviceRGB ()bool {return _ae ._bec &&!_ae ._cge &&!_ae ._gc };

// StandardName gets the name of the standard.
func (_aedb *profile2 )StandardName ()string {return _eg .Sprintf ("\u0050D\u0046\u002f\u0041\u002d\u0032\u0025s",_aedb ._becece ._ca );};func _bad (_gde []*_cbf .Image ,_bedb bool )error {_gea :=_cg .PdfObjectName ("\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B");
if _bedb {_gea ="\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b";};for _ ,_abg :=range _gde {if _abg .Colorspace ==_gea {continue ;};_ga ,_gbaa :=_dg .NewXObjectImageFromStream (_abg .Stream );if _gbaa !=nil {return _gbaa ;};_dab ,_gbaa :=_ga .ToImage ();
if _gbaa !=nil {return _gbaa ;};_cca ,_gbaa :=_dab .ToGoImage ();if _gbaa !=nil {return _gbaa ;};var _bac _dg .PdfColorspace ;if _bedb {_bac =_dg .NewPdfColorspaceDeviceCMYK ();_cca ,_gbaa =_eb .CMYKConverter .Convert (_cca );}else {_bac =_dg .NewPdfColorspaceDeviceRGB ();
_cca ,_gbaa =_eb .NRGBAConverter .Convert (_cca );};if _gbaa !=nil {return _gbaa ;};_dec ,_dage :=_cca .(_eb .Image );if !_dage {return _fc .New ("\u0069\u006d\u0061\u0067\u0065\u0020\u0064\u006f\u0065\u0073\u006e\u0027\u0074 \u0069\u006d\u0070\u006c\u0065\u006de\u006e\u0074\u0020\u0069\u006d\u0061\u0067\u0065\u0075\u0074\u0069\u006c\u002eI\u006d\u0061\u0067\u0065");
};_gdc :=_dec .Base ();_dgg :=&_dg .Image {Width :int64 (_gdc .Width ),Height :int64 (_gdc .Height ),BitsPerComponent :int64 (_gdc .BitsPerComponent ),ColorComponents :_gdc .ColorComponents ,Data :_gdc .Data };_dgg .SetDecode (_gdc .Decode );_dgg .SetAlpha (_gdc .Alpha );
if _gbaa =_ga .SetImage (_dgg ,_bac );_gbaa !=nil {return _gbaa ;};_ga .ToPdfObject ();_abg .ColorComponents =_gdc .ColorComponents ;_abg .Colorspace =_gea ;};return nil ;};func _de ()standardType {return standardType {_fg :1,_ca :"\u0041"}};var _ Profile =(*Profile2U )(nil );


// Profile2A is the implementation of the PDF/A-2A standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile2A struct{profile2 };func _defgc (_daagg *_dg .PdfFont ,_egcgb *_cg .PdfObjectDictionary )ViolatedRule {const (_acca ="\u0036.\u0033\u002e\u0035\u002d\u0032";_efff ="\u0046\u006f\u0072\u0020\u0061l\u006c\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074 \u0073\u0075bs\u0065\u0074\u0073 \u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065\u0064\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074he\u0020f\u006f\u006e\u0074\u0020\u0064\u0065s\u0063r\u0069\u0070\u0074o\u0072\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006ec\u006c\u0075\u0064e\u0020\u0061\u0020\u0043\u0068\u0061\u0072\u0053\u0065\u0074\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u006c\u0069\u0073\u0074\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0063\u0068\u0061\u0072a\u0063\u0074\u0065\u0072 \u006e\u0061\u006d\u0065\u0073\u0020d\u0065\u0066i\u006e\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020f\u006f\u006e\u0074\u0020s\u0075\u0062\u0073\u0065\u0074, \u0061\u0073 \u0064\u0065s\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e \u0050\u0044\u0046\u0020\u0052e\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0054\u0061\u0062\u006ce\u0020\u0035\u002e1\u0038\u002e";
);var _dbdf string ;if _fcbe ,_ddagb :=_cg .GetName (_egcgb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_ddagb {_dbdf =_fcbe .String ();};if _dbdf !="\u0054\u0079\u0070e\u0031"{return _cd ;};if _ee .IsStdFont (_ee .StdFontName (_daagg .BaseFont ())){return _cd ;
};_acaad :=_daagg .FontDescriptor ();if _acaad .CharSet ==nil {return _fd (_acca ,_efff );};return _cd ;};func _cabb (_fgadgg *_cg .PdfObjectDictionary ,_edeb map[*_cg .PdfObjectStream ][]byte ,_fdgdg map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_baacge ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0037\u002d\u0031";
_eeaefb ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006cl\u0020\u0069\u006e\u0063l\u0075\u0064e\u0020\u0061 \u0054\u006f\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0065\u006e\u0074\u0072\u0079\u0020w\u0068\u006f\u0073\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073 \u0061\u0020\u0043M\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u006d\u0061p\u0073\u0020\u0063\u0068\u0061\u0072ac\u0074\u0065\u0072\u0020\u0063\u006fd\u0065s\u0020\u0074\u006f\u0020\u0055\u006e\u0069\u0063\u006f\u0064e \u0076a\u006c\u0075\u0065\u0073,\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063r\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020P\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035.\u0039\u002c\u0020\u0075\u006e\u006ce\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006d\u0065\u0065\u0074\u0073 \u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0074\u0068\u0072\u0065\u0065\u0020\u0063\u006f\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u0073\u003a\u000a\u0020\u002d\u0020\u0066o\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u0073\u0020M\u0061\u0063\u0052o\u006d\u0061\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u004d\u0061\u0063\u0045\u0078\u0070\u0065\u0072\u0074E\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041n\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u006f\u0072\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020t\u0068\u0065\u0020\u0070\u0072\u0065d\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0056\u0020C\u004d\u0061\u0070s\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u006e\u0061\u006d\u0065\u0073\u0020a\u0072\u0065 \u0074\u0061k\u0065\u006e\u0020\u0066\u0072\u006f\u006d\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u0020\u0073\u0074\u0061n\u0064\u0061\u0072\u0064\u0020L\u0061t\u0069\u006e\u0020\u0063\u0068a\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0074\u0020\u006fr\u0020\u0074\u0068\u0065 \u0073\u0065\u0074\u0020\u006f\u0066 \u006e\u0061\u006d\u0065\u0064\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0079\u006d\u0062\u006f\u006c\u0020\u0066\u006f\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046 \u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0041\u0070\u0070\u0065\u006e\u0064\u0069\u0078 \u0044\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020w\u0068\u006f\u0073e\u0020d\u0065\u0073\u0063\u0065n\u0064\u0061\u006e\u0074 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u0047B\u0031\u002c\u0020\u0041\u0064\u006fb\u0065\u002d\u0043\u004e\u0053\u0031\u002c\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004a\u0061\u0070\u0061\u006e\u0031\u0020\u006f\u0072\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004b\u006fr\u0065\u0061\u0031\u0020\u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u006c\u006c\u0065\u0063\u0074\u0069\u006f\u006e\u0073\u002e";
);_fefgc ,_fadgg :=_cg .GetStream (_fgadgg .Get ("\u0054o\u0055\u006e\u0069\u0063\u006f\u0064e"));if _fadgg {_ ,_agaa :=_cefgf (_fefgc ,_edeb ,_fdgdg );if _agaa !=nil {return _fd (_baacge ,_eeaefb );};return _cd ;};_acad ,_fadgg :=_cg .GetName (_fgadgg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_fadgg {return _fd (_baacge ,_eeaefb );};switch _acad .String (){case "\u0054\u0079\u0070e\u0031":return _cd ;};return _fd (_baacge ,_eeaefb );};func _gaeg (_afbffd *_dg .CompliancePdfReader )(_dgded ViolatedRule ){for _ ,_cedg :=range _afbffd .GetObjectNums (){_cdef ,_faaea :=_afbffd .GetIndirectObjectByNumber (_cedg );
if _faaea !=nil {continue ;};_fdcce ,_ffdee :=_cg .GetStream (_cdef );if !_ffdee {continue ;};_bebcb ,_ffdee :=_cg .GetName (_fdcce .Get ("\u0054\u0079\u0070\u0065"));if !_ffdee {continue ;};if *_bebcb !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;
};_ ,_ffdee =_cg .GetName (_fdcce .Get ("\u004f\u0050\u0049"));if _ffdee {return _fd ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072m\u0020\u0058\u004f\u0062\u006a\u0065c\u0074\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u003a \u002d\u0020\u0074\u0068\u0065\u0020O\u0050\u0049\u0020\u006b\u0065\u0079\u003b \u002d\u0020\u0074\u0068e \u0053u\u0062\u0074\u0079\u0070\u0065\u0032 ke\u0079 \u0077\u0069t\u0068\u0020\u0061\u0020\u0076\u0061l\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u003b\u0020\u002d \u0074\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};_aacg ,_ffdee :=_cg .GetName (_fdcce .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032"));if !_ffdee {continue ;};if *_aacg =="\u0050\u0053"{return _fd ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072m\u0020\u0058\u004f\u0062\u006a\u0065c\u0074\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u003a \u002d\u0020\u0074\u0068\u0065\u0020O\u0050\u0049\u0020\u006b\u0065\u0079\u003b \u002d\u0020\u0074\u0068e \u0053u\u0062\u0074\u0079\u0070\u0065\u0032 ke\u0079 \u0077\u0069t\u0068\u0020\u0061\u0020\u0076\u0061l\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u003b\u0020\u002d \u0074\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};if _fdcce .Get ("\u0050\u0053")!=nil {return _fd ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072m\u0020\u0058\u004f\u0062\u006a\u0065c\u0074\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u003a \u002d\u0020\u0074\u0068\u0065\u0020O\u0050\u0049\u0020\u006b\u0065\u0079\u003b \u002d\u0020\u0074\u0068e \u0053u\u0062\u0074\u0079\u0070\u0065\u0032 ke\u0079 \u0077\u0069t\u0068\u0020\u0061\u0020\u0076\u0061l\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u003b\u0020\u002d \u0074\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};};return _dgded ;};func _ddb (_dfda *_dg .CompliancePdfReader )ViolatedRule {return _cd };func _eagc (_fecdb *_dg .CompliancePdfReader )ViolatedRule {for _ ,_fffc :=range _fecdb .GetObjectNums (){_gbbb ,_ebad :=_fecdb .GetIndirectObjectByNumber (_fffc );
if _ebad !=nil {continue ;};_afgd ,_cdeee :=_cg .GetStream (_gbbb );if !_cdeee {continue ;};_defgf ,_cdeee :=_cg .GetName (_afgd .Get ("\u0054\u0079\u0070\u0065"));if !_cdeee {continue ;};if *_defgf !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};
if _afgd .Get ("\u0053\u004d\u0061s\u006b")!=nil {return _fd ("\u0036\u002e\u0034-\u0032","\u0041\u006e\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e \u0053\u004d\u0061\u0073\u006b\u0020\u006b\u0065\u0079\u002e");
};};return _cd ;};func _cdfb (_fggd *_dg .CompliancePdfReader )(_edcgb []ViolatedRule ){_egbae :=true ;_affdf ,_acgee :=_fggd .GetCatalogMarkInfo ();if !_acgee {_egbae =false ;}else {_agcc ,_aecdc :=_cg .GetDict (_affdf );if _aecdc {_dcec ,_dddb :=_cg .GetBool (_agcc .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));
if !bool (*_dcec )||!_dddb {_egbae =false ;};}else {_egbae =false ;};};if !_egbae {_edcgb =append (_edcgb ,_fd ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006cog\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020M\u0061r\u006b\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061 \u004d\u0061\u0072\u006b\u0065\u0064\u0020\u0065\u006et\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074,\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0076\u0061lu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0072\u0075\u0065"));
};_eacc ,_acgee :=_fggd .GetCatalogStructTreeRoot ();if !_acgee {_edcgb =append (_edcgb ,_fd ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u006c\u006f\u0067\u0069\u0063\u0061\u006c\u0020\u0073\u0074\u0072\u0075\u0063\u0074\u0075r\u0065\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065d \u0062\u0079\u0020a\u0020s\u0074\u0072\u0075\u0063\u0074\u0075\u0072e\u0020\u0068\u0069\u0065\u0072\u0061\u0072\u0063\u0068\u0079\u0020\u0072\u006f\u006ft\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065\u0065\u0052\u006f\u006f\u0074\u0020\u0065\u006e\u0074r\u0079\u0020\u006f\u0066\u0020\u0074h\u0065\u0020d\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061t\u0061\u006c\u006fg \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0036\u002e"));
};_edfed ,_acgee :=_cg .GetDict (_eacc );if _acgee {_aege ,_ggbf :=_cg .GetName (_edfed .Get ("\u0052o\u006c\u0065\u004d\u0061\u0070"));if _ggbf {_ceadcg ,_badg :=_cg .GetDict (_aege );if _badg {for _ ,_ccef :=range _ceadcg .Keys (){_dbcc :=_ceadcg .Get (_ccef );
if _dbcc ==nil {_edcgb =append (_edcgb ,_fd ("\u0036.\u0037\u002e\u0033\u002d\u0032","\u0041\u006c\u006c\u0020\u006eo\u006e\u002ds\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0073t\u0072\u0075\u0063\u0074ure\u0020\u0074\u0079\u0070\u0065s\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u006d\u0061\u0070\u0070\u0065d\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020n\u0065\u0061\u0072\u0065\u0073\u0074\u0020\u0066\u0075\u006e\u0063t\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0073\u0074a\u006ed\u0061r\u0064\u0020\u0074\u0079\u0070\u0065\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065re\u006e\u0063e\u0020\u0039\u002e\u0037\u002e\u0034\u002c\u0020i\u006e\u0020\u0074\u0068e\u0020\u0072\u006fl\u0065\u0020\u006d\u0061p \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0066 \u0074h\u0065\u0020\u0073\u0074\u0072\u0075c\u0074\u0075r\u0065\u0020\u0074\u0072e\u0065\u0020\u0072\u006f\u006ft\u002e"));
};};};};};return _edcgb ;};func _bdd (_eba *_cbf .Document ,_fccd func ()_a .Time )error {_gfg ,_bdfc :=_dg .NewPdfInfoFromObject (_eba .Info );if _bdfc !=nil {return _bdfc ;};if _gdab :=_gecg (_gfg ,_fccd );_gdab !=nil {return _gdab ;};_eba .Info =_gfg .ToPdfObject ();
return nil ;};func _fedb (_dbbcg *_dg .CompliancePdfReader )ViolatedRule {_dccae ,_bebfc :=_dbbcg .PdfReader .GetTrailer ();if _bebfc !=nil {return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u006d\u0069\u0073s\u0069\u006e\u0067\u0020t\u0072\u0061\u0069\u006c\u0065\u0072\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074");
};if _dccae .Get ("\u0049\u0044")==nil {return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e\u0020\u0027\u0049\u0044\u0027\u0020k\u0065\u0079\u0077o\u0072\u0064");
};if _dccae .Get ("\u0045n\u0063\u0072\u0079\u0070\u0074")!=nil {return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0032","\u0054\u0068\u0065\u0020\u006b\u0065y\u0077\u006f\u0072\u0064\u0020'\u0045\u006e\u0063\u0072\u0079\u0070t\u0027\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0075\u0073\u0065d\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u002e\u0020");
};return _cd ;};func _degg (_ccf *_cbf .Document ,_ade int ){if _ccf .Version .Major ==0{_ccf .Version .Major =1;};if _ccf .Version .Minor < _ade {_ccf .Version .Minor =_ade ;};};func _adcg (_deeg *_dg .PdfFont ,_bbfdg *_cg .PdfObjectDictionary )ViolatedRule {const (_eedgc ="\u0036.\u0033\u002e\u0035\u002d\u0033";
_feff ="\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0073\u0075\u0062\u0073\u0065\u0074\u0073 \u0072e\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0064\u0020\u0077i\u0074\u0068\u0069n\u0020\u0061\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069l\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006et\u0020\u0064\u0065s\u0063\u0072\u0069\u0070\u0074\u006f\u0072\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020\u0043\u0049\u0044\u0053\u0065\u0074\u0020s\u0074\u0072\u0065\u0061\u006d\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0066\u0079\u0069\u006eg\u0020\u0077\u0068i\u0063\u0068\u0020\u0043\u0049\u0044\u0073 \u0061\u0072e\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e \u0074\u0068\u0065\u0020\u0065\u006d\u0062\u0065\u0064d\u0065\u0064\u0020\u0043\u0049D\u0046\u006f\u006e\u0074\u0020\u0066\u0069l\u0065,\u0020\u0061\u0073 \u0064\u0065\u0073\u0063\u0072\u0069b\u0065\u0064 \u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063e\u0020\u0054ab\u006c\u0065\u0020\u0035.\u00320\u002e";
);var _ddbg string ;if _cgdcg ,_efcf :=_cg .GetName (_bbfdg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_efcf {_ddbg =_cgdcg .String ();};switch _ddbg {case "\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":_eeb :=_deeg .FontDescriptor ();
if _eeb .CIDSet ==nil {return _fd (_eedgc ,_feff );};return _cd ;default:return _cd ;};};func _ccad (_agdd *_dg .CompliancePdfReader )(_eafd []ViolatedRule ){_cddad :=_agdd .GetObjectNums ();for _ ,_cebd :=range _cddad {_edfag ,_badc :=_agdd .GetIndirectObjectByNumber (_cebd );
if _badc !=nil {continue ;};_bccf ,_dagcc :=_cg .GetDict (_edfag );if !_dagcc {continue ;};_fgef ,_dagcc :=_cg .GetName (_bccf .Get ("\u0054\u0079\u0070\u0065"));if !_dagcc {continue ;};if _fgef .String ()!="\u0046\u0069\u006c\u0065\u0073\u0070\u0065\u0063"{continue ;
};if _bccf .Get ("\u0045\u0046")!=nil {_eafd =append (_eafd ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0031\u002d\u0031","\u0041 \u0066\u0069\u006c\u0065 \u0073p\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066i\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046 \u0033\u002e\u0031\u0030\u002e\u0032\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0045\u0046 \u006be\u0079\u002e"));
break ;};};_aafd ,_aedab :=_febce (_agdd );if !_aedab {return _eafd ;};_fbcd ,_aedab :=_cg .GetDict (_aafd .Get ("\u004e\u0061\u006de\u0073"));if !_aedab {return _eafd ;};if _fbcd .Get ("\u0045\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0046\u0069\u006c\u0065\u0073")!=nil {_eafd =append (_eafd ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0031\u002d\u0032","\u0041\u0020\u0066i\u006c\u0065\u0027\u0073\u0020\u006e\u0061\u006d\u0065\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020d\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020PD\u0046 \u0052\u0065\u0066er\u0065\u006e\u0063\u0065\u0020\u0033\u002e6\u002e\u0033\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0045m\u0062\u0065\u0064\u0064\u0065\u0064\u0046i\u006c\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
};return _eafd ;};func _agbd (_dde *_cbf .Document )error {_gae ,_gddfe :=_dde .GetPages ();if !_gddfe {return nil ;};for _ ,_ddf :=range _gae {_beed ,_agde :=_cg .GetArray (_ddf .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_agde {continue ;
};for _ ,_dcba :=range _beed .Elements (){_dcba =_cg .ResolveReference (_dcba );if _ ,_afde :=_dcba .(*_cg .PdfObjectNull );_afde {continue ;};_geaae ,_gfega :=_cg .GetDict (_dcba );if !_gfega {continue ;};_cfbg ,_ :=_cg .GetIntVal (_geaae .Get ("\u0046"));
_cfbg &=^(1<<0);_cfbg &=^(1<<1);_cfbg &=^(1<<5);_cfbg &=^(1<<8);_cfbg |=1<<2;_geaae .Set ("\u0046",_cg .MakeInteger (int64 (_cfbg )));_bgag :=false ;if _agfd :=_geaae .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065");_agfd !=nil {_fbba ,_abca :=_cg .GetName (_agfd );
if _abca &&_fbba .String ()=="\u0057\u0069\u0064\u0067\u0065\u0074"{_bgag =true ;if _geaae .Get ("\u0041\u0041")!=nil {_geaae .Remove ("\u0041\u0041");};if _geaae .Get ("\u0041")!=nil {_geaae .Remove ("\u0041");};};if _abca &&_fbba .String ()=="\u0054\u0065\u0078\u0074"{_ffbe ,_ :=_cg .GetIntVal (_geaae .Get ("\u0046"));
_ffbe |=1<<3;_ffbe |=1<<4;_geaae .Set ("\u0046",_cg .MakeInteger (int64 (_ffbe )));};};_ggba ,_gfega :=_cg .GetDict (_geaae .Get ("\u0041\u0050"));if _gfega {_bggb :=_ggba .Get ("\u004e");if _bggb ==nil {continue ;};if len (_ggba .Keys ())> 1{_ggba .Clear ();
_ggba .Set ("\u004e",_bggb );};if _bgag {_fffa ,_fgab :=_cg .GetName (_geaae .Get ("\u0046\u0054"));if _fgab &&*_fffa =="\u0042\u0074\u006e"{continue ;};};};};};return nil ;};func _cddac (_fecgc *_dg .CompliancePdfReader )ViolatedRule {if _fecgc .ParserMetadata ().HeaderPosition ()!=0{return _fd ("\u0036.\u0031\u002e\u0032\u002d\u0031","h\u0065\u0061\u0064\u0065\u0072\u0020\u0070\u006f\u0073\u0069\u0074\u0069\u006f\u006e\u0020\u0069\u0073\u0020n\u006f\u0074\u0020\u0061\u0074\u0020\u0074\u0068\u0065\u0020fi\u0072\u0073\u0074 \u0062y\u0074\u0065");
};if _fecgc .PdfVersion ().Major !=1{return _fd ("\u0036.\u0031\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069l\u0065\u0020\u0068\u0065\u0061\u0064e\u0072 \u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0073\u0069s\u0074 \u006f\u0066\u0020\u201c%\u0050\u0044\u0046\u002d\u0031\u002e\u006e\u201d\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065 \u0045\u004f\u004c\u0020ma\u0072\u006b\u0065\u0072\u002c \u0077\u0068\u0065\u0072\u0065\u0020\u0027\u006e\u0027\u0020\u0069s\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065\u0020\u0064\u0069\u0067\u0069t\u0020\u006e\u0075\u006d\u0062e\u0072\u0020\u0062\u0065\u0074\u0077\u0065\u0065\u006e\u0020\u0030\u0020(\u0033\u0030h\u0029\u0020\u0061\u006e\u0064\u0020\u0037\u0020\u0028\u0033\u0037\u0068\u0029");
};if _fecgc .PdfVersion ().Minor < 0||_fecgc .PdfVersion ().Minor > 7{return _fd ("\u0036.\u0031\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069l\u0065\u0020\u0068\u0065\u0061\u0064e\u0072 \u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0073\u0069s\u0074 \u006f\u0066\u0020\u201c%\u0050\u0044\u0046\u002d\u0031\u002e\u006e\u201d\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065 \u0045\u004f\u004c\u0020ma\u0072\u006b\u0065\u0072\u002c \u0077\u0068\u0065\u0072\u0065\u0020\u0027\u006e\u0027\u0020\u0069s\u0020\u0061\u0020\u0073\u0069\u006e\u0067\u006c\u0065\u0020\u0064\u0069\u0067\u0069t\u0020\u006e\u0075\u006d\u0062e\u0072\u0020\u0062\u0065\u0074\u0077\u0065\u0065\u006e\u0020\u0030\u0020(\u0033\u0030h\u0029\u0020\u0061\u006e\u0064\u0020\u0037\u0020\u0028\u0033\u0037\u0068\u0029");
};return _cd ;};func _eaec (_ceee *_dg .CompliancePdfReader )(_gceg []ViolatedRule ){var _cbfab ,_bcdgf ,_eebf ,_abeg ,_fbafg ,_faff bool ;_eafb :=func ()bool {return _cbfab &&_bcdgf &&_eebf &&_abeg &&_fbafg &&_faff };for _ ,_ebgfc :=range _ceee .PageList {if _ebgfc .Resources ==nil {continue ;
};_cbgab ,_adadc :=_cg .GetDict (_ebgfc .Resources .Font );if !_adadc {continue ;};for _ ,_baadg :=range _cbgab .Keys (){_aaege ,_eeff :=_cg .GetDict (_cbgab .Get (_baadg ));if !_eeff {if !_cbfab {_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0031","\u0041\u006c\u006c\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006e\u0064\u0020\u0066on\u0074 \u0070\u0072\u006fg\u0072\u0061\u006ds\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072mi\u006e\u0067\u0020\u0066\u0069\u006ce\u002c\u0020\u0072\u0065\u0067\u0061\u0072\u0064\u006c\u0065s\u0073\u0020\u006f\u0066\u0020\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006eg m\u006f\u0064\u0065\u0020\u0075\u0073\u0061\u0067\u0065\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0074\u0068e\u0020\u0070\u0072o\u0076\u0069\u0073\u0069\u006f\u006e\u0073\u0020\u0069\u006e \u0049\u0053\u004f\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031:\u0032\u0030\u0030\u0038\u002c \u0039\u002e\u0036\u0020a\u006e\u0064\u0020\u0039.\u0037\u002e"));
_cbfab =true ;if _eafb (){return _gceg ;};};continue ;};if _aacga ,_cgcfd :=_cg .GetName (_aaege .Get ("\u0054\u0079\u0070\u0065"));!_cbfab &&(!_cgcfd ||_aacga .String ()!="\u0046\u006f\u006e\u0074"){_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0031","\u0054\u0079\u0070e\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0029 Th\u0065\u0020\u0074\u0079\u0070\u0065\u0020\u006f\u0066 \u0050\u0044\u0046\u0020\u006fbj\u0065\u0063\u0074\u0020\u0074\u0068\u0061t\u0020\u0074\u0068\u0069s\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0064\u0065\u0073c\u0072\u0069\u0062\u0065\u0073\u003b\u0020\u006d\u0075\u0073t\u0020\u0062\u0065\u0020\u0046\u006f\u006e\u0074\u0020\u0066\u006fr\u0020\u0061\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_cbfab =true ;if _eafb (){return _gceg ;};};_ddcd ,_gbbc :=_dg .NewPdfFontFromPdfObject (_aaege );if _gbbc !=nil {continue ;};var _ccbec string ;if _daaeg ,_fafe :=_cg .GetName (_aaege .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_fafe {_ccbec =_daaeg .String ();
};if !_bcdgf {switch _ccbec {case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0031","\u004dM\u0054\u0079\u0070\u0065\u0031","\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":default:_bcdgf =true ;
_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0032","\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065d\u0029\u0020\u0054\u0068e \u0074\u0079\u0070\u0065 \u006f\u0066\u0020\u0066\u006f\u006et\u003b\u0020\u006d\u0075\u0073\u0074\u0020b\u0065\u0020\u0022\u0054\u0079\u0070\u0065\u0031\u0022\u0020f\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020f\u006f\u006e\u0074\u0073\u002c\u0020\u0022\u004d\u004d\u0054\u0079\u0070\u0065\u0031\u0022\u0020\u0066\u006f\u0072\u0020\u006d\u0075\u006c\u0074\u0069\u0070\u006c\u0065\u0020\u006da\u0073\u0074e\u0072\u0020\u0066\u006f\u006e\u0074s\u002c\u0020\u0022\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0022\u0054\u0079\u0070\u0065\u0033\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070e\u0020\u0033\u0020\u0066\u006f\u006e\u0074\u0073\u002c\u0020\"\u0054\u0079\u0070\u0065\u0030\"\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006ed\u0020\u0022\u0043\u0049\u0044\u0046\u006fn\u0074\u0054\u0079\u0070\u0065\u0030\u0022 \u006f\u0072\u0020\u0022\u0043\u0049\u0044\u0046\u006f\u006e\u0074T\u0079\u0070e\u0032\u0022\u0020\u0066\u006f\u0072\u0020\u0043\u0049\u0044\u0020\u0066\u006f\u006e\u0074\u0073\u002e"));
if _eafb (){return _gceg ;};};};if !_eebf {if _ccbec !="\u0054\u0079\u0070e\u0033"{_gadab ,_bbga :=_cg .GetName (_aaege .Get ("\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074"));if !_bbga ||_gadab .String ()==""{_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0033","B\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064)\u0020T\u0068\u0065\u0020\u0050o\u0073\u0074S\u0063\u0072\u0069\u0070\u0074\u0020\u006e\u0061\u006d\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u002e"));
_eebf =true ;if _eafb (){return _gceg ;};};};};if _ccbec !="\u0054\u0079\u0070e\u0031"{continue ;};_addae :=_ee .IsStdFont (_ee .StdFontName (_ddcd .BaseFont ()));if _addae {continue ;};_fdagf ,_gbdfe :=_cg .GetIntVal (_aaege .Get ("\u0046i\u0072\u0073\u0074\u0043\u0068\u0061r"));
if !_gbdfe &&!_abeg {_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0034","\u0046\u0069r\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074h\u0065\u0020\u0073\u0074\u0061\u006e\u0064\u0061\u0072d\u0020\u0031\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u0029\u0020\u0054\u0068\u0065\u0020\u0066\u0069\u0072\u0073\u0074\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064e\u0020\u0064\u0065\u0066i\u006ee\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057i\u0064\u0074\u0068\u0073 \u0061r\u0072\u0061y\u002e"));
_abeg =true ;if _eafb (){return _gceg ;};};_ccbbe ,_ageb :=_cg .GetIntVal (_aaege .Get ("\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072"));if !_ageb &&!_fbafg {_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0035","\u004c\u0061\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069n\u0074\u0065\u0067e\u0072 \u002d\u0020\u0028\u0052\u0065\u0071u\u0069\u0072\u0065d\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020t\u0068\u0065 s\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0031\u0034\u0020\u0066\u006f\u006ets\u0029\u0020\u0054\u0068\u0065\u0020\u006c\u0061\u0073t\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064\u0065\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057\u0069\u0064\u0074h\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u002e"));
_fbafg =true ;if _eafb (){return _gceg ;};};if !_faff {_fgadg ,_dbbcb :=_cg .GetArray (_aaege .Get ("\u0057\u0069\u0064\u0074\u0068\u0073"));if !_dbbcb ||!_gbdfe ||!_ageb ||_fgadg .Len ()!=_ccbbe -_fdagf +1{_gceg =append (_gceg ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0032\u002d\u0036","\u0057\u0069\u0064\u0074\u0068\u0073\u0020\u002d a\u0072\u0072\u0061y \u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0073\u0074a\u006e\u0064a\u0072\u0064\u00201\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u003b\u0020\u0069\u006ed\u0069\u0072\u0065\u0063\u0074\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0070\u0072\u0065\u0066e\u0072\u0072e\u0064\u0029\u0020\u0041\u006e \u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0066\u0020\u0028\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u2212 F\u0069\u0072\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u002b\u00201\u0029\u0020\u0077\u0069\u0064\u0074\u0068\u0073."));
_faff =true ;if _eafb (){return _gceg ;};};};};};return _gceg ;};var _ Profile =(*Profile2A )(nil );func _eabb (_bcdg *_dg .PdfFont ,_ddbc *_cg .PdfObjectDictionary )ViolatedRule {const (_affa ="\u0036.\u0033\u002e\u0037\u002d\u0031";_gafc ="\u0041\u006cl \u006e\u006f\u006e\u002d\u0073\u0079\u006db\u006f\u006c\u0069\u0063\u0020\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065\u0020\u0066o\u006e\u0074s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020e\u0069\u0074h\u0065\u0072\u0020\u004d\u0061\u0063\u0052\u006f\u006d\u0061\u006e\u0045\u006e\u0063\u006fd\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041\u006e\u0073i\u0045n\u0063\u006f\u0064\u0069n\u0067\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0066o\u0072\u0020t\u0068\u0065 \u0045n\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006b\u0065\u0079 \u0069\u006e\u0020t\u0068e\u0020\u0046o\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0072\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0066\u006f\u0072 \u0074\u0068\u0065\u0020\u0042\u0061\u0073\u0065\u0045\u006e\u0063\u006fd\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074\u0068\u0065 \u0064i\u0063\u0074i\u006fn\u0061\u0072\u0079\u0020\u0077\u0068\u0069\u0063\u0068\u0020\u0069s\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0074\u0068e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006be\u0079\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0046\u006f\u006e\u0074 \u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u002e\u0020\u0049\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e, \u006eo\u0020n\u006f\u006e\u002d\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072\u0075\u0065\u0054\u0079p\u0065 \u0066\u006f\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0020\u0061\u0020\u0044\u0069\u0066\u0066e\u0072\u0065\u006e\u0063\u0065\u0073\u0020a\u0072\u0072\u0061\u0079\u0020\u0075n\u006c\u0065s\u0073\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0074h\u0065\u0020\u0067\u006c\u0079\u0070\u0068\u0020\u006e\u0061\u006d\u0065\u0073 \u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0044\u0069f\u0066\u0065\u0072\u0065\u006ec\u0065\u0073\u0020a\u0072\u0072\u0061\u0079\u0020\u0061\u0072\u0065\u0020\u006c\u0069\u0073\u0074\u0065\u0064 \u0069\u006e \u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065 G\u006c\u0079\u0070\u0068\u0020\u004c\u0069\u0073t\u0020\u0061\u006e\u0064\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0066o\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072a\u006d\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u0061\u0074\u0020\u006c\u0065\u0061\u0073t\u0020\u0074\u0068\u0065\u0020\u004d\u0069\u0063\u0072o\u0073o\u0066\u0074\u0020\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0028\u0033\u002c\u0031 \u2013 P\u006c\u0061\u0074\u0066\u006f\u0072\u006d\u0020I\u0044\u003d\u0033\u002c\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067 I\u0044\u003d\u0031\u0029\u0020\u0065\u006e\u0063\u006f\u0064i\u006e\u0067 \u0069\u006e\u0020t\u0068\u0065\u0020'\u0063\u006d\u0061\u0070\u0027\u0020\u0074\u0061\u0062\u006c\u0065\u002e";
);var _bceff string ;if _afg ,_bcefga :=_cg .GetName (_ddbc .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bcefga {_bceff =_afg .String ();};if _bceff !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cd ;};_ada :=_bcdg .FontDescriptor ();
_adcf ,_bacd :=_cg .GetIntVal (_ada .Flags );if !_bacd {_ef .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _fd (_affa ,_gafc );};_babf :=(uint32 (_adcf )>>3)!=0;if _babf {return _cd ;};_cced ,_bacd :=_cg .GetName (_ddbc .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067"));if !_bacd {return _fd (_affa ,_gafc );};switch _cced .String (){case "\u004d\u0061c\u0052\u006f\u006da\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067","\u0057i\u006eA\u006e\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067":return _cd ;
default:return _fd (_affa ,_gafc );};};

// ValidateStandard checks if provided input CompliancePdfReader matches rules that conforms PDF/A-1 standard.
func (_addc *profile1 )ValidateStandard (r *_dg .CompliancePdfReader )error {_cebe :=VerificationError {ConformanceLevel :_addc ._eab ._fg ,ConformanceVariant :_addc ._eab ._ca };if _bggf :=_ggfa (r );_bggf !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_bggf );
};if _aba :=_dgdb (r );_aba !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_aba );};if _bagff :=_gccea (r );_bagff !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_bagff );};if _becec :=_ebcd (r );_becec !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_becec );
};if _abed :=_ddb (r );_abed !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_abed );};if _eaced :=_eggc (r );len (_eaced )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_eaced ...);};if _cfdg :=_bgdf (r );_cfdg !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_cfdg );
};if _agegc :=_egdf (r );len (_agegc )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_agegc ...);};if _fafc :=_bfde (r );len (_fafc )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_fafc ...);};if _gcdgf :=_agdf (r );len (_gcdgf )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_gcdgf ...);
};if _gbdd :=_dcbb (r );_gbdd !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_gbdd );};if _effe :=_ccad (r );len (_effe )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_effe ...);};if _aec :=_abea (r );len (_aec )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_aec ...);
};if _bffg :=_gcabg (r );_bffg !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_bffg );};if _gedd :=_edaf (r ,false );len (_gedd )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_gedd ...);};if _gfee :=_gcbb (r );len (_gfee )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_gfee ...);
};if _gddc :=_ddff (r );_gddc !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_gddc );};if _afef :=_cfc (r );_afef !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_afef );};if _beeac :=_bfda (r );_beeac !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_beeac );
};if _cead :=_abbfe (r );_cead !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_cead );};if _ceff :=_babe (r );_ceff !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_ceff );};if _geac :=_dgec (r );len (_geac )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_geac ...);
};if _faef :=_fcca (r ,_addc ._eab );len (_faef )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_faef ...);};if _abcb :=_dgde (r );len (_abcb )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_abcb ...);};if _acdd :=_eagc (r );_acdd !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_acdd );
};if _cbab :=_bcce (r );_cbab !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_cbab );};if _bfc :=_adba (r );len (_bfc )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_bfc ...);};if _bdae :=_aedf (r );len (_bdae )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_bdae ...);
};if _acdf :=_beeb (r );_acdf !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_acdf );};if _afbd :=_eafc (r );_afbd !=_cd {_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_afbd );};if _dgdd :=_bbaeg (r ,_addc ._eab ,false );len (_dgdd )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_dgdd ...);
};if _addc ._eab ==_de (){if _daea :=_accb (r );len (_daea )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_daea ...);};};if _fbc :=_caba (r );len (_fbc )!=0{_cebe .ViolatedRules =append (_cebe .ViolatedRules ,_fbc ...);};if len (_cebe .ViolatedRules )> 0{_f .Slice (_cebe .ViolatedRules ,func (_egb ,_dagc int )bool {return _cebe .ViolatedRules [_egb ].RuleNo < _cebe .ViolatedRules [_dagc ].RuleNo ;
});return _cebe ;};return nil ;};

// VerificationError is the PDF/A verification error structure, that contains all violated rules.
type VerificationError struct{

// ViolatedRules are the rules that were violated during error verification.
ViolatedRules []ViolatedRule ;

// ConformanceLevel defines the standard on verification failed.
ConformanceLevel int ;

// ConformanceVariant is the standard variant used on verification.
ConformanceVariant string ;};func _gcb (_baa *_cbf .Document ,_faa standardType ,_bef *_cbf .OutputIntents )error {var (_bfac *_dg .PdfOutputIntent ;_cef error ;);if _baa .Version .Minor <=7{_bfac ,_cef =_bg .NewSRGBv2OutputIntent (_faa .outputIntentSubtype ());
}else {_bfac ,_cef =_bg .NewSRGBv4OutputIntent (_faa .outputIntentSubtype ());};if _cef !=nil {return _cef ;};if _cef =_bef .Add (_bfac .ToPdfObject ());_cef !=nil {return _cef ;};return nil ;};func _bgdf (_eddf *_dg .CompliancePdfReader )ViolatedRule {return _cd };
func _cfc (_aeaac *_dg .CompliancePdfReader )(_cbfb ViolatedRule ){for _ ,_ebfcg :=range _aeaac .GetObjectNums (){_gbbd ,_edgc :=_aeaac .GetIndirectObjectByNumber (_ebfcg );if _edgc !=nil {continue ;};_ggfb ,_cbeb :=_cg .GetStream (_gbbd );if !_cbeb {continue ;
};_bdc ,_cbeb :=_cg .GetName (_ggfb .Get ("\u0054\u0079\u0070\u0065"));if !_cbeb {continue ;};if *_bdc !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};if _ggfb .Get ("\u0052\u0065\u0066")!=nil {return _fd ("\u0036.\u0032\u002e\u0036\u002d\u0031","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e");
};};return _cbfb ;};func _bcce (_dccad *_dg .CompliancePdfReader )ViolatedRule {_aggad :=map[*_cg .PdfObjectStream ]struct{}{};for _ ,_egdd :=range _dccad .PageList {if _egdd .Resources ==nil &&_egdd .Contents ==nil {continue ;};if _eacba :=_egdd .GetPageDict ();
_eacba !=nil {_dfef ,_bfbc :=_cg .GetDict (_eacba .Get ("\u0047\u0072\u006fu\u0070"));if _bfbc {if _aagdc :=_dfef .Get ("\u0053");_aagdc !=nil {_debedb ,_aeba :=_cg .GetName (_aagdc );if _aeba &&_debedb .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _fd ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};};};if _egdd .Resources !=nil {if _dfgc ,_feab :=_cg .GetDict (_egdd .Resources .XObject );_feab {for _ ,_fecg :=range _dfgc .Keys (){_cbbg ,_bfebe :=_cg .GetStream (_dfgc .Get (_fecg ));if !_bfebe {continue ;};if _ ,_bdde :=_aggad [_cbbg ];_bdde {continue ;
};_fdbe ,_bfebe :=_cg .GetDict (_cbbg .Get ("\u0047\u0072\u006fu\u0070"));if !_bfebe {_aggad [_cbbg ]=struct{}{};continue ;};_beddg :=_fdbe .Get ("\u0053");if _beddg !=nil {_bacf ,_acfd :=_cg .GetName (_beddg );if _acfd &&_bacf .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _fd ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};_aggad [_cbbg ]=struct{}{};continue ;};};};if _egdd .Contents !=nil {_bced ,_cfbgd :=_egdd .GetContentStreams ();if _cfbgd !=nil {continue ;};for _ ,_dgfcb :=range _bced {_gdad ,_aacc :=_be .NewContentStreamParser (_dgfcb ).Parse ();if _aacc !=nil {continue ;
};for _ ,_ggg :=range *_gdad {if len (_ggg .Params )==0{continue ;};_bbfeb ,_fcad :=_cg .GetName (_ggg .Params [0]);if !_fcad {continue ;};_bebc ,_aedeg :=_egdd .Resources .GetXObjectByName (*_bbfeb );if _aedeg !=_dg .XObjectTypeForm {continue ;};if _ ,_fcdf :=_aggad [_bebc ];
_fcdf {continue ;};_ceca ,_fcad :=_cg .GetDict (_bebc .Get ("\u0047\u0072\u006fu\u0070"));if !_fcad {_aggad [_bebc ]=struct{}{};continue ;};_egfad :=_ceca .Get ("\u0053");if _egfad !=nil {_dcge ,_ebgf :=_cg .GetName (_egfad );if _ebgf &&_dcge .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _fd ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};_aggad [_bebc ]=struct{}{};};};};};return _cd ;};

// NewProfile2U creates a new Profile2U with the given options.
func NewProfile2U (options *Profile2Options )*Profile2U {if options ==nil {options =DefaultProfile2Options ();};_daad (options );return &Profile2U {profile2 {_fafg :*options ,_becece :_bc ()}};};func _eff ()standardType {return standardType {_fg :2,_ca :"\u0042"}};
func _cfecf (_ebcf *_dg .CompliancePdfReader )(_dafa []ViolatedRule ){var (_gdfd ,_baee ,_dbca ,_acda ,_dgaa bool ;_efdc func (_cg .PdfObject ););_efdc =func (_cbga _cg .PdfObject ){switch _ffbde :=_cbga .(type ){case *_cg .PdfObjectInteger :if !_gdfd &&(int64 (*_ffbde )> _ed .MaxInt32 ||int64 (*_ffbde )< -_ed .MaxInt32 ){_dafa =append (_dafa ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0031","L\u0061\u0072\u0067e\u0073\u0074\u0020\u0049\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0032\u002c\u0031\u0034\u0037,\u0034\u0038\u0033,\u0036\u0034\u0037\u002e\u0020\u0053\u006d\u0061\u006c\u006c\u0065\u0073\u0074 \u0069\u006e\u0074\u0065g\u0065\u0072\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u002d\u0032\u002c\u0031\u0034\u0037\u002c\u0034\u0038\u0033,\u0036\u0034\u0038\u002e"));
_gdfd =true ;};case *_cg .PdfObjectFloat :if !_baee &&(_ed .Abs (float64 (*_ffbde ))> _ed .MaxFloat32 ){_dafa =append (_dafa ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0032","\u0041 \u0063\u006f\u006e\u0066orm\u0069\u006e\u0067\u0020f\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0061\u006c\u0020\u006e\u0075\u006db\u0065\u0072\u0020\u006f\u0075\u0074\u0073\u0069de\u0020\u0074\u0068e\u0020\u0072\u0061\u006e\u0067e\u0020o\u0066\u0020\u002b\u002f\u002d\u0033\u002e\u0034\u00303\u0020\u0078\u0020\u0031\u0030\u005e\u0033\u0038\u002e"));
};case *_cg .PdfObjectString :if !_dbca &&len ([]byte (_ffbde .Str ()))> 32767{_dafa =append (_dafa ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0033","M\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006c\u0065n\u0067\u0074\u0068\u0020\u006f\u0066\u0020a \u0073\u0074\u0072\u0069n\u0067\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074es\u0029\u0020i\u0073\u0020\u0033\u0032\u0037\u0036\u0037\u002e"));
_dbca =true ;};case *_cg .PdfObjectName :if !_acda &&len ([]byte (*_ffbde ))> 127{_dafa =append (_dafa ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0034","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006c\u0065\u006eg\u0074\u0068\u0020\u006ff\u0020\u0061\u0020\u006e\u0061\u006d\u0065\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074\u0065\u0073\u0029\u0020\u0069\u0073\u0020\u0031\u0032\u0037\u002e"));
_acda =true ;};case *_cg .PdfObjectArray :for _ ,_bcga :=range _ffbde .Elements (){_efdc (_bcga );};if !_dgaa &&(_ffbde .Len ()==4||_ffbde .Len ()==5){_fffdc ,_ggddb :=_cg .GetName (_ffbde .Get (0));if !_ggddb {return ;};if *_fffdc !="\u0044e\u0076\u0069\u0063\u0065\u004e"{return ;
};_cbdg :=_ffbde .Get (1);_cbdg =_cg .TraceToDirectObject (_cbdg );_bdga ,_ggddb :=_cg .GetArray (_cbdg );if !_ggddb {return ;};if _bdga .Len ()> 32{_dafa =append (_dafa ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0039","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006e\u0075\u006db\u0065\u0072\u0020\u006ff\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u004e\u0020\u0063\u006f\u006d\u0070\u006f\u006e\u0065\u006e\u0074\u0073\u0020\u0069\u0073\u0020\u0033\u0032\u002e"));
_dgaa =true ;};};case *_cg .PdfObjectDictionary :_abbfb :=_ffbde .Keys ();for _ccce ,_ddca :=range _abbfb {_efdc (&_abbfb [_ccce ]);_efdc (_ffbde .Get (_ddca ));};case *_cg .PdfObjectStream :_efdc (_ffbde .PdfObjectDictionary );case *_cg .PdfObjectStreams :for _ ,_ecfgf :=range _ffbde .Elements (){_efdc (_ecfgf );
};case *_cg .PdfObjectReference :_efdc (_ffbde .Resolve ());};};_fbbf :=_ebcf .GetObjectNums ();if len (_fbbf )> 8388607{_dafa =append (_dafa ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0037","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020in\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0073 \u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u0020\u0066\u0069\u006c\u0065\u0020\u0069\u0073\u00208\u002c\u0033\u0038\u0038\u002c\u0036\u0030\u0037\u002e"));
};for _ ,_bddf :=range _fbbf {_dgae ,_fdfed :=_ebcf .GetIndirectObjectByNumber (_bddf );if _fdfed !=nil {continue ;};_ffdfe :=_cg .TraceToDirectObject (_dgae );_efdc (_ffdfe );};return _dafa ;};func _fffb (_cgac *_dg .CompliancePdfReader )(_afcea []ViolatedRule ){_deec ,_eeffd :=_febce (_cgac );
if !_eeffd {return _afcea ;};_gcbec ,_eeffd :=_cg .GetDict (_deec .Get ("\u004e\u0061\u006de\u0073"));if !_eeffd {return _afcea ;};if _gcbec .Get ("\u0041\u006c\u0074\u0065rn\u0061\u0074\u0065\u0050\u0072\u0065\u0073\u0065\u006e\u0074\u0061\u0074\u0069\u006fn\u0073")!=nil {_afcea =append (_afcea ,_fd ("\u0036\u002e\u0031\u0030\u002d\u0031","T\u0068\u0065\u0072e\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u006e\u006f\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0050\u0072\u0065s\u0065\u006e\u0074a\u0074\u0069\u006f\u006e\u0073\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075m\u0065\u006e\u0074\u0027\u0073\u0020\u006e\u0061\u006d\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002e"));
};return _afcea ;};func _afaag (_egef *_dg .CompliancePdfReader )(*_dg .PdfOutputIntent ,bool ){_aabb ,_gafb :=_fcgbg (_egef );if !_gafb {return nil ,false ;};_gbcf ,_dfgce :=_dg .NewPdfOutputIntentFromPdfObject (_aabb );if _dfgce !=nil {return nil ,false ;
};return _gbcf ,true ;};func _aaag (_gdae *_cbf .Document )error {_gdg ,_fcf :=_gdae .FindCatalog ();if !_fcf {return nil ;};_ ,_fcf =_cg .GetDict (_gdg .Object .Get ("\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065e\u0052\u006f\u006f\u0074"));if !_fcf {_gbg :=_cg .MakeDict ();
_gbg .Set ("\u0054\u0079\u0070\u0065",_cg .MakeName ("\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065e\u0052\u006f\u006f\u0074"));_gdg .Object .Set ("\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065e\u0052\u006f\u006f\u0074",_gbg );};return nil ;
};func _dba (_cbgb *_cbf .Document )error {_ecf ,_dfec :=_cbgb .GetPages ();if !_dfec {return nil ;};for _ ,_cfbb :=range _ecf {_ggdg ,_ffac :=_cg .GetArray (_cfbb .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_ffac {continue ;};for _ ,_dacb :=range _ggdg .Elements (){_dacb =_cg .ResolveReference (_dacb );
if _ ,_daag :=_dacb .(*_cg .PdfObjectNull );_daag {continue ;};_egcca ,_aaf :=_cg .GetDict (_dacb );if !_aaf {continue ;};_bagb ,_ :=_cg .GetIntVal (_egcca .Get ("\u0046"));_bagb &=^(1<<0);_bagb &=^(1<<1);_bagb &=^(1<<5);_bagb |=1<<2;_egcca .Set ("\u0046",_cg .MakeInteger (int64 (_bagb )));
_bgdc :=false ;if _bab :=_egcca .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065");_bab !=nil {_gcag ,_agc :=_cg .GetName (_bab );if _agc &&_gcag .String ()=="\u0057\u0069\u0064\u0067\u0065\u0074"{_bgdc =true ;if _egcca .Get ("\u0041\u0041")!=nil {_egcca .Remove ("\u0041\u0041");
};};};if _egcca .Get ("\u0043")!=nil ||_egcca .Get ("\u0049\u0043")!=nil {_dcg ,_aeda :=_acc (_cbgb );if !_aeda {_egcca .Remove ("\u0043");_egcca .Remove ("\u0049\u0043");}else {_cefg ,_edbd :=_cg .GetIntVal (_dcg .Get ("\u004e"));if !_edbd ||_cefg !=3{_egcca .Remove ("\u0043");
_egcca .Remove ("\u0049\u0043");};};};_defc ,_aaf :=_cg .GetDict (_egcca .Get ("\u0041\u0050"));if _aaf {_dagb :=_defc .Get ("\u004e");if _dagb ==nil {continue ;};if len (_defc .Keys ())> 1{_defc .Clear ();_defc .Set ("\u004e",_dagb );};if _bgdc {_ecc ,_fefg :=_cg .GetName (_egcca .Get ("\u0046\u0054"));
if _fefg &&*_ecc =="\u0042\u0074\u006e"{continue ;};};};};};return nil ;};func _edea (_def *_cbf .Document ,_aad bool )error {_bff ,_abf :=_def .GetPages ();if !_abf {return nil ;};for _ ,_gbga :=range _bff {_cdc :=_gbga .FindXObjectForms ();for _ ,_fdec :=range _cdc {_deee ,_fga :=_dg .NewXObjectFormFromStream (_fdec );
if _fga !=nil {return _fga ;};_dbec ,_fga :=_deee .GetContentStream ();if _fga !=nil {return _fga ;};_cda :=_be .NewContentStreamParser (string (_dbec ));_gdeg ,_fga :=_cda .Parse ();if _fga !=nil {return _fga ;};_aegc ,_fga :=_bdeg (_deee .Resources ,_gdeg ,_aad );
if _fga !=nil {return _fga ;};if len (_aegc )==0{continue ;};if _fga =_deee .SetContentStream (_aegc ,_cg .NewFlateEncoder ());_fga !=nil {return _fga ;};_deee .ToPdfObject ();};};return nil ;};func _bdeg (_cagg *_dg .PdfPageResources ,_gcfe *_be .ContentStreamOperations ,_ecba bool )([]byte ,error ){var _eed bool ;
for _ ,_ggc :=range *_gcfe {_eddc :switch _ggc .Operand {case "\u0042\u0049":_cfeg ,_cdaf :=_ggc .Params [0].(*_be .ContentStreamInlineImage );if !_cdaf {break ;};_ccc ,_bdb :=_cfeg .GetColorSpace (_cagg );if _bdb !=nil {return nil ,_bdb ;};switch _ccc .(type ){case *_dg .PdfColorspaceDeviceCMYK :if _ecba {break _eddc ;
};case *_dg .PdfColorspaceDeviceGray :case *_dg .PdfColorspaceDeviceRGB :if !_ecba {break _eddc ;};default:break _eddc ;};_eed =true ;_cbaf ,_bdb :=_cfeg .ToImage (_cagg );if _bdb !=nil {return nil ,_bdb ;};_bedf ,_bdb :=_cbaf .ToGoImage ();if _bdb !=nil {return nil ,_bdb ;
};if _ecba {_bedf ,_bdb =_eb .CMYKConverter .Convert (_bedf );}else {_bedf ,_bdb =_eb .NRGBAConverter .Convert (_bedf );};if _bdb !=nil {return nil ,_bdb ;};_egd ,_cdaf :=_bedf .(_eb .Image );if !_cdaf {return nil ,_fc .New ("\u0069\u006d\u0061\u0067\u0065\u0020\u0064\u006f\u0065\u0073\u006e\u0027\u0074 \u0069\u006d\u0070\u006c\u0065\u006de\u006e\u0074\u0020\u0069\u006d\u0061\u0067\u0065\u0075\u0074\u0069\u006c\u002eI\u006d\u0061\u0067\u0065");
};_dcaa :=_egd .Base ();_defg :=_dg .Image {Width :int64 (_dcaa .Width ),Height :int64 (_dcaa .Height ),BitsPerComponent :int64 (_dcaa .BitsPerComponent ),ColorComponents :_dcaa .ColorComponents ,Data :_dcaa .Data };_defg .SetDecode (_dcaa .Decode );_defg .SetAlpha (_dcaa .Alpha );
_caed ,_bdb :=_cfeg .GetEncoder ();if _bdb !=nil {_caed =_cg .NewFlateEncoder ();};_eaca ,_bdb :=_be .NewInlineImageFromImage (_defg ,_caed );if _bdb !=nil {return nil ,_bdb ;};_ggc .Params [0]=_eaca ;case "\u0047","\u0067":if len (_ggc .Params )!=1{break ;
};_ffd ,_cfde :=_cg .GetNumberAsFloat (_ggc .Params [0]);if _cfde !=nil {break ;};if _ecba {_ggc .Params =[]_cg .PdfObject {_cg .MakeFloat (0),_cg .MakeFloat (0),_cg .MakeFloat (0),_cg .MakeFloat (1-_ffd )};_cggc :="\u004b";if _ggc .Operand =="\u0067"{_cggc ="\u006b";
};_ggc .Operand =_cggc ;}else {_ggc .Params =[]_cg .PdfObject {_cg .MakeFloat (_ffd ),_cg .MakeFloat (_ffd ),_cg .MakeFloat (_ffd )};_acdb :="\u0052\u0047";if _ggc .Operand =="\u0067"{_acdb ="\u0072\u0067";};_ggc .Operand =_acdb ;};_eed =true ;case "\u0052\u0047","\u0072\u0067":if !_ecba {break ;
};if len (_ggc .Params )!=3{break ;};_bagea ,_fcaf :=_cg .GetNumbersAsFloat (_ggc .Params );if _fcaf !=nil {break ;};_eed =true ;_dabf ,_eace ,_fdef :=_bagea [0],_bagea [1],_bagea [2];_ggd ,_bffa ,_ccdd ,_abbe :=_g .RGBToCMYK (uint8 (_dabf *255),uint8 (_eace *255),uint8 (255*_fdef ));
_ggc .Params =[]_cg .PdfObject {_cg .MakeFloat (float64 (_ggd )/255),_cg .MakeFloat (float64 (_bffa )/255),_cg .MakeFloat (float64 (_ccdd )/255),_cg .MakeFloat (float64 (_abbe )/255)};_adfd :="\u004b";if _ggc .Operand =="\u0072\u0067"{_adfd ="\u006b";};
_ggc .Operand =_adfd ;case "\u004b","\u006b":if _ecba {break ;};if len (_ggc .Params )!=4{break ;};_dgga ,_gfca :=_cg .GetNumbersAsFloat (_ggc .Params );if _gfca !=nil {break ;};_bfbb ,_fff ,_bgae ,_bcc :=_dgga [0],_dgga [1],_dgga [2],_dgga [3];_bagf ,_fcac ,_afad :=_g .CMYKToRGB (uint8 (255*_bfbb ),uint8 (255*_fff ),uint8 (255*_bgae ),uint8 (255*_bcc ));
_ggc .Params =[]_cg .PdfObject {_cg .MakeFloat (float64 (_bagf )/255),_cg .MakeFloat (float64 (_fcac )/255),_cg .MakeFloat (float64 (_afad )/255)};_fba :="\u0052\u0047";if _ggc .Operand =="\u006b"{_fba ="\u0072\u0067";};_ggc .Operand =_fba ;_eed =true ;
};};if !_eed {return nil ,nil ;};_ceaa :=_be .NewContentCreator ();for _ ,_fdafg :=range *_gcfe {_ceaa .AddOperand (*_fdafg );};_gac :=_ceaa .Bytes ();return _gac ,nil ;};func _edafe (_afga *_dg .CompliancePdfReader ,_efdgg standardType )(_gfebd []ViolatedRule ){var _dabdb ,_bgaec ,_fbbbc ,_adeee ,_cgbc ,_gbfa ,_gfbc bool ;
_bggbe :=func ()bool {return _dabdb &&_bgaec &&_fbbbc &&_adeee &&_cgbc &&_gbfa &&_gfbc };_afcg :=map[*_cg .PdfObjectStream ]*_gf .CMap {};_ecdca :=map[*_cg .PdfObjectStream ][]byte {};_ebdcdb :=map[_cg .PdfObject ]*_dg .PdfFont {};for _ ,_agce :=range _afga .GetObjectNums (){_agcg ,_cbcg :=_afga .GetIndirectObjectByNumber (_agce );
if _cbcg !=nil {continue ;};_fbafde ,_bgdeg :=_cg .GetDict (_agcg );if !_bgdeg {continue ;};_fbgaa ,_bgdeg :=_cg .GetName (_fbafde .Get ("\u0054\u0079\u0070\u0065"));if !_bgdeg {continue ;};if *_fbgaa !="\u0046\u006f\u006e\u0074"{continue ;};_ggbbf ,_cbcg :=_dg .NewPdfFontFromPdfObject (_fbafde );
if _cbcg !=nil {_ef .Log .Debug ("g\u0065\u0074\u0074\u0069\u006e\u0067 \u0066\u006f\u006e\u0074\u0020\u0066r\u006f\u006d\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020%\u0076",_cbcg );continue ;};_ebdcdb [_fbafde ]=_ggbbf ;
};for _ ,_dgaaf :=range _afga .PageList {_fafdc ,_egcgc :=_dgaaf .GetContentStreams ();if _egcgc !=nil {_ef .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067 \u0070\u0061\u0067\u0065\u0020\u0063o\u006e\u0074\u0065\u006e\u0074\u0020\u0073t\u0072\u0065\u0061\u006d\u0073\u0020\u0066\u0061\u0069\u006ce\u0064");
continue ;};for _ ,_afdec :=range _fafdc {_ccff :=_be .NewContentStreamParser (_afdec );_acga ,_bdfg :=_ccff .Parse ();if _bdfg !=nil {_ef .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074s\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_bdfg );
continue ;};var _aadde bool ;for _ ,_fgeb :=range *_acga {if _fgeb .Operand !="\u0054\u0072"{continue ;};if len (_fgeb .Params )!=1{_ef .Log .Debug ("\u0069\u006e\u0076\u0061\u006ci\u0064\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0070\u0061\u0072\u0061\u006d\u0065\u0074\u0065\u0072\u0073\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054\u0072\u0027\u0020\u006f\u0070\u0065\u0072\u0061\u006e\u0064\u002c\u0020\u0065\u0078\u0070e\u0063\u0074\u0065\u0064\u0020\u0027\u0031\u0027\u0020\u0062\u0075\u0074 \u0069\u0073\u003a\u0020\u0027\u0025d\u0027",len (_fgeb .Params ));
continue ;};_fdbg ,_bcede :=_cg .GetIntVal (_fgeb .Params [0]);if !_bcede {_ef .Log .Debug ("\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020i\u0073 \u006e\u006f\u0074\u0020\u0061\u006e\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072");
continue ;};if _fdbg ==3{_aadde =true ;break ;};};for _ ,_cbda :=range *_acga {if _cbda .Operand !="\u0054\u0066"{continue ;};if len (_cbda .Params )!=2{_ef .Log .Debug ("i\u006eva\u006ci\u0064 \u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066 \u0070\u0061\u0072\u0061\u006de\u0074\u0065\u0072s\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054f\u0027\u0020\u006fper\u0061\u006e\u0064\u002c\u0020\u0065x\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0027\u0032\u0027\u0020\u0069s\u003a \u0027\u0025\u0064\u0027",len (_cbda .Params ));
continue ;};_fgfb ,_cdbae :=_cg .GetName (_cbda .Params [0]);if !_cdbae {_ef .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a \u0054\u0066\u0020\u006f\u0070\u003d\u0025\u0073\u0020\u0047\u0065\u0074\u004ea\u006d\u0065\u0056\u0061\u006c\u0020\u0066a\u0069\u006c\u0065\u0064",_cbda );
continue ;};_afdd ,_fbdff :=_dgaaf .Resources .GetFontByName (*_fgfb );if !_fbdff {_ef .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");continue ;};_abcg ,_cdbae :=_cg .GetDict (_afdd );if !_cdbae {_ef .Log .Debug ("\u0066\u006f\u006e\u0074 d\u0069\u0063\u0074\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
continue ;};_aabcd ,_cdbae :=_ebdcdb [_abcg ];if !_cdbae {var _bcae error ;_aabcd ,_bcae =_dg .NewPdfFontFromPdfObject (_abcg );if _bcae !=nil {_ef .Log .Debug ("\u0067\u0065\u0074\u0074i\u006e\u0067\u0020\u0066\u006f\u006e\u0074\u0020\u0066\u0072o\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u003a \u0025\u0076",_bcae );
continue ;};_ebdcdb [_abcg ]=_aabcd ;};if !_dabdb {_dgaag :=_cabg (_abcg ,_ecdca ,_afcg );if _dgaag !=_cd {_gfebd =append (_gfebd ,_dgaag );_dabdb =true ;if _bggbe (){return _gfebd ;};};};if !_bgaec {_dceeg :=_efgc (_abcg );if _dceeg !=_cd {_gfebd =append (_gfebd ,_dceeg );
_bgaec =true ;if _bggbe (){return _gfebd ;};};};if !_fbbbc {_cdfg :=_cadg (_abcg ,_ecdca ,_afcg );if _cdfg !=_cd {_gfebd =append (_gfebd ,_cdfg );_fbbbc =true ;if _bggbe (){return _gfebd ;};};};if !_adeee {_edfe :=_edff (_abcg ,_ecdca ,_afcg );if _edfe !=_cd {_gfebd =append (_gfebd ,_edfe );
_adeee =true ;if _bggbe (){return _gfebd ;};};};if !_cgbc {_dadfb :=_bfca (_aabcd ,_abcg ,_aadde );if _dadfb !=_cd {_cgbc =true ;_gfebd =append (_gfebd ,_dadfb );if _bggbe (){return _gfebd ;};};};if !_gbfa {_bafd :=_fgdgg (_aabcd ,_abcg );if _bafd !=_cd {_gbfa =true ;
_gfebd =append (_gfebd ,_bafd );if _bggbe (){return _gfebd ;};};};if !_gfbc &&(_efdgg ._ca =="\u0041"||_efdgg ._ca =="\u0055"){_baacgc :=_cabb (_abcg ,_ecdca ,_afcg );if _baacgc !=_cd {_gfbc =true ;_gfebd =append (_gfebd ,_baacgc );if _bggbe (){return _gfebd ;
};};};};};};return _gfebd ;};func _cabg (_gacb *_cg .PdfObjectDictionary ,_bcdb map[*_cg .PdfObjectStream ][]byte ,_agfe map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_eafcd ="\u0046\u006f\u0072\u0020\u0061\u006e\u0079\u0020\u0067\u0069\u0076\u0065\u006e\u0020\u0063\u006f\u006d\u0070o\u0073\u0069\u0074e\u0020\u0028\u0054\u0079\u0070\u0065\u0020\u0030\u0029 \u0066\u006fn\u0074\u0020\u0077\u0069\u0074\u0068\u0069\u006e \u0061\u0020\u0063\u006fn\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f \u0065\u006e\u0074\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074\u0073 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0074\u0068\u0065\u0020\u0066\u006fl\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0072\u0065l\u0061t\u0069\u006f\u006e\u0073\u0068\u0069\u0070. \u0049\u0066\u0020\u0074\u0068\u0065\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006b\u0065\u0079 \u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0054\u0079\u0070\u0065\u0020\u0030 \u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0069\u0073\u0020I\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056\u002c\u0020\u0061\u006e\u0079\u0020v\u0061\u006c\u0075\u0065\u0073\u0020\u006f\u0066\u0020\u0052\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u002c\u0020\u004f\u0072\u0064\u0065\u0072\u0069\u006e\u0067\u002c\u0020\u0061\u006e\u0064\u0020\u0053up\u0070\u006c\u0065\u006d\u0065\u006e\u0074\u0020\u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0069n\u0020\u0074h\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f\u0020\u0065\u006e\u0074r\u0079\u0020\u006ff\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044F\u006f\u006e\u0074\u002e\u0020\u004f\u0074\u0068\u0065\u0072\u0077\u0069\u0073\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0063\u006f\u0072\u0072\u0065\u0073\u0070\u006f\u006e\u0064\u0069\u006e\u0067\u0020\u0052\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u0020a\u006e\u0064\u0020\u004f\u0072\u0064\u0065\u0072\u0069\u006e\u0067\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0069\u006e\u0020\u0062\u006f\u0074h\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065m\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006cl\u0020\u0062\u0065\u0020i\u0064en\u0074\u0069\u0063\u0061\u006c\u002c \u0061n\u0064\u0020\u0074\u0068\u0065\u0020v\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0053\u0075\u0070\u0070l\u0065\u006d\u0065\u006e\u0074 \u006b\u0065\u0079\u0020\u0069\u006e\u0020t\u0068\u0065\u0020\u0043I\u0044S\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066o\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006ff\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0067re\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u006f\u0072\u0020\u0065\u0071\u0075\u0061\u006c\u0020\u0074\u006f t\u0068\u0065\u0020\u0053\u0075\u0070\u0070\u006c\u0065\u006d\u0065\u006e\u0074\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066o\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006ff\u0020\u0074\u0068\u0065\u0020\u0043M\u0061p\u002e";
_bgda ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0031";);var _afbdb string ;if _aefdd ,_acfc :=_cg .GetName (_gacb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_acfc {_afbdb =_aefdd .String ();};if _afbdb !="\u0054\u0079\u0070e\u0030"{return _cd ;
};_cfga :=_gacb .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");if _edda ,_aeff :=_cg .GetName (_cfga );_aeff {switch _edda .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _cd ;
};_eecdg ,_ggeac :=_gf .LoadPredefinedCMap (_edda .String ());if _ggeac !=nil {return _fd (_bgda ,_eafcd );};_agca :=_eecdg .CIDSystemInfo ();if _agca .Ordering !=_agca .Registry {return _fd (_bgda ,_eafcd );};return _cd ;};_fegbc ,_abgc :=_cg .GetStream (_cfga );
if !_abgc {return _fd (_bgda ,_eafcd );};_bcfa ,_gfff :=_cefgf (_fegbc ,_bcdb ,_agfe );if _gfff !=nil {return _fd (_bgda ,_eafcd );};_facaf :=_bcfa .CIDSystemInfo ();if _facaf .Ordering !=_facaf .Registry {return _fd (_bgda ,_eafcd );};return _cd ;};func _bbaeg (_gcfd *_dg .CompliancePdfReader ,_gebg standardType ,_dgad bool )(_ffbca []ViolatedRule ){_efdbc ,_adcd :=_febce (_gcfd );
if !_adcd {return []ViolatedRule {_fd ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u0063a\u0074a\u006c\u006f\u0067\u0020\u006eo\u0074\u0020f\u006f\u0075\u006e\u0064\u002e")};};_bcaaa :=_efdbc .Get ("\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061");if _bcaaa ==nil {return []ViolatedRule {_fd ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u006e\u006f\u0020\u0027\u004d\u0065\u0074\u0061d\u0061\u0074\u0061' \u006b\u0065\u0079\u0020\u0066\u006fu\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u002e"),_fd ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e")};
};_gcbg ,_adcd :=_cg .GetStream (_bcaaa );if !_adcd {return []ViolatedRule {_fd ("\u0036.\u0037\u002e\u0032\u002d\u0032","\u0063\u0061\u0074a\u006c\u006f\u0067\u0020\u0027\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0027\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020a\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"),_fd ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e")};
};if _gcbg .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")!=nil {_ffbca =append (_ffbca ,_fd ("\u0036.\u0037\u002e\u0032\u002d\u0032","M\u0065\u0074a\u0064\u0061\u0074\u0061\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c \u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0046\u0069\u006c\u0074\u0065\u0072\u0020\u006b\u0065y\u002e"));
};_fdfa ,_bcgd :=_egf .LoadDocument (_gcbg .Stream );if _bcgd !=nil {return []ViolatedRule {_fd ("\u0036.\u0037\u002e\u0039\u002d\u0031","The\u0020\u006d\u0065\u0074a\u0064\u0061t\u0061\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0061\u006e\u0064\u0020\u0077\u0065\u006c\u006c\u0020\u0066\u006f\u0072\u006de\u0064\u0020\u0050\u0044\u0046\u0041\u0045\u0078\u0074e\u006e\u0073\u0069\u006f\u006e\u0020\u0053\u0063\u0068\u0065\u006da\u0020\u0066\u006fr\u0020\u0061\u006c\u006c\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0073\u002e")};
};_cdad :=_fdfa .GetGoXmpDocument ();var _bgaga []*_df .Namespace ;for _ ,_acgb :=range _cdad .Namespaces (){switch _acgb .Name {case _b .NsDc .Name ,_ede .NsPDF .Name ,_cb .NsXmp .Name ,_c .NsXmpRights .Name ,_efc .Namespace .Name ,_gb .Namespace .Name ,_cc .NsXmpMM .Name ,_gb .FieldNS .Name ,_gb .SchemaNS .Name ,_gb .PropertyNS .Name ,"\u0073\u0074\u0045v\u0074","\u0073\u0074\u0056e\u0072","\u0073\u0074\u0052e\u0066","\u0073\u0074\u0044i\u006d","\u0078a\u0070\u0047\u0049\u006d\u0067","\u0073\u0074\u004ao\u0062","\u0078\u006d\u0070\u0069\u0064\u0071":continue ;
};_bgaga =append (_bgaga ,_acgb );};_dfcd :=true ;_daede ,_bcgd :=_fdfa .GetPdfaExtensionSchemas ();if _bcgd ==nil {for _ ,_ddba :=range _bgaga {var _aafc bool ;for _adfdc :=range _daede {if _ddba .URI ==_daede [_adfdc ].NamespaceURI {_aafc =true ;break ;
};};if !_aafc {_dfcd =false ;break ;};};}else {_dfcd =false ;};if !_dfcd {_ffbca =append (_ffbca ,_fd ("\u0036.\u0037\u002e\u0039\u002d\u0032","\u0050\u0072\u006f\u0070\u0065\u0072\u0074i\u0065\u0073 \u0073\u0070\u0065\u0063\u0069\u0066\u0069ed\u0020\u0069\u006e\u0020\u0058M\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0073\u0068\u0061\u006cl\u0020\u0075\u0073\u0065\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073 \u0064\u0065\u0066i\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006fn\u002c\u0020\u006f\u0072\u0020\u0065\u0078\u0074\u0065ns\u0069\u006f\u006e\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u0074\u0068\u0061\u0074 \u0063\u006f\u006d\u0070\u006c\u0079\u0020\u0077\u0069\u0074h\u0020\u0058\u004d\u0050\u0020\u0053\u0070e\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u002e"));
};_bbfg ,_bcgd :=_gcfd .GetPdfInfo ();if _bcgd ==nil {if !_ebga (_bbfg ,_fdfa ){_ffbca =append (_ffbca ,_fd ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e"));
};}else if _ ,_beeag :=_fdfa .GetMediaManagement ();_beeag {_ffbca =append (_ffbca ,_fd ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e"));
};_bdcd ,_adcd :=_fdfa .GetPdfAID ();if !_adcd {_ffbca =append (_ffbca ,_fd ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u0061n\u0064\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020\u006c\u0065\u0076\u0065l\u0020\u006f\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0070e\u0063\u0069\u0066\u0069\u0065\u0064\u0020\u0075\u0073\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073\u0063h\u0065\u006da."));
}else {if _bdcd .Part !=_gebg ._fg {_ffbca =append (_ffbca ,_fd ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0032","\u0054h\u0065\u0020\u0076\u0061lue\u0020\u006f\u0066\u0020p\u0064\u0066\u0061\u0069\u0064\u003a\u0070\u0061\u0072\u0074 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0061\u0072\u0074\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u002019\u0030\u0030\u0035 \u0074\u006f\u0020\u0077\u0068i\u0063h\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065 \u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0073\u002e"));
};if _gebg ._ca =="\u0041"&&_bdcd .Conformance !="\u0041"{_ffbca =append (_ffbca ,_fd ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0033","\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063i\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063o\u006e\u0066\u006fr\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0041\u002e\u0020\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0042\u0020\u0063\u006f\u006e\u0066o\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0073\u0070e\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e"));
}else if _gebg ._ca =="\u0042"&&(_bdcd .Conformance !="\u0041"&&_bdcd .Conformance !="\u0042"){_ffbca =append (_ffbca ,_fd ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0033","\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063i\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063o\u006e\u0066\u006fr\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0041\u002e\u0020\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0042\u0020\u0063\u006f\u006e\u0066o\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0073\u0070e\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e"));
};};return _ffbca ;};

// Part gets the PDF/A version level.
func (_bffef *profile1 )Part ()int {return _bffef ._eab ._fg };func _bde (_eda *_cbf .Document )error {_gcaf :=map[string ]*_cg .PdfObjectDictionary {};_ffa :=_ad .NewFinder (&_ad .FinderOpts {Extensions :[]string {"\u002e\u0074\u0074\u0066"}});_gcf :=map[_cg .PdfObject ]struct{}{};
_bdg :=map[_cg .PdfObject ]struct{}{};for _ ,_ccbe :=range _eda .Objects {_cac ,_fcd :=_cg .GetDict (_ccbe );if !_fcd {continue ;};_gbea :=_cac .Get ("\u0054\u0079\u0070\u0065");if _gbea ==nil {continue ;};if _dda ,_efa :=_cg .GetName (_gbea );_efa &&_dda .String ()!="\u0046\u006f\u006e\u0074"{continue ;
};if _ ,_dfgg :=_gcf [_ccbe ];_dfgg {continue ;};_dbd ,_abge :=_dg .NewPdfFontFromPdfObject (_cac );if _abge !=nil {_ef .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0063\u006f\u0075\u006c\u0064\u0020\u006e\u006f\u0074\u0020\u006c\u006f\u0061\u0064\u0020\u0066\u006fn\u0074\u0020\u0066\u0072\u006fm\u0020\u006fb\u006a\u0065\u0063\u0074");
return _abge ;};_eac ,_abge :=_dbd .GetFontDescriptor ();if _abge !=nil {return _abge ;};if _eac !=nil &&(_eac .FontFile !=nil ||_eac .FontFile2 !=nil ||_eac .FontFile3 !=nil ){continue ;};_ggb :=_dbd .BaseFont ();if _ggb ==""{return _eg .Errorf ("\u006f\u006e\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006f\u0062\u006a\u0065c\u0074\u0073\u0020\u0073\u0079\u006e\u0074\u0061\u0078\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020\u0076\u0061\u006c\u0069d\u0020\u002d\u0020\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u0075\u006ed\u0065\u0066\u0069n\u0065\u0064\u003a\u0020\u0025\u0073",_cac .String ());
};_dbc ,_dcd :=_gcaf [_ggb ];if !_dcd {if len (_ggb )> 7&&_ggb [6]=='+'{_ggb =_ggb [7:];};_ccg :=[]string {_ggb ,"\u0054i\u006de\u0073\u0020\u004e\u0065\u0077\u0020\u0052\u006f\u006d\u0061\u006e","\u0041\u0072\u0069a\u006c","D\u0065\u006a\u0061\u0056\u0075\u0020\u0053\u0061\u006e\u0073"};
for _ ,_cgf :=range _ccg {_ef .Log .Debug ("\u0044\u0045\u0042\u0055\u0047\u003a \u0073\u0065\u0061\u0072\u0063\u0068\u0069\u006e\u0067\u0020\u0073\u0079\u0073t\u0065\u006d\u0020\u0066\u006f\u006e\u0074 \u0060\u0025\u0073\u0060",_cgf );if _dbc ,_dcd =_gcaf [_cgf ];
_dcd {break ;};_gda :=_ffa .Match (_cgf );if _gda ==nil {_ef .Log .Debug ("c\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0066\u0069\u006e\u0064\u0020\u0066\u006fn\u0074\u0020\u0066i\u006ce\u0020\u0025\u0073",_cgf );continue ;};_cea ,_edb :=_dg .NewPdfFontFromTTFFile (_gda .Filename );
if _edb !=nil {return _edb ;};_adga :=_cea .FontDescriptor ();if _adga .FontFile !=nil {if _ ,_dcd =_bdg [_adga .FontFile ];!_dcd {_eda .Objects =append (_eda .Objects ,_adga .FontFile );_bdg [_adga .FontFile ]=struct{}{};};};if _adga .FontFile2 !=nil {if _ ,_dcd =_bdg [_adga .FontFile2 ];
!_dcd {_eda .Objects =append (_eda .Objects ,_adga .FontFile2 );_bdg [_adga .FontFile2 ]=struct{}{};};};if _adga .FontFile3 !=nil {if _ ,_dcd =_bdg [_adga .FontFile3 ];!_dcd {_eda .Objects =append (_eda .Objects ,_adga .FontFile3 );_bdg [_adga .FontFile3 ]=struct{}{};
};};_dcc ,_abb :=_cea .ToPdfObject ().(*_cg .PdfIndirectObject );if !_abb {_ef .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u0069\u0073\u0020\u006e\u006ft\u0020\u0061\u006e\u0020\u0069\u006e\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074");
continue ;};_gdf ,_abb :=_dcc .PdfObject .(*_cg .PdfObjectDictionary );if !_abb {_ef .Log .Debug ("\u0046\u006fn\u0074\u0020\u0074\u0079p\u0065\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u006e \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
continue ;};_gcaf [_cgf ]=_gdf ;_dbc =_gdf ;break ;};if _dbc ==nil {_ef .Log .Debug ("\u004e\u006f\u0020\u006d\u0061\u0074\u0063\u0068\u0069\u006eg\u0020\u0066\u006f\u006e\u0074\u0020\u0066o\u0075\u006e\u0064\u0020\u0066\u006f\u0072\u003a\u0020\u0025\u0073",_dbd .BaseFont ());
return _fc .New ("\u006e\u006f m\u0061\u0074\u0063h\u0069\u006e\u0067\u0020fon\u0074 f\u006f\u0075\u006e\u0064\u0020\u0069\u006e t\u0068\u0065\u0020\u0073\u0079\u0073\u0074e\u006d");};};for _ ,_gfb :=range _dbc .Keys (){_cac .Set (_gfb ,_dbc .Get (_gfb ));
};_gcd :=_dbc .Get ("\u0057\u0069\u0064\u0074\u0068\u0073");if _gcd !=nil {if _ ,_dcd =_bdg [_gcd ];!_dcd {_eda .Objects =append (_eda .Objects ,_gcd );_bdg [_gcd ]=struct{}{};};};_gcf [_ccbe ]=struct{}{};_fee :=_cac .Get ("\u0046\u006f\u006e\u0074\u0044\u0065\u0073\u0063\u0072i\u0070\u0074\u006f\u0072");
if _fee !=nil {_eda .Objects =append (_eda .Objects ,_fee );_bdg [_fee ]=struct{}{};};};return nil ;};func _bfee (_eaf *_cbf .Document )error {_beba :=func (_cfg *_cg .PdfObjectDictionary )error {if _edf :=_cfg .Get ("\u0053\u004d\u0061s\u006b");_edf !=nil {_cfg .Set ("\u0053\u004d\u0061s\u006b",_cg .MakeName ("\u004e\u006f\u006e\u0065"));
};_ffb :=_cfg .Get ("\u0043\u0041");if _ffb !=nil {_dege ,_fcc :=_cg .GetNumberAsFloat (_ffb );if _fcc !=nil {_ef .Log .Debug ("\u0045x\u0074\u0047S\u0074\u0061\u0074\u0065 \u006f\u0062\u006ae\u0063\u0074\u0020\u0043\u0041\u0020\u0076\u0061\u006cue\u0020\u0069\u0073 \u006e\u006ft\u0020\u0061\u0020\u0066\u006c\u006fa\u0074\u003a \u0025\u0076",_fcc );
_dege =0;};if _dege !=1.0{_cfg .Set ("\u0043\u0041",_cg .MakeFloat (1.0));};};_ffb =_cfg .Get ("\u0063\u0061");if _ffb !=nil {_bge ,_dcf :=_cg .GetNumberAsFloat (_ffb );if _dcf !=nil {_ef .Log .Debug ("\u0045\u0078t\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0027\u0063\u0061\u0027\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u0066\u006c\u006f\u0061\u0074\u003a\u0020\u0025\u0076",_dcf );
_bge =0;};if _bge !=1.0{_cfg .Set ("\u0063\u0061",_cg .MakeFloat (1.0));};};_dfe :=_cfg .Get ("\u0042\u004d");if _dfe !=nil {_efgg ,_gca :=_cg .GetName (_dfe );if !_gca {_ef .Log .Debug ("E\u0078\u0074\u0047\u0053\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0027\u0042\u004d\u0027\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u004e\u0061m\u0065");
_efgg =_cg .MakeName ("");};_adgg :=_efgg .String ();switch _adgg {case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065":default:_cfg .Set ("\u0042\u004d",_cg .MakeName ("\u004e\u006f\u0072\u006d\u0061\u006c"));
};};_gfa :=_cfg .Get ("\u0054\u0052");if _gfa !=nil {_ef .Log .Debug ("\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0054\u0052\u0020\u006b\u0065\u0079");
_cfg .Remove ("\u0054\u0052");};_bgaa :=_cfg .Get ("\u0054\u0052\u0032");if _bgaa !=nil {_fbb :=_bgaa .String ();if _fbb !="\u0044e\u0066\u0061\u0075\u006c\u0074"{_ef .Log .Debug ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074\u0065 o\u0062\u006a\u0065\u0063\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073 \u0054\u00522\u0020\u006b\u0065y\u0020\u0077\u0069\u0074\u0068\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065r\u0020\u0074ha\u006e\u0020\u0044e\u0066\u0061\u0075\u006c\u0074");
_cfg .Set ("\u0054\u0052\u0032",_cg .MakeName ("\u0044e\u0066\u0061\u0075\u006c\u0074"));};};return nil ;};_ccag ,_cba :=_eaf .GetPages ();if !_cba {return nil ;};for _ ,_bgeg :=range _ccag {_aaa ,_bgd :=_bgeg .GetResources ();if !_bgd {continue ;};_ag ,_ffe :=_cg .GetDict (_aaa .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));
if !_ffe {return nil ;};_daf :=_ag .Keys ();for _ ,_ega :=range _daf {_ecd ,_bae :=_cg .GetDict (_ag .Get (_ega ));if !_bae {continue ;};_aaaf :=_beba (_ecd );if _aaaf !=nil {continue ;};};};for _ ,_cad :=range _ccag {_fe ,_bee :=_cad .GetContents ();if !_bee {return nil ;
};for _ ,_cbg :=range _fe {_gga ,_gfe :=_cbg .GetData ();if _gfe !=nil {continue ;};_cae :=_be .NewContentStreamParser (string (_gga ));_fde ,_gfe :=_cae .Parse ();if _gfe !=nil {continue ;};for _ ,_daba :=range *_fde {if len (_daba .Params )==0{continue ;
};_ ,_ffed :=_cg .GetName (_daba .Params [0]);if !_ffed {continue ;};_ecg ,_aab :=_cad .GetResourcesXObject ();if !_aab {continue ;};for _ ,_edfa :=range _ecg .Keys (){_aed ,_gag :=_cg .GetStream (_ecg .Get (_edfa ));if !_gag {continue ;};_adf ,_gag :=_cg .GetDict (_aed .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_gag {continue ;};_fda ,_gag :=_cg .GetDict (_adf .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_gag {continue ;};for _ ,_age :=range _fda .Keys (){_gbf ,_dcfc :=_cg .GetDict (_fda .Get (_age ));if !_dcfc {continue ;};_cfe :=_beba (_gbf );
if _cfe !=nil {continue ;};};};};};};return nil ;};func _acc (_deda *_cbf .Document )(*_cg .PdfObjectDictionary ,bool ){_dfga ,_dgbbc :=_deda .FindCatalog ();if !_dgbbc {return nil ,false ;};_cged ,_dgbbc :=_cg .GetArray (_dfga .Object .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));
if !_dgbbc {return nil ,false ;};if _cged .Len ()==0{return nil ,false ;};return _cg .GetDict (_cged .Get (0));};

// NewProfile2A creates a new Profile2A with given options.
func NewProfile2A (options *Profile2Options )*Profile2A {if options ==nil {options =DefaultProfile2Options ();};_daad (options );return &Profile2A {profile2 {_fafg :*options ,_becece :_cf ()}};};func _faae (_dfa *_dg .PdfFont ,_fdea *_cg .PdfObjectDictionary )ViolatedRule {const (_bddbf ="\u0036.\u0033\u002e\u0037\u002d\u0033";
_dgcd ="\u0046\u006f\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006d\u0073\u0027\u0020\u0022\u0063\u006d\u0061\u0070\u0022\u0020\u0074\u0061\u0062\u006c\u0065\u0073\u0020\u0066\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0073\u0079\u006d\u0062o\u006c\u0069c\u0020\u0054\u0072\u0075e\u0054\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073 \u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0065\u0078\u0061\u0063\u0074\u006cy\u0020\u006f\u006ee\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u002e";
);var _abdfb string ;if _eeaga ,_aecf :=_cg .GetName (_fdea .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_aecf {_abdfb =_eeaga .String ();};if _abdfb !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cd ;};_bfcc :=_dfa .FontDescriptor ();
_cbafd ,_ccfee :=_cg .GetIntVal (_bfcc .Flags );if !_ccfee {_ef .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _fd (_bddbf ,_dgcd );};_ddde :=(uint32 (_cbafd )>>3)!=0;if !_ddde {return _cd ;};return _cd ;};func _gddb (_bfbd *_cg .PdfObjectDictionary ,_acfa map[*_cg .PdfObjectStream ][]byte ,_fdfb map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_gbfea ="\u0036.\u0033\u002e\u0038\u002d\u0031";
_baaef ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006cl\u0020\u0069\u006e\u0063l\u0075\u0064e\u0020\u0061 \u0054\u006f\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0065\u006e\u0074\u0072\u0079\u0020w\u0068\u006f\u0073\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073 \u0061\u0020\u0043M\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u006d\u0061p\u0073\u0020\u0063\u0068\u0061\u0072ac\u0074\u0065\u0072\u0020\u0063\u006fd\u0065s\u0020\u0074\u006f\u0020\u0055\u006e\u0069\u0063\u006f\u0064e \u0076a\u006c\u0075\u0065\u0073,\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063r\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020P\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035.\u0039\u002c\u0020\u0075\u006e\u006ce\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006d\u0065\u0065\u0074\u0073 \u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0074\u0068\u0072\u0065\u0065\u0020\u0063\u006f\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u0073\u003a\u000a\u0020\u002d\u0020\u0066o\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u0073\u0020M\u0061\u0063\u0052o\u006d\u0061\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u004d\u0061\u0063\u0045\u0078\u0070\u0065\u0072\u0074E\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041n\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u006f\u0072\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020t\u0068\u0065\u0020\u0070\u0072\u0065d\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0056\u0020C\u004d\u0061\u0070s\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u006e\u0061\u006d\u0065\u0073\u0020a\u0072\u0065 \u0074\u0061k\u0065\u006e\u0020\u0066\u0072\u006f\u006d\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u0020\u0073\u0074\u0061n\u0064\u0061\u0072\u0064\u0020L\u0061t\u0069\u006e\u0020\u0063\u0068a\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0074\u0020\u006fr\u0020\u0074\u0068\u0065 \u0073\u0065\u0074\u0020\u006f\u0066 \u006e\u0061\u006d\u0065\u0064\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0079\u006d\u0062\u006f\u006c\u0020\u0066\u006f\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046 \u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0041\u0070\u0070\u0065\u006e\u0064\u0069\u0078 \u0044\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020w\u0068\u006f\u0073e\u0020d\u0065\u0073\u0063\u0065n\u0064\u0061\u006e\u0074 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u0047B\u0031\u002c\u0020\u0041\u0064\u006fb\u0065\u002d\u0043\u004e\u0053\u0031\u002c\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004a\u0061\u0070\u0061\u006e\u0031\u0020\u006f\u0072\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004b\u006fr\u0065\u0061\u0031\u0020\u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u006c\u006c\u0065\u0063\u0074\u0069\u006f\u006e\u0073\u002e";
);_gdgb ,_dddec :=_cg .GetStream (_bfbd .Get ("\u0054o\u0055\u006e\u0069\u0063\u006f\u0064e"));if _dddec {_ ,_ebdcd :=_cefgf (_gdgb ,_acfa ,_fdfb );if _ebdcd !=nil {return _fd (_gbfea ,_baaef );};return _cd ;};_daeda ,_dddec :=_cg .GetName (_bfbd .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_dddec {return _fd (_gbfea ,_baaef );};switch _daeda .String (){case "\u0054\u0079\u0070e\u0031":return _cd ;};return _fd (_gbfea ,_baaef );};func _dfee (_bbabb *_dg .CompliancePdfReader )(_gbcd []ViolatedRule ){_bdff :=_bbabb .GetObjectNums ();for _ ,_bfbgf :=range _bdff {_gfbggd ,_dbddg :=_bbabb .GetIndirectObjectByNumber (_bfbgf );
if _dbddg !=nil {continue ;};_faeg ,_egdc :=_cg .GetDict (_gfbggd );if !_egdc {continue ;};_ecde ,_egdc :=_cg .GetName (_faeg .Get ("\u0054\u0079\u0070\u0065"));if !_egdc {continue ;};if _ecde .String ()!="\u0046\u0069\u006c\u0065\u0073\u0070\u0065\u0063"{continue ;
};if _faeg .Get ("\u0045\u0046")!=nil {if _faeg .Get ("\u0046")==nil ||_faeg .Get ("\u0045\u0046")==nil {_gbcd =append (_gbcd ,_fd ("\u0036\u002e\u0038-\u0032","\u0054h\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0070\u0065\u0063\u0069\u0066i\u0063\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063t\u0069\u006fn\u0061\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020t\u0068\u0065\u0020\u0046\u0020a\u006e\u0064\u0020\u0055\u0046\u0020\u006b\u0065\u0079\u0073\u002e"));
};if _faeg .Get ("\u0041\u0046\u0052\u0065\u006c\u0061\u0074\u0069\u006fn\u0073\u0068\u0069\u0070")==nil {_gbcd =append (_gbcd ,_fd ("\u0036\u002e\u0038-\u0033","\u0049\u006e\u0020\u006f\u0072d\u0065\u0072\u0020\u0074\u006f\u0020\u0065\u006e\u0061\u0062\u006c\u0065\u0020i\u0064\u0065nt\u0069\u0066\u0069c\u0061\u0074\u0069o\u006e\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0072\u0065\u006c\u0061\u0074\u0069\u006f\u006e\u0073h\u0069\u0070\u0020\u0062\u0065\u0074\u0077\u0065\u0065\u006e\u0020\u0074\u0068\u0065\u0020fi\u006ce\u0020\u0073\u0070\u0065\u0063\u0069f\u0069c\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020c\u006f\u006e\u0074e\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073\u0020\u0072\u0065\u0066\u0065\u0072\u0072\u0069\u006e\u0067\u0020\u0074\u006f\u0020\u0069\u0074\u002c\u0020\u0061\u0020\u006e\u0065\u0077\u0020(\u0072\u0065\u0071\u0075i\u0072\u0065\u0064\u0029\u0020\u006be\u0079\u0020h\u0061\u0073\u0020\u0062e\u0065\u006e\u0020\u0064\u0065\u0066i\u006e\u0065\u0064\u0020a\u006e\u0064\u0020\u0069\u0074s \u0070\u0072e\u0073\u0065n\u0063\u0065\u0020\u0028\u0069\u006e\u0020\u0074\u0068e\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u0029\u0020\u0069\u0073\u0020\u0072\u0065q\u0075\u0069\u0072e\u0064\u002e"));
};break ;};};return _gbcd ;};

// Error implements error interface.
func (_fb VerificationError )Error ()string {_add :=_d .Builder {};_add .WriteString ("\u0053\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u003a\u0020");_add .WriteString (_eg .Sprintf ("\u0050\u0044\u0046\u002f\u0041\u002d\u0025\u0064\u0025\u0073",_fb .ConformanceLevel ,_fb .ConformanceVariant ));
_add .WriteString ("\u0020\u0056\u0069\u006f\u006c\u0061\u0074\u0065\u0064\u0020\u0072\u0075l\u0065\u0073\u003a\u0020");for _dge ,_ce :=range _fb .ViolatedRules {_add .WriteString (_ce .String ());if _dge !=len (_fb .ViolatedRules )-1{_add .WriteRune ('\n');
};};return _add .String ();};func _bfda (_ggec *_dg .CompliancePdfReader )(_gfdd ViolatedRule ){for _ ,_baeb :=range _ggec .GetObjectNums (){_eccb ,_ggce :=_ggec .GetIndirectObjectByNumber (_baeb );if _ggce !=nil {continue ;};_afdgd ,_cbgf :=_cg .GetStream (_eccb );
if !_cbgf {continue ;};_ffacf ,_cbgf :=_cg .GetName (_afdgd .Get ("\u0054\u0079\u0070\u0065"));if !_cbgf {continue ;};if *_ffacf !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_accd ,_cbgf :=_cg .GetName (_afdgd .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_cbgf {continue ;};if *_accd =="\u0050\u0053"{return _fd ("\u0036.\u0032\u002e\u0037\u002d\u0031","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073.");
};};return _gfdd ;};func (_bb standardType )outputIntentSubtype ()_dg .PdfOutputIntentType {switch _bb ._fg {case 1:return _dg .PdfOutputIntentTypeA1 ;case 2:return _dg .PdfOutputIntentTypeA2 ;case 3:return _dg .PdfOutputIntentTypeA3 ;case 4:return _dg .PdfOutputIntentTypeA4 ;
default:return 0;};};func _edd (_deb *_cbf .Document ,_aede standardType ,_cdda XmpOptions )error {_gab ,_gaa :=_deb .FindCatalog ();if !_gaa {return nil ;};var _edfg *_egf .Document ;_eeae ,_gaa :=_gab .GetMetadata ();if !_gaa {_edfg =_egf .NewDocument ();
}else {var _egcc error ;_edfg ,_egcc =_egf .LoadDocument (_eeae .Stream );if _egcc !=nil {return _egcc ;};};_dbe :=_egf .PdfInfoOptions {InfoDict :_deb .Info ,PdfVersion :_eg .Sprintf ("\u0025\u0064\u002e%\u0064",_deb .Version .Major ,_deb .Version .Minor ),Copyright :_cdda .Copyright ,Overwrite :true };
_aga ,_gaa :=_gab .GetMarkInfo ();if _gaa {_ccfg ,_fea :=_cg .GetBool (_aga .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));if _fea &&bool (*_ccfg ){_dbe .Marked =true ;};};if _ded :=_edfg .SetPdfInfo (&_dbe );_ded !=nil {return _ded ;};if _aef :=_edfg .SetPdfAID (_aede ._fg ,_aede ._ca );
_aef !=nil {return _aef ;};_aeg :=_egf .MediaManagementOptions {OriginalDocumentID :_cdda .OriginalDocumentID ,DocumentID :_cdda .DocumentID ,InstanceID :_cdda .InstanceID ,NewDocumentID :!_cdda .NewDocumentVersion ,ModifyComment :"O\u0070\u0074\u0069\u006d\u0069\u007ae\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u006f\u0020\u0050D\u0046\u002f\u0041\u0020\u0073\u0074\u0061\u006e\u0064\u0061r\u0064"};
_caa ,_gaa :=_cg .GetDict (_deb .Info );if _gaa {if _baga ,_gdb :=_cg .GetString (_caa .Get ("\u004do\u0064\u0044\u0061\u0074\u0065"));_gdb &&_baga .String ()!=""{_ebf ,_ccba :=_ea .ParsePdfTime (_baga .String ());if _ccba !=nil {return _eg .Errorf ("\u0069n\u0076\u0061\u006c\u0069d\u0020\u004d\u006f\u0064\u0044a\u0074e\u0020f\u0069\u0065\u006c\u0064\u003a\u0020\u0025w",_ccba );
};_aeg .ModifyDate =_ebf ;};};if _gfea :=_edfg .SetMediaManagement (&_aeg );_gfea !=nil {return _gfea ;};if _fcdd :=_edfg .SetPdfAExtension ();_fcdd !=nil {return _fcdd ;};_cddc ,_efb :=_edfg .MarshalIndent (_cdda .MarshalPrefix ,_cdda .MarshalIndent );
if _efb !=nil {return _efb ;};if _bfb :=_gab .SetMetadata (_cddc );_bfb !=nil {return _bfb ;};return nil ;};func _fecd (_cece *_dg .PdfFont ,_cfa *_cg .PdfObjectDictionary )ViolatedRule {const (_bfeb ="\u0036.\u0033\u002e\u0037\u002d\u0032";_accf ="\u0041l\u006c\u0020\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072u\u0065\u0054\u0079p\u0065\u0020\u0066\u006f\u006e\u0074s\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0061\u006e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0065n\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068e\u0020\u0066\u006f\u006e\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e";
);var _bgde string ;if _dbcb ,_fbcdb :=_cg .GetName (_cfa .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_fbcdb {_bgde =_dbcb .String ();};if _bgde !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cd ;};_abfc :=_cece .FontDescriptor ();_gfbd ,_dged :=_cg .GetIntVal (_abfc .Flags );
if !_dged {_ef .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _fd (_bfeb ,_accf );};_eegb :=(uint32 (_gfbd )>>3)&1;_fbfg :=_eegb !=0;if !_fbfg {return _cd ;};if _cfa .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067")!=nil {return _fd (_bfeb ,_accf );};return _cd ;};type documentColorspaceOptimizeFunc func (_eee *_cbf .Document ,_agg []*_cbf .Image )error ;
type pageColorspaceOptimizeFunc func (_gee *_cbf .Document ,_agee *_cbf .Page ,_fa []*_cbf .Image )error ;func (_dfg *documentImages )hasOnlyDeviceCMYK ()bool {return _dfg ._cge &&!_dfg ._bec &&!_dfg ._gc };func _gccea (_adda *_dg .CompliancePdfReader )ViolatedRule {_adbdb ,_egbf :=_adda .PdfReader .GetTrailer ();
if _egbf !=nil {return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u006d\u0069\u0073s\u0069\u006e\u0067\u0020t\u0072\u0061\u0069\u006c\u0065\u0072\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074");};if _adbdb .Get ("\u0049\u0044")==nil {return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e\u0020\u0027\u0049\u0044\u0027\u0020k\u0065\u0079\u0077o\u0072\u0064");
};if _adbdb .Get ("\u0045n\u0063\u0072\u0079\u0070\u0074")!=nil {return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0032","\u0054\u0068\u0065\u0020\u006b\u0065y\u0077\u006f\u0072\u0064\u0020'\u0045\u006e\u0063\u0072\u0079\u0070t\u0027\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0075\u0073\u0065d\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u002e\u0020");
};return _cd ;};func _ebcd (_ccgg *_dg .CompliancePdfReader )ViolatedRule {if _ccgg .ParserMetadata ().HasDataAfterEOF (){return _fd ("\u0036.\u0031\u002e\u0033\u002d\u0033","\u004e\u006f\u0020\u0064\u0061ta\u0020\u0073h\u0061\u006c\u006c\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0020\u0074\u0068\u0065\u0020\u006c\u0061\u0073\u0074\u0020\u0065\u006e\u0064\u002d\u006f\u0066\u002d\u0066\u0069l\u0065\u0020\u006da\u0072\u006b\u0065\u0072\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0061 \u0073\u0069\u006e\u0067\u006ce\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c \u0065\u006ed\u002do\u0066\u002d\u006c\u0069\u006e\u0065\u0020m\u0061\u0072\u006b\u0065\u0072\u002e");
};return _cd ;};func _adbac (_egaaf *_dg .CompliancePdfReader )(_fafa []ViolatedRule ){var _cbgc ,_bfce ,_dbbf bool ;if _egaaf .ParserMetadata ().HasNonConformantStream (){_fafa =[]ViolatedRule {_fd ("\u0036.\u0031\u002e\u0037\u002d\u0032","T\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020f\u006f\u006cl\u006fw\u0065\u0064\u0020e\u0069\u0074h\u0065\u0072\u0020\u0062\u0079\u0020\u0061 \u0043\u0041\u0052\u0052I\u0041\u0047\u0045\u0020\u0052E\u0054\u0055\u0052\u004e\u0020\u00280\u0044\u0068\u0029\u0020\u0061\u006e\u0064\u0020\u004c\u0049\u004e\u0045\u0020F\u0045\u0045\u0044\u0020\u0028\u0030\u0041\u0068\u0029\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0071\u0075\u0065\u006e\u0063\u0065\u0020o\u0072\u0020\u0062\u0079\u0020\u0061 \u0073\u0069ng\u006c\u0065\u0020\u004cIN\u0045 \u0046\u0045\u0045\u0044 \u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u002e\u0020T\u0068\u0065\u0020e\u006e\u0064\u0073\u0074r\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020p\u0072\u0065\u0063\u0065\u0064\u0065\u0064\u0020\u0062\u0079\u0020\u0061n\u0020\u0045\u004f\u004c \u006d\u0061\u0072\u006b\u0065\u0072\u002e")};
};for _ ,_cbbgc :=range _egaaf .GetObjectNums (){_fegb ,_ :=_egaaf .GetIndirectObjectByNumber (_cbbgc );if _fegb ==nil {continue ;};_gfaf ,_afea :=_cg .GetStream (_fegb );if !_afea {continue ;};if !_cbgc {_ggbg :=_gfaf .Get ("\u004c\u0065\u006e\u0067\u0074\u0068");
if _ggbg ==nil {_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0031","\u006e\u006f\u0020'\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074"));
_cbgc =true ;}else {_ebee ,_cdeg :=_cg .GetIntVal (_ggbg );if !_cdeg {_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0031","s\u0074\u0072\u0065\u0061\u006d\u0020\u0027\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020an\u0020\u0069\u006et\u0065g\u0065\u0072"));
_cbgc =true ;}else {if len (_gfaf .Stream )!=_ebee {_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0031","\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006c\u0065\u006e\u0067th\u0020v\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020m\u0061\u0074\u0063\u0068\u0020\u0074\u0068\u0065\u0020\u0073\u0069\u007a\u0065\u0020\u006f\u0066\u0020t\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d"));
_cbgc =true ;};};};};if !_bfce {if _gfaf .Get ("\u0046")!=nil {_bfce =true ;_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
};if _gfaf .Get ("\u0046F\u0069\u006c\u0074\u0065\u0072")!=nil &&!_bfce {_bfce =true ;_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};if _gfaf .Get ("\u0046\u0044\u0065\u0063\u006f\u0064\u0065\u0050\u0061\u0072\u0061\u006d\u0073")!=nil &&!_bfce {_bfce =true ;_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};};if !_dbbf {_dbgb ,_cedc :=_cg .GetName (_cg .TraceToDirectObject (_gfaf .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if !_cedc {continue ;};if *_dbgb ==_cg .StreamEncodingFilterNameLZW {_dbbf =true ;_fafa =append (_fafa ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0034","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e"));
};};};return _fafa ;};type profile2 struct{_becece standardType ;_fafg Profile2Options ;};func _gdfe (_ecdb *_cg .PdfObjectDictionary )ViolatedRule {const (_cbbd ="\u0036.\u0033\u002e\u0033\u002d\u0032";_gdee ="\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0054y\u0070\u0065\u0020\u0032\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072\u0065\u0020\u0075\u0073\u0065\u0064\u0020f\u006f\u0072 \u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067,\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0046\u006fn\u0074\u0020\u0064\u0069c\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c \u0063\u006f\u006e\u0074\u0061i\u006e\u0020\u0061\u0020\u0043\u0049\u0044\u0054\u006f\u0047\u0049D\u004d\u0061\u0070\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020a\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006d\u0061\u0070\u0070\u0069\u006e\u0067\u0020\u0066\u0072\u006f\u006d\u0020\u0043\u0049\u0044\u0073\u0020\u0074\u006f\u0020\u0067\u006c\u0079\u0070\u0068\u0020\u0069\u006e\u0064\u0069c\u0065\u0073\u0020\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u0049d\u0065\u006e\u0074\u0069\u0074\u0079\u002c\u0020\u0061s d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020P\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072e\u006e\u0063\u0065\u0020\u0054a\u0062\u006c\u0065\u0020\u0035\u002e\u00313";
);var _geag string ;if _eagb ,_edaa :=_cg .GetName (_ecdb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_edaa {_geag =_eagb .String ();};if _geag !="\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032"{return _cd ;};if _ecdb .Get ("C\u0049\u0044\u0054\u006f\u0047\u0049\u0044\u004d\u0061\u0070")==nil {return _fd (_cbbd ,_gdee );
};return _cd ;};func _eggc (_adcb *_dg .CompliancePdfReader )(_dfc []ViolatedRule ){_ddd :=_adcb .ParserMetadata ();if _ddd .HasInvalidSubsectionHeader (){_dfc =append (_dfc ,_fd ("\u0036.\u0031\u002e\u0034\u002d\u0031","\u006e\u0020\u0061\u0020\u0063\u0072\u006f\u0073\u0073\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0073\u0065c\u0074\u0069\u006f\u006e\u0020h\u0065a\u0064\u0065\u0072\u0020t\u0068\u0065\u0020\u0073\u0074\u0061\u0072t\u0069\u006e\u0067\u0020\u006fb\u006a\u0065\u0063\u0074 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0072\u0061n\u0067e\u0020s\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020s\u0069\u006e\u0067\u006c\u0065\u0020\u0053\u0050\u0041C\u0045\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074e\u0072\u0020\u0028\u0032\u0030\u0068\u0029\u002e"));
};if _ddd .HasInvalidSeparationAfterXRef (){_dfc =append (_dfc ,_fd ("\u0036.\u0031\u002e\u0034\u002d\u0032","\u0054\u0068\u0065 \u0078\u0072\u0065\u0066\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0063\u0072\u006f\u0073s\u0020\u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065 s\u0075b\u0073\u0065\u0063ti\u006f\u006e\u0020\u0068\u0065\u0061\u0064e\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079 \u0061\u0020\u0073i\u006e\u0067\u006c\u0065\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u002e"));
};return _dfc ;};func _fbcge (_ggbd *_dg .CompliancePdfReader )(_eefag []ViolatedRule ){var _cbbe ,_fagf ,_afgde ,_ddgb ,_ggfc ,_fdbd ,_bgdfe bool ;_abccc :=map[*_cg .PdfObjectStream ]struct{}{};for _ ,_cggag :=range _ggbd .GetObjectNums (){if _cbbe &&_fagf &&_ggfc &&_afgde &&_ddgb &&_fdbd &&_bgdfe {return _eefag ;
};_ggbbg ,_ccdb :=_ggbd .GetIndirectObjectByNumber (_cggag );if _ccdb !=nil {continue ;};_adcdf ,_edgbe :=_cg .GetStream (_ggbbg );if !_edgbe {continue ;};if _ ,_edgbe =_abccc [_adcdf ];_edgbe {continue ;};_abccc [_adcdf ]=struct{}{};_eeeb ,_edgbe :=_cg .GetName (_adcdf .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));
if !_edgbe {continue ;};if !_ddgb {if _adcdf .Get ("\u0052\u0065\u0066")!=nil {_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0039\u002d\u0032","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e"));
_ddgb =true ;};};if _eeeb .String ()=="\u0050\u0053"{if !_fdbd {_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0039\u002d\u0033","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073."));
_fdbd =true ;continue ;};};if _eeeb .String ()=="\u0046\u006f\u0072\u006d"{if _fagf &&_afgde &&_ddgb {continue ;};if !_fagf &&_adcdf .Get ("\u004f\u0050\u0049")!=nil {_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072\u006d \u0058\u004f\u0062j\u0065\u0063\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u004f\u0050\u0049\u0020\u006b\u0065\u0079\u002e"));
_fagf =true ;};if !_afgde {if _adcdf .Get ("\u0050\u0053")!=nil {_afgde =true ;};if _aabce :=_adcdf .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");_aabce !=nil &&!_afgde {if _egge ,_gfgbcd :=_cg .GetName (_aabce );_gfgbcd &&*_egge =="\u0050\u0053"{_afgde =true ;
};};if _afgde {_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0039\u002d\u0031","\u0041\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065y \u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076\u0061\u006cu\u0065 o\u0066 \u0050\u0053\u0020\u0061\u006e\u0064\u0020t\u0068\u0065\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e"));
};};continue ;};if _eeeb .String ()!="\u0049\u006d\u0061g\u0065"{continue ;};if !_cbbe &&_adcdf .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0038\u002d\u0031","\u0041\u006e\u0020\u0049m\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
_cbbe =true ;};if !_bgdfe &&_adcdf .Get ("\u004f\u0050\u0049")!=nil {_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0038\u002d\u0032","\u0041\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0068\u0065\u0020\u004f\u0050\u0049\u0020\u006b\u0065\u0079\u002e"));
_bgdfe =true ;};if !_ggfc &&_adcdf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065")!=nil {_gada ,_fadg :=_cg .GetBool (_adcdf .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));if _fadg &&bool (*_gada ){continue ;
};_eefag =append (_eefag ,_fd ("\u0036.\u0032\u002e\u0038\u002d\u0033","\u0049\u0066 a\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0063o\u006e\u0074\u0061\u0069n\u0073\u0020\u0074\u0068e \u0049\u006et\u0065r\u0070\u006f\u006c\u0061\u0074\u0065 \u006b\u0065\u0079,\u0020\u0069t\u0073\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020b\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
_ggfc =true ;};};return _eefag ;};func _ecfd (_bgfb *_cbf .Document )error {_fgad ,_fbfb :=_bgfb .FindCatalog ();if !_fbfb {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_eegc ,_fbfb :=_cg .GetDict (_fgad .Object .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073"));
if !_fbfb {return nil ;};_efegb ,_fbfb :=_cg .GetDict (_eegc .Get ("\u0044"));if _fbfb {if _efegb .Get ("\u0041\u0053")!=nil {_efegb .Remove ("\u0041\u0053");};};_bece ,_fbfb :=_cg .GetArray (_eegc .Get ("\u0043o\u006e\u0066\u0069\u0067\u0073"));if _fbfb {for _cbeg :=0;
_cbeg < _bece .Len ();_cbeg ++{_cfbc ,_geef :=_cg .GetDict (_bece .Get (_cbeg ));if !_geef {continue ;};if _cfbc .Get ("\u0041\u0053")!=nil {_cfbc .Remove ("\u0041\u0053");};};};return nil ;};var _cd =ViolatedRule {};func _cf ()standardType {return standardType {_fg :2,_ca :"\u0041"}};


// ApplyStandard tries to change the content of the writer to match the PDF/A-1 standard.
// Implements model.StandardApplier.
func (_bbae *profile1 )ApplyStandard (document *_cbf .Document )(_dead error ){_degg (document ,4);if _dead =_bdd (document ,_bbae ._ceeb .Now );_dead !=nil {return _dead ;};if _dead =_cde (document );_dead !=nil {return _dead ;};_afae ,_fbdc :=_dcdg (_bbae ._ceeb .CMYKDefaultColorSpace ,_bbae ._eab );
_dead =_fce (document ,[]pageColorspaceOptimizeFunc {_ggde ,_afae },[]documentColorspaceOptimizeFunc {_fbdc });if _dead !=nil {return _dead ;};_daed (document );if _dead =_bcg (document ,_bbae ._eab ._fg );_dead !=nil {return _dead ;};if _dead =_cddab (document );
_dead !=nil {return _dead ;};if _dead =_dba (document );_dead !=nil {return _dead ;};if _dead =_bfee (document );_dead !=nil {return _dead ;};if _dead =_bde (document );_dead !=nil {return _dead ;};if _bbae ._eab ._ca =="\u0041"{_dgfd (document );};if _dead =_edfb (document ,_bbae ._eab ._fg );
_dead !=nil {return _dead ;};if _dead =_fbf (document );_dead !=nil {return _dead ;};if _dabe :=_edd (document ,_bbae ._eab ,_bbae ._ceeb .Xmp );_dabe !=nil {return _dabe ;};if _bbae ._eab ==_de (){if _dead =_aaag (document );_dead !=nil {return _dead ;
};};if _dead =_fcdg (document );_dead !=nil {return _dead ;};return nil ;};func _fccdc (_cec *_cbf .Document ,_efbd bool )error {_ffaaa ,_fdac :=_cec .GetPages ();if !_fdac {return nil ;};for _ ,_gfeb :=range _ffaaa {_edg ,_aeb :=_gfeb .GetContents ();
if !_aeb {continue ;};var _ecbc *_dg .PdfPageResources ;_gceb ,_aeb :=_gfeb .GetResources ();if _aeb {_ecbc ,_ =_dg .NewPdfPageResourcesFromDict (_gceb );};for _fccg ,_dga :=range _edg {_fdc ,_acb :=_dga .GetData ();if _acb !=nil {continue ;};_eacg :=_be .NewContentStreamParser (string (_fdc ));
_becg ,_acb :=_eacg .Parse ();if _acb !=nil {continue ;};_dbeg ,_acb :=_bdeg (_ecbc ,_becg ,_efbd );if _acb !=nil {return _acb ;};if _dbeg ==nil {continue ;};if _acb =(&_edg [_fccg ]).SetData (_dbeg );_acb !=nil {return _acb ;};};};return nil ;};func _agdf (_aecc *_dg .CompliancePdfReader )[]ViolatedRule {return nil };


// Profile1B is the implementation of the PDF/A-1B standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile1B struct{profile1 };

// Profile2U is the implementation of the PDF/A-2U standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile2U struct{profile2 };func _fbbfd (_dgbg *_dg .CompliancePdfReader )(_fbfa []ViolatedRule ){return _fbfa };

// NewProfile1B creates a new Profile1B with the given options.
func NewProfile1B (options *Profile1Options )*Profile1B {if options ==nil {options =DefaultProfile1Options ();};_aee (options );return &Profile1B {profile1 {_ceeb :*options ,_eab :_beb ()}};};func _cede (_cbdd *_cbf .Document )error {_fae ,_dbcgg :=_cbdd .FindCatalog ();
if !_dbcgg {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_cgbg ,_dbcgg :=_cg .GetDict (_fae .Object .Get ("\u0050\u0065\u0072m\u0073"));if _dbcgg {_bede :=_cg .MakeDict ();_bbag :=_cgbg .Keys ();
for _ ,_gbcg :=range _bbag {if _gbcg .String ()=="\u0055\u0052\u0033"||_gbcg .String ()=="\u0044\u006f\u0063\u004d\u0044\u0050"{_bede .Set (_gbcg ,_cgbg .Get (_gbcg ));};};_fae .Object .Set ("\u0050\u0065\u0072m\u0073",_bede );};return nil ;};func _bfca (_ecfdf *_dg .PdfFont ,_cbfbe *_cg .PdfObjectDictionary ,_gageb bool )ViolatedRule {const (_cefba ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0034\u002d\u0031";
_fagda ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006ds\u0020\u0066\u006fr\u0020\u0061\u006c\u006c\u0020f\u006f\u006e\u0074\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0066\u006f\u0072\u0020\u0072e\u006e\u0064\u0065\u0072\u0069\u006eg\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020w\u0069t\u0068\u0069\u006e\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u002c \u0061\u0073\u0020\u0064\u0065\u0066\u0069n\u0065\u0064 \u0069\u006e\u0020\u0049S\u004f\u0020\u0033\u0032\u00300\u0030\u002d\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u0020\u0039\u002e\u0039\u002e";
);if _gageb {return _cd ;};_agfdd :=_ecfdf .FontDescriptor ();var _dgabc string ;if _daecg ,_efea :=_cg .GetName (_cbfbe .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_efea {_dgabc =_daecg .String ();};switch _dgabc {case "\u0054\u0079\u0070e\u0031":if _agfdd .FontFile ==nil {return _fd (_cefba ,_fagda );
};case "\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065":if _agfdd .FontFile2 ==nil {return _fd (_cefba ,_fagda );};case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0033":default:if _agfdd .FontFile3 ==nil {return _fd (_cefba ,_fagda );};};return _cd ;
};func _dgdb (_gcee *_dg .CompliancePdfReader )ViolatedRule {_gcdc :=_gcee .ParserMetadata ().HeaderCommentBytes ();if _gcdc [0]> 127&&_gcdc [1]> 127&&_gcdc [2]> 127&&_gcdc [3]> 127{return _cd ;};return _fd ("\u0036.\u0031\u002e\u0032\u002d\u0032","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061\u0064\u0065\u0072\u0020\u006c\u0069\u006e\u0065\u0020\u0073\u0068\u0061\u006c\u006c b\u0065\u0020i\u006d\u006d\u0065\u0064\u0069a\u0074\u0065\u006c\u0079 \u0066\u006f\u006c\u006co\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0063\u006f\u006d\u006d\u0065n\u0074\u0020\u0063\u006f\u006e\u0073\u0069s\u0074\u0069\u006e\u0067\u0020o\u0066\u0020\u0061\u0020\u0025\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0066\u006f\u006c\u006c\u006fwe\u0064\u0020\u0062y\u0020a\u0074\u0009\u006c\u0065a\u0073\u0074\u0020f\u006f\u0075\u0072\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u002c\u0020e\u0061\u0063\u0068\u0020\u006f\u0066\u0020\u0077\u0068\u006f\u0073\u0065 \u0065\u006e\u0063\u006f\u0064e\u0064\u0020\u0062\u0079\u0074e\u0020\u0076\u0061\u006c\u0075\u0065s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u0020\u0064e\u0063\u0069\u006d\u0061\u006c \u0076\u0061\u006c\u0075\u0065\u0020\u0067\u0072\u0065\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u0032\u0037\u002e");
};func _edff (_bedfc *_cg .PdfObjectDictionary ,_ffdc map[*_cg .PdfObjectStream ][]byte ,_cagc map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_dggcg ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0034";_abeec ="\u0046\u006f\u0072\u0020\u0074\u0068\u006fs\u0065\u0020\u0043\u004d\u0061\u0070\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072e\u0020\u0065m\u0062\u0065\u0064de\u0064\u002c\u0020\u0074\u0068\u0065\u0020\u0069\u006et\u0065\u0067\u0065\u0072 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0057\u004d\u006f\u0064\u0065\u0020\u0065\u006e\u0074r\u0079\u0020i\u006e t\u0068\u0065\u0020CM\u0061\u0070\u0020\u0064\u0069\u0063\u0074\u0069o\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u0020\u0074\u006f \u0074h\u0065\u0020\u0057\u004d\u006f\u0064e\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064ed\u0020\u0043\u004d\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e";
);var _cfbe string ;if _acfb ,_cggeg :=_cg .GetName (_bedfc .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_cggeg {_cfbe =_acfb .String ();};if _cfbe !="\u0054\u0079\u0070e\u0030"{return _cd ;};_efcfd :=_bedfc .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ ,_cefde :=_cg .GetName (_efcfd );_cefde {return _cd ;};_gcde ,_fcdfa :=_cg .GetStream (_efcfd );if !_fcdfa {return _fd (_dggcg ,_abeec );};_gaae ,_gcda :=_cefgf (_gcde ,_ffdc ,_cagc );if _gcda !=nil {return _fd (_dggcg ,_abeec );};_bagdg ,_ccbbd :=_cg .GetIntVal (_gcde .Get ("\u0057\u004d\u006fd\u0065"));
_babc ,_fdgd :=_gaae .WMode ();if _ccbbd &&_fdgd {if _babc !=_bagdg {return _fd (_dggcg ,_abeec );};};if (_ccbbd &&!_fdgd )||(!_ccbbd &&_fdgd ){return _fd (_dggcg ,_abeec );};return _cd ;};func _eacgf (_bgbb *_dg .CompliancePdfReader )(_bfbdf []ViolatedRule ){return _bfbdf };
func _dgfd (_bcbd *_cbf .Document ){_bfed ,_aead :=_bcbd .FindCatalog ();if !_aead {return ;};_dbbd ,_aead :=_bfed .GetMarkInfo ();if !_aead {_dbbd =_cg .MakeDict ();};_ddee ,_aead :=_cg .GetBool (_dbbd .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));if !_aead ||!bool (*_ddee ){_dbbd .Set ("\u004d\u0061\u0072\u006b\u0065\u0064",_cg .MakeBool (true ));
_bfed .SetMarkInfo (_dbbd );};};

// ApplyStandard tries to change the content of the writer to match the PDF/A-2 standard.
// Implements model.StandardApplier.
func (_ecga *profile2 )ApplyStandard (document *_cbf .Document )(_ebda error ){_degg (document ,7);if _ebda =_bdd (document ,_ecga ._fafg .Now );_ebda !=nil {return _ebda ;};if _ebda =_cde (document );_ebda !=nil {return _ebda ;};_bcffb ,_caee :=_dcdg (_ecga ._fafg .CMYKDefaultColorSpace ,_ecga ._becece );
_ebda =_fce (document ,[]pageColorspaceOptimizeFunc {_bcffb },[]documentColorspaceOptimizeFunc {_caee });if _ebda !=nil {return _ebda ;};_daed (document );if _ebda =_cede (document );_ebda !=nil {return _ebda ;};if _ebda =_bcg (document ,_ecga ._becece ._fg );
_ebda !=nil {return _ebda ;};if _ebda =_agbd (document );_ebda !=nil {return _ebda ;};if _ebda =_ccbb (document );_ebda !=nil {return _ebda ;};if _ebda =_bde (document );_ebda !=nil {return _ebda ;};if _ebda =_efgb (document );_ebda !=nil {return _ebda ;
};if _ecga ._becece ._ca =="\u0041"{_dgfd (document );};if _ebda =_edfb (document ,_ecga ._becece ._fg );_ebda !=nil {return _ebda ;};if _ebda =_fbf (document );_ebda !=nil {return _ebda ;};if _bdee :=_edd (document ,_ecga ._becece ,_ecga ._fafg .Xmp );
_bdee !=nil {return _bdee ;};if _ecga ._becece ==_cf (){if _ebda =_aaag (document );_ebda !=nil {return _ebda ;};};if _ebda =_ecfd (document );_ebda !=nil {return _ebda ;};if _ebda =_feg (document );_ebda !=nil {return _ebda ;};if _ebda =_gfcaa (document );
_ebda !=nil {return _ebda ;};return nil ;};func _bfde (_ccfa *_dg .CompliancePdfReader )(_aca []ViolatedRule ){var _aegg ,_gccg ,_bddc bool ;if _ccfa .ParserMetadata ().HasNonConformantStream (){_aca =[]ViolatedRule {_fd ("\u0036.\u0031\u002e\u0037\u002d\u0031","T\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020f\u006f\u006cl\u006fw\u0065\u0064\u0020e\u0069\u0074h\u0065\u0072\u0020\u0062\u0079\u0020\u0061 \u0043\u0041\u0052\u0052I\u0041\u0047\u0045\u0020\u0052E\u0054\u0055\u0052\u004e\u0020\u00280\u0044\u0068\u0029\u0020\u0061\u006e\u0064\u0020\u004c\u0049\u004e\u0045\u0020F\u0045\u0045\u0044\u0020\u0028\u0030\u0041\u0068\u0029\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0071\u0075\u0065\u006e\u0063\u0065\u0020o\u0072\u0020\u0062\u0079\u0020\u0061 \u0073\u0069ng\u006c\u0065\u0020\u004cIN\u0045 \u0046\u0045\u0045\u0044 \u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u002e\u0020T\u0068\u0065\u0020e\u006e\u0064\u0073\u0074r\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020p\u0072\u0065\u0063\u0065\u0064\u0065\u0064\u0020\u0062\u0079\u0020\u0061n\u0020\u0045\u004f\u004c \u006d\u0061\u0072\u006b\u0065\u0072\u002e")};
};for _ ,_dcbd :=range _ccfa .GetObjectNums (){_gcab ,_ :=_ccfa .GetIndirectObjectByNumber (_dcbd );if _gcab ==nil {continue ;};_beec ,_gbfe :=_cg .GetStream (_gcab );if !_gbfe {continue ;};if !_aegg {_bagg :=_beec .Get ("\u004c\u0065\u006e\u0067\u0074\u0068");
if _bagg ==nil {_aca =append (_aca ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0032","\u006e\u006f\u0020'\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074"));
_aegg =true ;}else {_bggg ,_abgb :=_cg .GetIntVal (_bagg );if !_abgb {_aca =append (_aca ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0032","s\u0074\u0072\u0065\u0061\u006d\u0020\u0027\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020an\u0020\u0069\u006et\u0065g\u0065\u0072"));
_aegg =true ;}else {if len (_beec .Stream )!=_bggg {_aca =append (_aca ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0032","\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006c\u0065\u006e\u0067th\u0020v\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020m\u0061\u0074\u0063\u0068\u0020\u0074\u0068\u0065\u0020\u0073\u0069\u007a\u0065\u0020\u006f\u0066\u0020t\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d"));
_aegg =true ;};};};};if !_gccg {if _beec .Get ("\u0046")!=nil {_gccg =true ;_aca =append (_aca ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
};if _beec .Get ("\u0046F\u0069\u006c\u0074\u0065\u0072")!=nil &&!_gccg {_gccg =true ;_aca =append (_aca ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};if _beec .Get ("\u0046\u0044\u0065\u0063\u006f\u0064\u0065\u0050\u0061\u0072\u0061\u006d\u0073")!=nil &&!_gccg {_gccg =true ;_aca =append (_aca ,_fd ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};};if !_bddc {_dgdbb ,_ggef :=_cg .GetName (_cg .TraceToDirectObject (_beec .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if !_ggef {continue ;};if *_dgdbb ==_cg .StreamEncodingFilterNameLZW {_bddc =true ;_aca =append (_aca ,_fd ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0031","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e"));
};};};return _aca ;};func _cbgac (_gdfcg *_dg .CompliancePdfReader ,_bdbgf standardType ,_fgdaf bool )(_cgdcd []ViolatedRule ){_gddfa ,_gdgf :=_febce (_gdfcg );if !_gdgf {return []ViolatedRule {_fd ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d1","\u0063a\u0074a\u006c\u006f\u0067\u0020\u006eo\u0074\u0020f\u006f\u0075\u006e\u0064\u002e")};
};_dedee :=_gddfa .Get ("\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061");if _dedee ==nil {return []ViolatedRule {_fd ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d1","\u0054\u0068\u0065\u0020\u0043\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u006f\u0066\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074ai\u006e\u0020\u0074\u0068\u0065\u0020\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0068\u006f\u0073\u0065\u0020v\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0061\u0020m\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020s\u0074\u0072\u0065\u0061\u006d")};
};_efdba ,_gdgf :=_cg .GetStream (_dedee );if !_gdgf {return []ViolatedRule {_fd ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d1","\u0054\u0068\u0065\u0020\u0043\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u006f\u0066\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074ai\u006e\u0020\u0074\u0068\u0065\u0020\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0068\u006f\u0073\u0065\u0020v\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0061\u0020m\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0020s\u0074\u0072\u0065\u0061\u006d")};
};_ecgbc ,_eacf :=_egf .LoadDocument (_efdba .Stream );if _eacf !=nil {return []ViolatedRule {_fd ("\u0036.\u0036\u002e\u0032\u002e\u0031\u002d4","\u0041\u006c\u006c\u0020\u006de\u0074\u0061\u0064a\u0074\u0061\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0073\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020i\u006e \u0074\u0068\u0065\u0020\u0050\u0044\u0046 \u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0066\u006f\u0072\u006d\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065ci\u0066\u0069\u0063\u0061\u0074\u0069\u006fn\u002e\u0020\u0041\u006c\u006c\u0020c\u006fn\u0074\u0065\u006e\u0074\u0020\u006f\u0066\u0020\u0061\u006c\u006c\u0020\u0058\u004d\u0050\u0020p\u0061\u0063\u006b\u0065\u0074\u0073 \u0073h\u0061\u006c\u006c \u0062\u0065\u0020\u0077\u0065\u006c\u006c\u002d\u0066o\u0072\u006de\u0064")};
};_ggbdda :=_ecgbc .GetGoXmpDocument ();var _egdgf []*_df .Namespace ;for _ ,_eegfa :=range _ggbdda .Namespaces (){switch _eegfa .Name {case _b .NsDc .Name ,_ede .NsPDF .Name ,_cb .NsXmp .Name ,_c .NsXmpRights .Name ,_efc .Namespace .Name ,_gb .Namespace .Name ,_cc .NsXmpMM .Name ,_gb .FieldNS .Name ,_gb .SchemaNS .Name ,_gb .PropertyNS .Name ,"\u0073\u0074\u0045v\u0074","\u0073\u0074\u0056e\u0072","\u0073\u0074\u0052e\u0066","\u0073\u0074\u0044i\u006d","\u0078a\u0070\u0047\u0049\u006d\u0067","\u0073\u0074\u004ao\u0062","\u0078\u006d\u0070\u0069\u0064\u0071":continue ;
};_egdgf =append (_egdgf ,_eegfa );};_gcbd :=true ;_aceca ,_eacf :=_ecgbc .GetPdfaExtensionSchemas ();if _eacf ==nil {for _ ,_gfbf :=range _egdgf {var _fdaag bool ;for _dgdg :=range _aceca {if _gfbf .URI ==_aceca [_dgdg ].NamespaceURI {_fdaag =true ;break ;
};};if !_fdaag {_gcbd =false ;break ;};};}else {_gcbd =false ;};if !_gcbd {_cgdcd =append (_cgdcd ,_fd ("\u0036.\u0036\u002e\u0032\u002e\u0033\u002d7","\u0041\u006c\u006c\u0020\u0070\u0072\u006f\u0070e\u0072\u0074\u0069e\u0073\u0020\u0073\u0070\u0065\u0063i\u0066\u0069\u0065\u0064\u0020\u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072m\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0075s\u0065\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0073\u0063he\u006da\u0073 \u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u002c\u0020\u0049\u0053\u004f\u0020\u0031\u00390\u0030\u0035-\u0031\u0020\u006f\u0072\u0020\u0074h\u0069s\u0020\u0070\u0061\u0072\u0074\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u0020\u0031\u0039\u0030\u0030\u0035\u002c\u0020o\u0072\u0020\u0061\u006e\u0079\u0020e\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073c\u0068\u0065\u006das\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006fm\u0070\u006c\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0036\u002e\u0036\u002e\u0032.\u0033\u002e\u0032\u002e"));
};_dacfe ,_gdgf :=_ecgbc .GetPdfAID ();if !_gdgf {_cgdcd =append (_cgdcd ,_fd ("\u0036.\u0036\u002e\u0034\u002d\u0031","\u0054\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u0061n\u0064\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020\u006c\u0065\u0076\u0065l\u0020\u006f\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0070e\u0063\u0069\u0066\u0069\u0065\u0064\u0020\u0075\u0073\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073\u0063h\u0065\u006da."));
}else {if _dacfe .Part !=_bdbgf ._fg {_cgdcd =append (_cgdcd ,_fd ("\u0036.\u0036\u002e\u0034\u002d\u0032","\u0054h\u0065\u0020\u0076\u0061lue\u0020\u006f\u0066\u0020p\u0064\u0066\u0061\u0069\u0064\u003a\u0070\u0061\u0072\u0074 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0061\u0072\u0074\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u002019\u0030\u0030\u0035 \u0074\u006f\u0020\u0077\u0068i\u0063h\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065 \u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0073\u002e"));
};if _bdbgf ._ca =="\u0041"&&_dacfe .Conformance !="\u0041"{_cgdcd =append (_cgdcd ,_fd ("\u0036.\u0036\u002e\u0034\u002d\u0033","\u0041\u0020\u004c\u0065\u0076\u0065\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061l\u006c\u0020\u0073\u0070ec\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020as\u0020\u0041\u002e\u0020\u0041 \u004c\u0065v\u0065\u006c\u0020\u0042\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061lu\u0065\u0020o\u0066 \u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e\u0020\u0041\u0020\u004c\u0065\u0076\u0065\u006c \u0055\u0020\u0063\u006f\u006e\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063\u0069\u0066\u0079 \u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0070\u0064f\u0061i\u0064\u003ac\u006fn\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065 \u0061\u0073\u0020\u0055."));
}else if _bdbgf ._ca =="\u0055"&&(_dacfe .Conformance !="\u0041"&&_dacfe .Conformance !="\u0055"){_cgdcd =append (_cgdcd ,_fd ("\u0036.\u0036\u002e\u0034\u002d\u0033","\u0041\u0020\u004c\u0065\u0076\u0065\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061l\u006c\u0020\u0073\u0070ec\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020as\u0020\u0041\u002e\u0020\u0041 \u004c\u0065v\u0065\u006c\u0020\u0042\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061lu\u0065\u0020o\u0066 \u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e\u0020\u0041\u0020\u004c\u0065\u0076\u0065\u006c \u0055\u0020\u0063\u006f\u006e\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063\u0069\u0066\u0079 \u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0070\u0064f\u0061i\u0064\u003ac\u006fn\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065 \u0061\u0073\u0020\u0055."));
}else if _bdbgf ._ca =="\u0042"&&(_dacfe .Conformance !="\u0041"&&_dacfe .Conformance !="\u0042"&&_dacfe .Conformance !="\u0055"){_cgdcd =append (_cgdcd ,_fd ("\u0036.\u0036\u002e\u0034\u002d\u0033","\u0041\u0020\u004c\u0065\u0076\u0065\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061l\u006c\u0020\u0073\u0070ec\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020as\u0020\u0041\u002e\u0020\u0041 \u004c\u0065v\u0065\u006c\u0020\u0042\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061lu\u0065\u0020o\u0066 \u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e\u0020\u0041\u0020\u004c\u0065\u0076\u0065\u006c \u0055\u0020\u0063\u006f\u006e\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063\u0069\u0066\u0079 \u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0070\u0064f\u0061i\u0064\u003ac\u006fn\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065 \u0061\u0073\u0020\u0055."));
};};return _cgdcd ;};func _ggcf (_bceb *_dg .CompliancePdfReader )(_ebcg []ViolatedRule ){var _aage ,_efgge ,_gfdde ,_cbegd bool ;_cagge :=func ()bool {return _aage &&_efgge &&_gfdde &&_cbegd };_cabfe ,_aeae :=_afaag (_bceb );var _bfbgd _bg .ProfileHeader ;
if _aeae {_bfbgd ,_ =_bg .ParseHeader (_cabfe .DestOutputProfile );};_gfef :=map[_cg .PdfObject ]struct{}{};var _ebcb func (_afed _dg .PdfColorspace )bool ;_ebcb =func (_ccbc _dg .PdfColorspace )bool {switch _aefd :=_ccbc .(type ){case *_dg .PdfColorspaceDeviceGray :if !_aage {if !_aeae {_ebcg =append (_ebcg ,_fd ("\u0036.\u0032\u002e\u0034\u002e\u0033\u002d4","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006f\u006e\u006c\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064 \u0069\u0066\u0020\u0061\u0020\u0064\u0065v\u0069\u0063\u0065\u0020\u0069\u006e\u0064\u0065p\u0065\u006e\u0064\u0065\u006e\u0074\u0020\u0044\u0065\u0066\u0061\u0075\u006c\u0074\u0047\u0072\u0061\u0079\u0020\u0063\u006f\u006c\u006f\u0075r \u0073\u0070\u0061\u0063\u0065\u0020\u0068\u0061\u0073\u0020\u0062\u0065\u0065\u006e \u0073\u0065\u0074\u0020\u0077\u0068\u0065n \u0074\u0068\u0065\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072a\u0079\u0020\u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u002c o\u0072\u0020\u0069\u0066\u0020\u0061\u0020\u0050\u0044\u0046\u002fA\u0020\u004f\u0075tp\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0069\u0073\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u002e"));
_aage =true ;if _cagge (){return true ;};};};case *_dg .PdfColorspaceDeviceRGB :if !_efgge {if !_aeae ||_bfbgd .ColorSpace !=_bg .ColorSpaceRGB {_ebcg =append (_ebcg ,_fd ("\u0036.\u0032\u002e\u0034\u002e\u0033\u002d2","\u0044\u0065\u0076\u0069c\u0065\u0052\u0047\u0042\u0020\u0073\u0068\u0061\u006cl\u0020\u006f\u006e\u006c\u0079\u0020\u0062e\u0020\u0075\u0073\u0065\u0064\u0020\u0069f\u0020\u0061\u0020\u0064\u0065\u0076\u0069\u0063e\u0020\u0069n\u0064\u0065\u0070e\u006e\u0064\u0065\u006et \u0044\u0065\u0066\u0061\u0075\u006c\u0074\u0052\u0047\u0042\u0020\u0063\u006fl\u006f\u0075r\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0068\u0061\u0073\u0020b\u0065\u0065\u006e\u0020s\u0065\u0074 \u0077\u0068\u0065\u006e\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u0052\u0047\u0042\u0020c\u006flou\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020i\u0073\u0020\u0075\u0073\u0065\u0064\u002c\u0020\u006f\u0072\u0020if\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044F\u002f\u0041\u0020\u004fut\u0070\u0075\u0074\u0049\u006e\u0074\u0065n\u0074\u0020t\u0068\u0061t\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0061\u006e\u0020\u0052\u0047\u0042\u0020\u0064\u0065\u0073\u0074\u0069\u006e\u0061\u0074io\u006e\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u002e"));
_efgge =true ;if _cagge (){return true ;};};};case *_dg .PdfColorspaceDeviceCMYK :if !_gfdde {if !_aeae ||_bfbgd .ColorSpace !=_bg .ColorSpaceCMYK {_ebcg =append (_ebcg ,_fd ("\u0036.\u0032\u002e\u0034\u002e\u0033\u002d3","\u0044e\u0076\u0069c\u0065\u0043\u004d\u0059\u004b\u0020\u0073hal\u006c\u0020\u006f\u006e\u006c\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u0066\u0020\u0061\u0020\u0064\u0065\u0076\u0069\u0063\u0065\u0020\u0069\u006e\u0064\u0065\u0070\u0065\u006e\u0064\u0065\u006e\u0074\u0020\u0044ef\u0061\u0075\u006c\u0074\u0043\u004d\u0059K\u0020\u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0068\u0061s\u0020\u0062\u0065\u0065\u006e \u0073\u0065\u0074\u0020\u006fr \u0069\u0066\u0020\u0061\u0020\u0044e\u0076\u0069\u0063\u0065\u004e\u002d\u0062\u0061\u0073\u0065\u0064\u0020\u0044\u0065f\u0061\u0075\u006c\u0074\u0043\u004d\u0059\u004b\u0020c\u006f\u006c\u006f\u0075r\u0020\u0073\u0070\u0061\u0063e\u0020\u0068\u0061\u0073\u0020\u0062\u0065\u0065\u006e\u0020\u0073\u0065\u0074\u0020\u0077\u0068\u0065\u006e\u0020\u0074h\u0065\u0020\u0044\u0065\u0076\u0069c\u0065\u0043\u004d\u0059\u004b\u0020c\u006f\u006c\u006fu\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u0072\u0020t\u0068\u0065\u0020\u0066\u0069l\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0073\u0020\u0061\u0020\u0043\u004d\u0059\u004b\u0020d\u0065\u0073\u0074\u0069\u006e\u0061t\u0069\u006f\u006e\u0020\u0070r\u006f\u0066\u0069\u006c\u0065\u002e"));
_gfdde =true ;if _cagge (){return true ;};};};case *_dg .PdfColorspaceICCBased :if !_cbegd {_baac ,_bbge :=_bg .ParseHeader (_aefd .Data );if _bbge !=nil {_ef .Log .Debug ("\u0070\u0061\u0072si\u006e\u0067\u0020\u0049\u0043\u0043\u0042\u0061\u0073e\u0064 \u0068e\u0061d\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_bbge );
_ebcg =append (_ebcg ,func ()ViolatedRule {return _fd ("\u0036.\u0032\u002e\u0034\u002e\u0032\u002d1","\u0054\u0068e\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0074\u0068\u0061\u0074\u0020\u0066o\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0073\u0074r\u0065\u0061\u006d o\u0066\u0020\u0061\u006e\u0020\u0049C\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006fl\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0049\u0043\u0043.\u0031\u003a\u0031\u0039\u0039\u0038-\u0030\u0039,\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0031\u002d\u00312\u002c\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0033\u002d\u0030\u0039\u0020\u006f\u0072\u0020I\u0053\u004f\u0020\u0031\u0035\u0030\u0037\u0036\u002d\u0031\u002e");
}());_cbegd =true ;if _cagge (){return true ;};};if !_cbegd {var _feggc ,_fdgfc bool ;switch _baac .DeviceClass {case _bg .DeviceClassPRTR ,_bg .DeviceClassMNTR ,_bg .DeviceClassSCNR ,_bg .DeviceClassSPAC :default:_feggc =true ;};switch _baac .ColorSpace {case _bg .ColorSpaceRGB ,_bg .ColorSpaceCMYK ,_bg .ColorSpaceGRAY ,_bg .ColorSpaceLAB :default:_fdgfc =true ;
};if _feggc ||_fdgfc {_ebcg =append (_ebcg ,_fd ("\u0036.\u0032\u002e\u0034\u002e\u0032\u002d1","\u0054\u0068e\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0074\u0068\u0061\u0074\u0020\u0066o\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0073\u0074r\u0065\u0061\u006d o\u0066\u0020\u0061\u006e\u0020\u0049C\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006fl\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0049\u0043\u0043.\u0031\u003a\u0031\u0039\u0039\u0038-\u0030\u0039,\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0031\u002d\u00312\u002c\u0020\u0049\u0043\u0043\u002e\u0031\u003a\u0032\u0030\u0030\u0033\u002d\u0030\u0039\u0020\u006f\u0072\u0020I\u0053\u004f\u0020\u0031\u0035\u0030\u0037\u0036\u002d\u0031\u002e"));
_cbegd =true ;if _cagge (){return true ;};};};};if _aefd .Alternate !=nil {return _ebcb (_aefd .Alternate );};};return false ;};for _ ,_abccf :=range _bceb .GetObjectNums (){_dabc ,_gbfb :=_bceb .GetIndirectObjectByNumber (_abccf );if _gbfb !=nil {continue ;
};_badd ,_gbca :=_cg .GetStream (_dabc );if !_gbca {continue ;};_afeag ,_gbca :=_cg .GetName (_badd .Get ("\u0054\u0079\u0070\u0065"));if !_gbca ||_afeag .String ()!="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_adad ,_gbca :=_cg .GetName (_badd .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_gbca {continue ;};_gfef [_badd ]=struct{}{};switch _adad .String (){case "\u0049\u006d\u0061g\u0065":_bdba ,_beca :=_dg .NewXObjectImageFromStream (_badd );if _beca !=nil {continue ;};_gfef [_badd ]=struct{}{};if _ebcb (_bdba .ColorSpace ){return _ebcg ;
};case "\u0046\u006f\u0072\u006d":_dbaee ,_eefd :=_cg .GetDict (_badd .Get ("\u0047\u0072\u006fu\u0070"));if !_eefd {continue ;};_bbaeb :=_dbaee .Get ("\u0043\u0053");if _bbaeb ==nil {continue ;};_bfccd ,_efad :=_dg .NewPdfColorspaceFromPdfObject (_bbaeb );
if _efad !=nil {continue ;};if _ebcb (_bfccd ){return _ebcg ;};};};for _ ,_gfbba :=range _bceb .PageList {_ebae ,_bebd :=_gfbba .GetContentStreams ();if _bebd !=nil {continue ;};for _ ,_dgcf :=range _ebae {_ebbce ,_bfgd :=_be .NewContentStreamParser (_dgcf ).Parse ();
if _bfgd !=nil {continue ;};for _ ,_fdeb :=range *_ebbce {if len (_fdeb .Params )> 1{continue ;};switch _fdeb .Operand {case "\u0042\u0049":_dgea ,_cffa :=_fdeb .Params [0].(*_be .ContentStreamInlineImage );if !_cffa {continue ;};_aaff ,_ggee :=_dgea .GetColorSpace (_gfbba .Resources );
if _ggee !=nil {continue ;};if _ebcb (_aaff ){return _ebcg ;};case "\u0044\u006f":_afaee ,_fbbbf :=_cg .GetName (_fdeb .Params [0]);if !_fbbbf {continue ;};_adbce ,_edab :=_gfbba .Resources .GetXObjectByName (*_afaee );if _ ,_edae :=_gfef [_adbce ];_edae {continue ;
};switch _edab {case _dg .XObjectTypeImage :_gdcg ,_facg :=_dg .NewXObjectImageFromStream (_adbce );if _facg !=nil {continue ;};_gfef [_adbce ]=struct{}{};if _ebcb (_gdcg .ColorSpace ){return _ebcg ;};case _dg .XObjectTypeForm :_bfff ,_cbafe :=_cg .GetDict (_adbce .Get ("\u0047\u0072\u006fu\u0070"));
if !_cbafe {continue ;};_deggg ,_cbafe :=_cg .GetName (_bfff .Get ("\u0043\u0053"));if !_cbafe {continue ;};_ddbeg ,_adcc :=_dg .NewPdfColorspaceFromPdfObject (_deggg );if _adcc !=nil {continue ;};_gfef [_adbce ]=struct{}{};if _ebcb (_ddbeg ){return _ebcg ;
};};};};};};return _ebcg ;};

// ViolatedRule is the structure that defines violated PDF/A rule.
type ViolatedRule struct{RuleNo string ;Detail string ;};type colorspaceModification struct{_ba _eb .ColorConverter ;_ec _dg .PdfColorspace ;};func _dccg (_efdd *_dg .PdfFont ,_gcfc *_cg .PdfObjectDictionary ,_cage bool )ViolatedRule {const (_cddag ="\u0036.\u0033\u002e\u0034\u002d\u0031";
_aaegc ="\u0054\u0068\u0065\u0020\u0066\u006f\u006et\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006d\u0073\u0020\u0066\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0077\u0069\u0074\u0068\u0069\u006e \u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069l\u0065\u0020s\u0068\u0061\u006cl\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0077\u0069\u0074\u0068i\u006e\u0020\u0074h\u0061\u0074\u0020\u0066\u0069\u006ce\u002c\u0020a\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052e\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0035\u002e\u0038\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0077h\u0065\u006e\u0020\u0074\u0068\u0065 \u0066\u006f\u006e\u0074\u0073\u0020\u0061\u0072\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0065\u0078\u0063\u006cu\u0073i\u0076\u0065\u006c\u0079\u0020\u0077\u0069t\u0068\u0020\u0074\u0065\u0078\u0074\u0020\u0072e\u006ed\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020\u0033\u002e";
);if _cage {return _cd ;};_acae :=_efdd .FontDescriptor ();var _caag string ;if _fgda ,_ebedb :=_cg .GetName (_gcfc .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_ebedb {_caag =_fgda .String ();};switch _caag {case "\u0054\u0079\u0070e\u0031":if _acae .FontFile ==nil {return _fd (_cddag ,_aaegc );
};case "\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065":if _acae .FontFile2 ==nil {return _fd (_cddag ,_aaegc );};case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0033":default:if _acae .FontFile3 ==nil {return _fd (_cddag ,_aaegc );};};return _cd ;
};

// Profile1A is the implementation of the PDF/A-1A standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile1A struct{profile1 };func _fce (_gbc *_cbf .Document ,_edde []pageColorspaceOptimizeFunc ,_ebg []documentColorspaceOptimizeFunc )error {_bcd ,_fdbb :=_gbc .GetPages ();if !_fdbb {return nil ;};var _adee []*_cbf .Image ;for _debe ,_acg :=range _bcd {_bcb ,_dbcg :=_acg .FindXObjectImages ();
if _dbcg !=nil {return _dbcg ;};for _ ,_gce :=range _edde {if _dbcg =_gce (_gbc ,&_bcd [_debe ],_bcb );_dbcg !=nil {return _dbcg ;};};_adee =append (_adee ,_bcb ...);};for _ ,_gdfc :=range _ebg {if _agaf :=_gdfc (_gbc ,_adee );_agaf !=nil {return _agaf ;
};};return nil ;};var _ Profile =(*Profile1A )(nil );func _gbee (_fafda *_dg .CompliancePdfReader )(_bbfge []ViolatedRule ){var _cagga ,_ccada ,_fbcfc ,_dade ,_effdc ,_beac ,_gddg bool ;_cafb :=func ()bool {return _cagga &&_ccada &&_fbcfc &&_dade &&_effdc &&_beac &&_gddg };
for _ ,_fabgg :=range _fafda .PageList {_fgcc ,_eegge :=_fabgg .GetAnnotations ();if _eegge !=nil {_ef .Log .Trace ("\u006c\u006f\u0061\u0064\u0069\u006e\u0067\u0020\u0061\u006en\u006f\u0074\u0061\u0074\u0069\u006f\u006es\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_eegge );
continue ;};for _ ,_bfcgc :=range _fgcc {if !_cagga {switch _bfcgc .GetContext ().(type ){case *_dg .PdfAnnotationScreen ,*_dg .PdfAnnotation3D ,*_dg .PdfAnnotationSound ,*_dg .PdfAnnotationMovie ,nil :_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0031\u002d\u0031","\u0041nn\u006f\u0074\u0061\u0074i\u006f\u006e t\u0079\u0070\u0065\u0073\u0020\u006e\u006f\u0074\u0020\u0064\u0065f\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072e\u006e\u0063\u0065\u0020\u0073\u0068\u0061\u006cl\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065r\u006d\u0069t\u0074\u0065\u0064\u002e\u0020\u0041\u0064d\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0033\u0044\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u0053\u0063\u0072\u0065\u0065\u006e\u0020\u0061n\u0064\u0020\u004d\u006f\u0076\u0069\u0065\u0020\u0074\u0079\u0070\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_cagga =true ;if _cafb (){return _bbfge ;};};};_efagb ,_gbge :=_cg .GetDict (_bfcgc .GetContainingPdfObject ());if !_gbge {continue ;};_ ,_afdgf :=_bfcgc .GetContext ().(*_dg .PdfAnnotationPopup );if !_afdgf &&!_ccada {_ ,_gfdf :=_cg .GetIntVal (_efagb .Get ("\u0046"));
if !_gfdf {_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0045\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072i\u0065\u0073\u0020\u0077\u0068\u006fs\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u0076\u0061l\u0075\u0065\u0020\u0069\u0073\u0020\u0050\u006f\u0070u\u0070\u002c\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0046 \u006b\u0065y."));
_ccada =true ;if _cafb (){return _bbfge ;};};};if !_fbcfc {_gcdad ,_bdfa :=_cg .GetIntVal (_efagb .Get ("\u0046"));if _bdfa &&!(_gcdad &4==4&&_gcdad &1==0&&_gcdad &2==0&&_gcdad &32==0&&_gcdad &256==0){_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0032","I\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u0020\u0046 \u006b\u0065\u0079\u0027\u0073\u0020\u0050\u0072\u0069\u006e\u0074\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0020\u0073\u0068\u0061l\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0074\u0020\u0074\u006f\u0020\u0031\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0048\u0069\u0064\u0064\u0065\u006e\u002c\u0020\u0049\u006e\u0076\u0069\u0073\u0069\u0062\u006c\u0065\u002c\u0020\u0054\u006f\u0067\u0067\u006c\u0065\u004e\u006f\u0056\u0069\u0065\u0077\u002c\u0020\u0061\u006e\u0064 \u004eo\u0056\u0069\u0065\u0077\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020s\u0065\u0074\u0020t\u006f\u0020\u0030."));
_fbcfc =true ;if _cafb (){return _bbfge ;};};};_ ,_dbfdd :=_bfcgc .GetContext ().(*_dg .PdfAnnotationText );if _dbfdd &&!_dade {_cbca ,_abeea :=_cg .GetIntVal (_efagb .Get ("\u0046"));if _abeea &&!(_cbca &8==8&&_cbca &16==16){_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0032\u002d\u0033","\u0054\u0065\u0078\u0074\u0020a\u006e\u006e\u006f\u0074\u0061t\u0069o\u006e\u0020\u0068\u0061\u0073\u0020\u006f\u006e\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006ca\u0067\u0073\u0020\u004e\u006f\u005a\u006f\u006f\u006d\u0020\u006f\u0072\u0020\u004e\u006f\u0052\u006f\u0074\u0061\u0074\u0065\u0020\u0073\u0065t\u0020\u0074\u006f\u0020\u0030\u002e"));
_dade =true ;if _cafb (){return _bbfge ;};};};if !_effdc {_gaage ,_fagff :=_cg .GetDict (_efagb .Get ("\u0041\u0050"));if _fagff {_dgfcd :=_gaage .Get ("\u004e");if _dgfcd ==nil ||len (_gaage .Keys ())> 1{_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0033\u002d\u0032","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_effdc =true ;if _cafb (){return _bbfge ;};continue ;};_ ,_gfga :=_bfcgc .GetContext ().(*_dg .PdfAnnotationWidget );if _gfga {_aegce ,_afbgg :=_cg .GetName (_efagb .Get ("\u0046\u0054"));if _afbgg &&*_aegce =="\u0042\u0074\u006e"{if _ ,_bbde :=_cg .GetDict (_dgfcd );
!_bbde {_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0033\u002d\u0032","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_effdc =true ;if _cafb (){return _bbfge ;};continue ;};};};_ ,_aadb :=_cg .GetStream (_dgfcd );if !_aadb {_bbfge =append (_bbfge ,_fd ("\u0036.\u0033\u002e\u0033\u002d\u0032","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_effdc =true ;if _cafb (){return _bbfge ;};continue ;};};};_dcega ,_ebbaf :=_bfcgc .GetContext ().(*_dg .PdfAnnotationWidget );if !_ebbaf {continue ;};if !_beac {if _dcega .A !=nil {_bbfge =append (_bbfge ,_fd ("\u0036.\u0034\u002e\u0031\u002d\u0031","A \u0057\u0069d\u0067\u0065\u0074\u0020\u0061\u006e\u006e\u006f\u0074a\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006ec\u006cu\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0020e\u006et\u0072\u0079."));
_beac =true ;if _cafb (){return _bbfge ;};};};if !_gddg {if _dcega .AA !=nil {_bbfge =append (_bbfge ,_fd ("\u0036.\u0034\u002e\u0031\u002d\u0031","\u0041\u0020\u0057\u0069\u0064\u0067\u0065\u0074\u0020\u0061\u006e\u006eo\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073h\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_gddg =true ;if _cafb (){return _bbfge ;};};};};};return _bbfge ;};func _dcdg (_cfgd bool ,_egg standardType )(pageColorspaceOptimizeFunc ,documentColorspaceOptimizeFunc ){var _fdaf ,_ccga ,_adb bool ;_gcea :=func (_gccd *_cbf .Document ,_ced *_cbf .Page ,_bgg []*_cbf .Image )error {for _ ,_eafab :=range _bgg {switch _eafab .Colorspace {case "\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_ccga =true ;
case "\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_fdaf =true ;case "\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_adb =true ;};};_dede ,_bage :=_ced .GetContents ();if !_bage {return nil ;};for _ ,_ceg :=range _dede {_cgc ,_cfd :=_ceg .GetData ();
if _cfd !=nil {continue ;};_dcfa :=_be .NewContentStreamParser (string (_cgc ));_cbe ,_cfd :=_dcfa .Parse ();if _cfd !=nil {continue ;};for _ ,_egfc :=range *_cbe {switch _egfc .Operand {case "\u0047","\u0067":_ccga =true ;case "\u0052\u0047","\u0072\u0067":_fdaf =true ;
case "\u004b","\u006b":_adb =true ;case "\u0043\u0053","\u0063\u0073":if len (_egfc .Params )==0{continue ;};_gbab ,_ebeg :=_cg .GetName (_egfc .Params [0]);if !_ebeg {continue ;};switch _gbab .String (){case "\u0052\u0047\u0042","\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_fdaf =true ;
case "\u0047","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_ccga =true ;case "\u0043\u004d\u0059\u004b","\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_adb =true ;};};};};_dff :=_ced .FindXObjectForms ();for _ ,_eacb :=range _dff {_dgf :=_be .NewContentStreamParser (string (_eacb .Stream ));
_ebac ,_ggbe :=_dgf .Parse ();if _ggbe !=nil {continue ;};for _ ,_dgef :=range *_ebac {switch _dgef .Operand {case "\u0047","\u0067":_ccga =true ;case "\u0052\u0047","\u0072\u0067":_fdaf =true ;case "\u004b","\u006b":_adb =true ;case "\u0043\u0053","\u0063\u0073":if len (_dgef .Params )==0{continue ;
};_ccd ,_ebfg :=_cg .GetName (_dgef .Params [0]);if !_ebfg {continue ;};switch _ccd .String (){case "\u0052\u0047\u0042","\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_fdaf =true ;case "\u0047","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_ccga =true ;
case "\u0043\u004d\u0059\u004b","\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_adb =true ;};};};_cfec ,_cdg :=_cg .GetArray (_ced .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_cdg {return nil ;};for _ ,_bbda :=range _cfec .Elements (){_fgcd ,_ceef :=_cg .GetDict (_bbda );
if !_ceef {continue ;};_dcff :=_fgcd .Get ("\u0043");if _dcff ==nil {continue ;};_cgg ,_ceef :=_cg .GetArray (_dcff );if !_ceef {continue ;};switch _cgg .Len (){case 0:case 1:_ccga =true ;case 3:_fdaf =true ;case 4:_adb =true ;};};};return nil ;};_dgbe :=func (_gdbb *_cbf .Document ,_egccf []*_cbf .Image )error {_agb ,_gbaf :=_gdbb .FindCatalog ();
if !_gbaf {return nil ;};_dedf ,_gbaf :=_agb .GetOutputIntents ();if _gbaf &&_dedf .Len ()> 0{return nil ;};if !_gbaf {_dedf =_agb .NewOutputIntents ();};if !(_fdaf ||_adb ||_ccga ){return nil ;};defer _agb .SetOutputIntents (_dedf );if _fdaf &&!_adb &&!_ccga {return _gcb (_gdbb ,_egg ,_dedf );
};if _adb &&!_fdaf &&!_ccga {return _gdda (_egg ,_dedf );};if _ccga &&!_fdaf &&!_adb {return _fdba (_egg ,_dedf );};if _fdaf &&_adb {if _eadd :=_bad (_egccf ,_cfgd );_eadd !=nil {return _eadd ;};if _fab :=_fccdc (_gdbb ,_cfgd );_fab !=nil {return _fab ;
};if _afc :=_edea (_gdbb ,_cfgd );_afc !=nil {return _afc ;};if _gdec :=_ffc (_gdbb ,_cfgd );_gdec !=nil {return _gdec ;};if _cfgd {return _gdda (_egg ,_dedf );};return _gcb (_gdbb ,_egg ,_dedf );};return nil ;};return _gcea ,_dgbe ;};

// Conformance gets the PDF/A conformance.
func (_ageg *profile1 )Conformance ()string {return _ageg ._eab ._ca };func _ffacc (_ffba *_dg .CompliancePdfReader )(_gebd []ViolatedRule ){var _bgegc ,_baad ,_adddcf ,_dedab ,_gcgb ,_cgdb ,_gecgc bool ;_aecd :=func ()bool {return _bgegc &&_baad &&_adddcf &&_dedab &&_gcgb &&_cgdb &&_gecgc };
_fadc :=func (_adab *_cg .PdfObjectDictionary )bool {if !_bgegc &&_adab .Get ("\u0054\u0052")!=nil {_bgegc =true ;_gebd =append (_gebd ,_fd ("\u0036.\u0032\u002e\u0035\u002d\u0031","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0054\u0052\u0020\u006b\u0065\u0079\u002e"));
};if _fdcdc :=_adab .Get ("\u0054\u0052\u0032");!_baad &&_fdcdc !=nil {_gebc ,_cdeeb :=_cg .GetName (_fdcdc );if !_cdeeb ||(_cdeeb &&*_gebc !="\u0044e\u0066\u0061\u0075\u006c\u0074"){_baad =true ;_gebd =append (_gebd ,_fd ("\u0036.\u0032\u002e\u0035\u002d\u0032","\u0041\u006e \u0045\u0078\u0074G\u0053\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069on\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074a\u0069n\u0020\u0074\u0068\u0065\u0020\u0054R2 \u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076al\u0075e\u0020\u006f\u0074\u0068e\u0072 \u0074h\u0061\u006e \u0044\u0065fa\u0075\u006c\u0074\u002e"));
if _aecd (){return true ;};};};if !_adddcf &&_adab .Get ("\u0048\u0054\u0050")!=nil {_adddcf =true ;_gebd =append (_gebd ,_fd ("\u0036.\u0032\u002e\u0035\u002d\u0033","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c \u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020th\u0065\u0020\u0048\u0054\u0050\u0020\u006b\u0065\u0079\u002e"));
};_bbcfb ,_eeee :=_cg .GetDict (_adab .Get ("\u0048\u0054"));if _eeee {if _cefa :=_bbcfb .Get ("\u0048\u0061\u006cf\u0074\u006f\u006e\u0065\u0054\u0079\u0070\u0065");!_dedab &&_cefa !=nil {_bbce ,_ebcaf :=_cg .GetInt (_cefa );if !_ebcaf ||(_ebcaf &&!(*_bbce ==1||*_bbce ==5)){_gebd =append (_gebd ,_fd ("\u0020\u0036\u002e\u0032\u002e\u0035\u002d\u0034","\u0041\u006c\u006c\u0020\u0068\u0061\u006c\u0066\u0074\u006f\u006e\u0065\u0073\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0032\u0020\u0066\u0069\u006ce\u0020\u0073h\u0061\u006c\u006c\u0020h\u0061\u0076\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061l\u0075\u0065\u0020\u0031\u0020\u006f\u0072\u0020\u0035 \u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0048\u0061l\u0066\u0074\u006fn\u0065\u0054\u0079\u0070\u0065\u0020\u006be\u0079\u002e"));
if _aecd (){return true ;};};};if _bdede :=_bbcfb .Get ("\u0048\u0061\u006cf\u0074\u006f\u006e\u0065\u004e\u0061\u006d\u0065");!_gcgb &&_bdede !=nil {_gcgb =true ;_gebd =append (_gebd ,_fd ("\u0036.\u0032\u002e\u0035\u002d\u0035","\u0048\u0061\u006c\u0066\u0074o\u006e\u0065\u0073\u0020\u0069\u006e\u0020a\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0032\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020\u0061\u0020\u0048\u0061\u006c\u0066\u0074\u006f\u006e\u0065N\u0061\u006d\u0065\u0020\u006b\u0065y\u002e"));
if _aecd (){return true ;};};};_ ,_ecfa :=_afaag (_ffba );var _eae bool ;_edcdd ,_eeee :=_cg .GetDict (_adab .Get ("\u0047\u0072\u006fu\u0070"));if _eeee {_ ,_decg :=_cg .GetName (_edcdd .Get ("\u0043\u0053"));if _decg {_eae =true ;};};if _fefff :=_adab .Get ("\u0042\u004d");
!_cgdb &&!_gecgc &&_fefff !=nil {_aeddc ,_cgcg :=_cg .GetName (_fefff );if _cgcg {switch _aeddc .String (){case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065","\u004d\u0075\u006c\u0074\u0069\u0070\u006c\u0079","\u0053\u0063\u0072\u0065\u0065\u006e","\u004fv\u0065\u0072\u006c\u0061\u0079","\u0044\u0061\u0072\u006b\u0065\u006e","\u004ci\u0067\u0068\u0074\u0065\u006e","\u0043\u006f\u006c\u006f\u0072\u0044\u006f\u0064\u0067\u0065","\u0043o\u006c\u006f\u0072\u0042\u0075\u0072n","\u0048a\u0072\u0064\u004c\u0069\u0067\u0068t","\u0053o\u0066\u0074\u004c\u0069\u0067\u0068t","\u0044\u0069\u0066\u0066\u0065\u0072\u0065\u006e\u0063\u0065","\u0045x\u0063\u006c\u0075\u0073\u0069\u006fn","\u0048\u0075\u0065","\u0053\u0061\u0074\u0075\u0072\u0061\u0074\u0069\u006f\u006e","\u0043\u006f\u006co\u0072","\u004c\u0075\u006d\u0069\u006e\u006f\u0073\u0069\u0074\u0079":default:_cgdb =true ;
_gebd =append (_gebd ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0031","\u004f\u006el\u0079\u0020\u0062\u006c\u0065\u006e\u0064\u0020\u006d\u006f\u0064\u0065\u0073\u0020\u0074h\u0061\u0074\u0020\u0061\u0072\u0065\u0020\u0073\u0070\u0065c\u0069\u0066\u0069ed\u0020\u0069\u006e\u0020\u0049\u0053O\u0020\u0033\u0032\u0030\u0030\u0030\u002d\u0031\u003a2\u0030\u0030\u0038\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075e\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0042M\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0065\u0078t\u0065\u006e\u0064\u0065\u0064\u0020\u0067\u0072\u0061\u0070\u0068\u0069\u0063\u0020\u0073\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
if _aecd (){return true ;};};if _aeddc .String ()!="\u004e\u006f\u0072\u006d\u0061\u006c"&&!_ecfa &&!_eae {_gecgc =true ;_gebd =append (_gebd ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _aecd (){return true ;};};};};if _ ,_eeee =_cg .GetDict (_adab .Get ("\u0053\u004d\u0061s\u006b"));!_gecgc &&_eeee &&!_ecfa &&!_eae {_gecgc =true ;_gebd =append (_gebd ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _aecd (){return true ;};};if _cbdf :=_adab .Get ("\u0043\u0041");!_gecgc &&_cbdf !=nil &&!_ecfa &&!_eae {_baecf ,_gbdf :=_cg .GetNumberAsFloat (_cbdf );if _gbdf ==nil &&_baecf < 1.0{_gecgc =true ;_gebd =append (_gebd ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _aecd (){return true ;};};};if _dacf :=_adab .Get ("\u0063\u0061");!_gecgc &&_dacf !=nil &&!_ecfa &&!_eae {_bcac ,_deea :=_cg .GetNumberAsFloat (_dacf );if _deea ==nil &&_bcac < 1.0{_gecgc =true ;_gebd =append (_gebd ,_fd ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0032","\u0049\u0066\u0020\u0074\u0068\u0065 \u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0064\u006f\u0065\u0073\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020P\u0044\u0046\u002f\u0041\u0020\u004f\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0050\u0061\u0067\u0065\u0020\u006f\u0062\u006a\u0065\u0063t\u0073\u0020\u0074\u0068a\u0074 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020t\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063l\u0075\u0064\u0065\u0020\u0074\u0068\u0065\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006b\u0065y\u002c a\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0061\u0074\u0074\u0072\u0069\u0062\u0075\u0074\u0065\u0020\u0064\u0069c\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0066\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0061\u0074\u0020\u0047\u0072\u006fu\u0070\u0020\u006b\u0065y\u0020sh\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075d\u0065\u0020\u0061\u0020\u0043\u0053\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0077\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065 \u0075\u0073\u0065\u0064\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0064\u0065\u0066\u0061\u0075\u006c\u0074\u0020\u0062\u006c\u0065\u006e\u0064\u0069n\u0067 \u0063\u006f\u006c\u006f\u0075\u0072\u0020\u0073p\u0061\u0063\u0065\u002e"));
if _aecd (){return true ;};};};return false ;};for _ ,_gdac :=range _ffba .PageList {_bbgf :=_gdac .Resources ;if _bbgf ==nil {continue ;};if _bbgf .ExtGState ==nil {continue ;};_ebge ,_fgdg :=_cg .GetDict (_bbgf .ExtGState );if !_fgdg {continue ;};_bdca :=_ebge .Keys ();
for _ ,_geeg :=range _bdca {_bbcd ,_dfgag :=_cg .GetDict (_ebge .Get (_geeg ));if !_dfgag {continue ;};if _fadc (_bbcd ){return _gebd ;};};};for _ ,_baacg :=range _ffba .PageList {_cggd :=_baacg .Resources ;if _cggd ==nil {continue ;};_ggebd ,_dbcaa :=_cg .GetDict (_cggd .XObject );
if !_dbcaa {continue ;};for _ ,_gggc :=range _ggebd .Keys (){_aefea ,_facdc :=_cg .GetStream (_ggebd .Get (_gggc ));if !_facdc {continue ;};_ccgfg ,_facdc :=_cg .GetDict (_aefea .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));if !_facdc {continue ;
};_caef ,_facdc :=_cg .GetDict (_ccgfg .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_facdc {continue ;};for _ ,_adadg :=range _caef .Keys (){_faaaa ,_gcfg :=_cg .GetDict (_caef .Get (_adadg ));if !_gcfg {continue ;};if _fadc (_faaaa ){return _gebd ;
};};};};return _gebd ;};func _daed (_dfdg *_cbf .Document ){if _dfdg .ID [0]!=""&&_dfdg .ID [1]!=""{return ;};_dfdg .UseHashBasedID =true ;};func _egdf (_dbdg *_dg .CompliancePdfReader )(_acfe []ViolatedRule ){if _dbdg .ParserMetadata ().HasOddLengthHexStrings (){_acfe =append (_acfe ,_fd ("\u0036.\u0031\u002e\u0036\u002d\u0031","\u0068\u0065\u0078a\u0064\u0065\u0063\u0069\u006d\u0061\u006c\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020\u006f\u0066\u0020e\u0076\u0065\u006e\u0020\u0073\u0069\u007a\u0065"));
};if _dbdg .ParserMetadata ().HasOddLengthHexStrings (){_acfe =append (_acfe ,_fd ("\u0036.\u0031\u002e\u0036\u002d\u0032","\u0068\u0065\u0078\u0061\u0064\u0065\u0063\u0069\u006da\u006c\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068o\u0075\u006c\u0064\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u006f\u006e\u006c\u0079\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0073\u0020\u0066\u0072\u006f\u006d\u0020\u0072\u0061n\u0067\u0065\u0020[\u0030\u002d\u0039\u003b\u0041\u002d\u0046\u003b\u0061\u002d\u0066\u005d"));
};return _acfe ;};func _gecg (_cgcd *_dg .PdfInfo ,_aaafb func ()_a .Time )error {var _facd *_dg .PdfDate ;if _cgcd .CreationDate ==nil {_febc ,_bacc :=_dg .NewPdfDateFromTime (_aaafb ());if _bacc !=nil {return _bacc ;};_facd =&_febc ;_cgcd .CreationDate =_facd ;
};if _cgcd .ModifiedDate ==nil {if _facd !=nil {_acec ,_bbf :=_dg .NewPdfDateFromTime (_aaafb ());if _bbf !=nil {return _bbf ;};_facd =&_acec ;};_cgcd .ModifiedDate =_facd ;};return nil ;};var _ Profile =(*Profile1B )(nil );func _dbaag (_ccedb *_dg .CompliancePdfReader )(_ccac []ViolatedRule ){_cceff :=func (_abfac *_cg .PdfObjectDictionary ,_abcca *[]string ,_gfefg *[]ViolatedRule )error {_abbg :=_abfac .Get ("\u004e\u0061\u006d\u0065");
if _abbg ==nil ||len (_abbg .String ())==0{*_gfefg =append (*_gfefg ,_fd ("\u0036\u002e\u0039-\u0031","\u0045\u0061\u0063\u0068\u0020o\u0070\u0074\u0069\u006f\u006e\u0061l\u0020\u0063\u006f\u006e\u0074\u0065\u006et\u0020\u0063\u006fn\u0066\u0069\u0067\u0075r\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u004e\u0061\u006d\u0065\u0020\u006b\u0065\u0079\u002e"));
};for _ ,_gagcc :=range *_abcca {if _gagcc ==_abbg .String (){*_gfefg =append (*_gfefg ,_fd ("\u0036\u002e\u0039-\u0032","\u0045\u0061\u0063\u0068\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061l\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074\u0020\u0063\u006f\u006e\u0066\u0069\u0067\u0075\u0072a\u0074\u0069\u006fn\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020N\u0061\u006d\u0065\u0020\u006b\u0065\u0079\u002c w\u0068\u006fs\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020s\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0075ni\u0071\u0075\u0065 \u0061\u006d\u006f\u006e\u0067\u0073\u0074\u0020\u0061\u006c\u006c\u0020o\u0070\u0074\u0069\u006f\u006e\u0061\u006c\u0020\u0063\u006fn\u0074\u0065\u006e\u0074 \u0063\u006f\u006e\u0066\u0069\u0067u\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074i\u006fn\u0061\u0072\u0069\u0065\u0073\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0074\u0068e\u0020\u0050\u0044\u0046\u002fA\u002d\u0032\u0020\u0066\u0069l\u0065\u002e"));
}else {*_abcca =append (*_abcca ,_abbg .String ());};};if _abfac .Get ("\u0041\u0053")!=nil {*_gfefg =append (*_gfefg ,_fd ("\u0036\u002e\u0039-\u0034","Th\u0065\u0020\u0041\u0053\u0020\u006b\u0065y \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0061\u0070\u0070\u0065\u0061r\u0020\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c\u0020\u0063\u006f\u006et\u0065\u006e\u0074\u0020\u0063\u006fn\u0066\u0069\u0067\u0075\u0072\u0061\u0074\u0069\u006fn\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
};return nil ;};_ebaa ,_dbea :=_febce (_ccedb );if !_dbea {return _ccac ;};_eeab ,_dbea :=_cg .GetDict (_ebaa .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073"));if !_dbea {return _ccac ;};var _bfdac []string ;_acecad ,_dbea :=_cg .GetDict (_eeab .Get ("\u0044"));
if _dbea {_cceff (_acecad ,&_bfdac ,&_ccac );};_afeda ,_dbea :=_cg .GetArray (_eeab .Get ("\u0043o\u006e\u0066\u0069\u0067\u0073"));if _dbea {for _fcae :=0;_fcae < _afeda .Len ();_fcae ++{_cfag ,_cfcf :=_cg .GetDict (_afeda .Get (_fcae ));if !_cfcf {continue ;
};_cceff (_cfag ,&_bfdac ,&_ccac );};};return _ccac ;};func _adba (_bgagd *_dg .CompliancePdfReader )(_cgfcb []ViolatedRule ){var _gdgea ,_gcdb ,_ecaf ,_geaf ,_gdaee ,_begc ,_beddf bool ;_dbfd :=func ()bool {return _gdgea &&_gcdb &&_ecaf &&_geaf &&_gdaee &&_begc &&_beddf };
for _ ,_gdgd :=range _bgagd .PageList {_ebbc ,_bdcb :=_gdgd .GetAnnotations ();if _bdcb !=nil {_ef .Log .Trace ("\u006c\u006f\u0061\u0064\u0069\u006e\u0067\u0020\u0061\u006en\u006f\u0074\u0061\u0074\u0069\u006f\u006es\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_bdcb );
continue ;};for _ ,_eaff :=range _ebbc {if !_gdgea {switch _eaff .GetContext ().(type ){case *_dg .PdfAnnotationFileAttachment ,*_dg .PdfAnnotationSound ,*_dg .PdfAnnotationMovie ,nil :_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0032\u002d\u0031","\u0041\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0074\u0079\u0070\u0065\u0073\u0020\u006e\u006f\u0074 \u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006ec\u0065\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020p\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e\u0020\u0041d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020\u0074\u0068\u0065\u0020F\u0069\u006c\u0065\u0041\u0074\u0074\u0061\u0063\u0068\u006de\u006e\u0074\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u0020\u0061\u006e\u0064\u0020\u004d\u006f\u0076\u0069e\u0020\u0074\u0079\u0070\u0065s \u0073ha\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_gdgea =true ;if _dbfd (){return _cgfcb ;};};};_aeea ,_cecf :=_cg .GetDict (_eaff .GetContainingPdfObject ());if !_cecf {continue ;};if !_gcdb {_fgbb ,_deag :=_cg .GetFloatVal (_aeea .Get ("\u0043\u0041"));if _deag &&_fgbb !=1.0{_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0031","\u0041\u006e\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073h\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0043\u0041\u0020\u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u002e\u0030\u002e"));
_gcdb =true ;if _dbfd (){return _cgfcb ;};};};if !_ecaf {_bacdd ,_ffbb :=_cg .GetIntVal (_aeea .Get ("\u0046"));if !(_ffbb &&_bacdd &4==4&&_bacdd &1==0&&_bacdd &2==0&&_bacdd &32==0){_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0032","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0074\u0068\u0065\u0020\u0046\u0020\u006b\u0065\u0079\u002e\u0020\u0054\u0068\u0065\u0020\u0046\u0020\u006b\u0065\u0079\u0027\u0073\u0020\u0050\u0072\u0069\u006e\u0074\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065 s\u0065\u0074\u0020\u0074\u006f\u0020\u0031\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0048\u0069\u0064\u0064\u0065\u006e\u002c\u0020I\u006e\u0076\u0069\u0073\u0069\u0062\u006c\u0065\u0020\u0061\u006e\u0064\u0020\u004e\u006f\u0056\u0069\u0065\u0077\u0020\u0066\u006c\u0061\u0067\u0020b\u0069\u0074\u0073 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073e\u0074\u0020t\u006f\u0020\u0030\u002e"));
_ecaf =true ;if _dbfd (){return _cgfcb ;};};};if !_geaf {_ecdfd ,_dceg :=_cg .GetDict (_aeea .Get ("\u0041\u0050"));if _dceg {_dcbf :=_ecdfd .Get ("\u004e");if _dcbf ==nil ||len (_ecdfd .Keys ())> 1{_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_geaf =true ;if _dbfd (){return _cgfcb ;};continue ;};_ ,_fddfg :=_eaff .GetContext ().(*_dg .PdfAnnotationWidget );if _fddfg {_daee ,_dabgb :=_cg .GetName (_aeea .Get ("\u0046\u0054"));if _dabgb &&*_daee =="\u0042\u0074\u006e"{if _ ,_bbfb :=_cg .GetDict (_dcbf );
!_bbfb {_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_geaf =true ;if _dbfd (){return _cgfcb ;};continue ;};};};_ ,_gdfad :=_cg .GetStream (_dcbf );if !_gdfad {_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_geaf =true ;if _dbfd (){return _cgfcb ;};continue ;};};};if !_gdaee {if _aeea .Get ("\u0043")!=nil ||_aeea .Get ("\u0049\u0043")!=nil {_bagfc ,_cgga :=_fcgbg (_bgagd );if !_cgga {_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0033","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006fn\u0074a\u0069\u006e\u0020t\u0068e\u0020\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0072\u0020\u0074\u0068e\u0020\u0049\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u0075\u006e\u006c\u0065\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006ff\u0069\u006ce\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069n\u0020\u0036\u002e\u0032\u002e2\u002c\u0020\u0069\u0073\u0020\u0052\u0047\u0042."));
_gdaee =true ;if _dbfd (){return _cgfcb ;};}else {_afgb ,_agff :=_cg .GetIntVal (_bagfc .Get ("\u004e"));if !_agff ||_afgb !=3{_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0035\u002e\u0033\u002d\u0033","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006fn\u0074a\u0069\u006e\u0020t\u0068e\u0020\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0072\u0020\u0074\u0068e\u0020\u0049\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u0075\u006e\u006c\u0065\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006ff\u0069\u006ce\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069n\u0020\u0036\u002e\u0032\u002e2\u002c\u0020\u0069\u0073\u0020\u0052\u0047\u0042."));
_gdaee =true ;if _dbfd (){return _cgfcb ;};};};};};_cgfb ,_gafcf :=_eaff .GetContext ().(*_dg .PdfAnnotationWidget );if !_gafcf {continue ;};if !_begc {if _cgfb .A !=nil {_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0036\u002e\u0031\u002d\u0033","A \u0057\u0069d\u0067\u0065\u0074\u0020\u0061\u006e\u006e\u006f\u0074a\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006ec\u006cu\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0020e\u006et\u0072\u0079."));
_begc =true ;if _dbfd (){return _cgfcb ;};};};if !_beddf {if _cgfb .AA !=nil {_cgfcb =append (_cgfcb ,_fd ("\u0036.\u0036\u002e\u0032\u002d\u0031","\u0041\u0020\u0057\u0069\u0064\u0067\u0065\u0074\u0020\u0061\u006e\u006eo\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073h\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_beddf =true ;if _dbfd (){return _cgfcb ;};};};};};return _cgfcb ;};func _bagbd (_cgea *_dg .CompliancePdfReader )(_cabe []ViolatedRule ){var _bfccdd ,_edabc bool ;_effcc :=func ()bool {return _bfccdd &&_edabc };for _ ,_acbf :=range _cgea .GetObjectNums (){_dgdbf ,_ggbag :=_cgea .GetIndirectObjectByNumber (_acbf );
if _ggbag !=nil {_ef .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0025\u0064\u0020fa\u0069\u006c\u0065d\u003a \u0025\u0076",_acbf ,_ggbag );
continue ;};_ebegg ,_fdffa :=_cg .GetDict (_dgdbf );if !_fdffa {continue ;};_dfae ,_fdffa :=_cg .GetName (_ebegg .Get ("\u0054\u0079\u0070\u0065"));if !_fdffa {continue ;};if *_dfae !="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_eacedfc ,_fdffa :=_cg .GetName (_ebegg .Get ("\u0053"));
if !_fdffa {if !_bfccdd {_cabe =append (_cabe ,_fd ("\u0036.\u0035\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004caun\u0063\u0068\u002c\u0020S\u006f\u0075\u006e\u0064,\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046\u006f\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044a\u0074\u0061,\u0020\u0048\u0069\u0064\u0065\u002c\u0020\u0053\u0065\u0074\u004f\u0043\u0047\u0053\u0074\u0061\u0074\u0065\u002c\u0020\u0052\u0065\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u002c\u0020T\u0072\u0061\u006e\u0073\u002c\u0020\u0047o\u0054\u006f\u0033\u0044\u0056\u0069\u0065\u0077\u0020\u0061\u006e\u0064\u0020\u004a\u0061v\u0061Sc\u0072\u0069p\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020\u0070\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e \u0041\u0064d\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020t\u0068\u0065\u0020\u0064\u0065\u0070\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020\u0073\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u006f\u0070\u0020\u0061c\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070e\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_bfccdd =true ;if _effcc (){return _cabe ;};};continue ;};switch _dg .PdfActionType (*_eacedfc ){case _dg .ActionTypeLaunch ,_dg .ActionTypeSound ,_dg .ActionTypeMovie ,_dg .ActionTypeResetForm ,_dg .ActionTypeImportData ,_dg .ActionTypeJavaScript ,_dg .ActionTypeHide ,_dg .ActionTypeSetOCGState ,_dg .ActionTypeRendition ,_dg .ActionTypeTrans ,_dg .ActionTypeGoTo3DView :if !_bfccdd {_cabe =append (_cabe ,_fd ("\u0036.\u0035\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004caun\u0063\u0068\u002c\u0020S\u006f\u0075\u006e\u0064,\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046\u006f\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044a\u0074\u0061,\u0020\u0048\u0069\u0064\u0065\u002c\u0020\u0053\u0065\u0074\u004f\u0043\u0047\u0053\u0074\u0061\u0074\u0065\u002c\u0020\u0052\u0065\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u002c\u0020T\u0072\u0061\u006e\u0073\u002c\u0020\u0047o\u0054\u006f\u0033\u0044\u0056\u0069\u0065\u0077\u0020\u0061\u006e\u0064\u0020\u004a\u0061v\u0061Sc\u0072\u0069p\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020\u0070\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e \u0041\u0064d\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020t\u0068\u0065\u0020\u0064\u0065\u0070\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020\u0073\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u006f\u0070\u0020\u0061c\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070e\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_bfccdd =true ;if _effcc (){return _cabe ;};};continue ;case _dg .ActionTypeNamed :if !_edabc {_egfcc ,_bagbc :=_cg .GetName (_ebegg .Get ("\u004e"));if !_bagbc {_cabe =append (_cabe ,_fd ("\u0036.\u0035\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_edabc =true ;if _effcc (){return _cabe ;};continue ;};switch *_egfcc {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_cabe =append (_cabe ,_fd ("\u0036.\u0035\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_edabc =true ;if _effcc (){return _cabe ;};continue ;};};};};return _cabe ;};func _dadd (_cccce *_dg .CompliancePdfReader )ViolatedRule {_dccf :=_cccce .ParserMetadata ();if _dccf .HasInvalidSeparationAfterXRef (){return _fd ("\u0036.\u0031\u002e\u0034\u002d\u0032","\u0054\u0068\u0065 \u0078\u0072\u0065\u0066\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0063\u0072\u006f\u0073s\u0020\u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065 s\u0075b\u0073\u0065\u0063ti\u006f\u006e\u0020\u0068\u0065\u0061\u0064e\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079 \u0061\u0020\u0073i\u006e\u0067\u006c\u0065\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u002e");
};return _cd ;};func _cadg (_ffg *_cg .PdfObjectDictionary ,_adccb map[*_cg .PdfObjectStream ][]byte ,_dedg map[*_cg .PdfObjectStream ]*_gf .CMap )ViolatedRule {const (_eecbe ="\u0036\u002e\u0032\u002e\u0031\u0031\u002e\u0033\u002d\u0033";_bbfbg ="\u0041\u006c\u006c \u0043\u004d\u0061\u0070s\u0020\u0075\u0073ed\u0020\u0077\u0069\u0074\u0068i\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0032\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074 th\u006f\u0073\u0065\u0020\u006ci\u0073\u0074\u0065\u0064\u0020i\u006e\u0020\u0049\u0053\u004f\u0020\u0033\u00320\u00300\u002d1\u003a\u0032\u0030\u0030\u0038\u002c\u0020\u0039\u002e\u0037\u002e\u0035\u002e\u0032\u002c\u0020\u0054\u0061\u0062\u006c\u0065 \u0031\u00318,\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0069\u006e \u0074\u0068\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u0020\u0061\u0073\u0020\u0064e\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0049\u0053\u004f\u0020\u0033\u0032\u00300\u0030-\u0031\u003a\u0032\u0030\u0030\u0038\u002c\u00209\u002e\u0037\u002e\u0035\u002e";
);var _dgbed string ;if _dabga ,_ffcd :=_cg .GetName (_ffg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_ffcd {_dgbed =_dabga .String ();};if _dgbed !="\u0054\u0079\u0070e\u0030"{return _cd ;};_eabc :=_ffg .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _edcde ,_gdaf :=_cg .GetName (_eabc );_gdaf {switch _edcde .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _cd ;default:return _fd (_eecbe ,_bbfbg );
};};_dfdab ,_dfgbb :=_cg .GetStream (_eabc );if !_dfgbb {return _fd (_eecbe ,_bbfbg );};_ ,_afbda :=_cefgf (_dfdab ,_adccb ,_dedg );if _afbda !=nil {return _fd (_eecbe ,_bbfbg );};return _cd ;};func _cefgf (_cafab *_cg .PdfObjectStream ,_adaeg map[*_cg .PdfObjectStream ][]byte ,_acdff map[*_cg .PdfObjectStream ]*_gf .CMap )(*_gf .CMap ,error ){_eddg ,_gbbba :=_acdff [_cafab ];
if !_gbbba {var _bdge error ;_gbgf ,_fafd :=_adaeg [_cafab ];if !_fafd {_gbgf ,_bdge =_cg .DecodeStream (_cafab );if _bdge !=nil {_ef .Log .Debug ("\u0064\u0065\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0073\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064:\u0020\u0025\u0076",_bdge );
return nil ,_bdge ;};_adaeg [_cafab ]=_gbgf ;};_eddg ,_bdge =_gf .LoadCmapFromData (_gbgf ,false );if _bdge !=nil {return nil ,_bdge ;};_acdff [_cafab ]=_eddg ;};return _eddg ,nil ;};type imageModifications struct{_gbad *colorspaceModification ;_dag _cg .StreamEncoder ;
};func _dae (_ge []_cg .PdfObject )(*documentImages ,error ){_fgf :=_cg .PdfObjectName ("\u0053u\u0062\u0074\u0079\u0070\u0065");_eeg :=make (map[*_cg .PdfObjectStream ]struct{});_fdf :=make (map[_cg .PdfObject ]struct{});var (_dgbb ,_aa ,_dc bool ;_efd []*imageInfo ;
_cee error ;);for _ ,_egc :=range _ge {_fca ,_ebc :=_cg .GetStream (_egc );if !_ebc {continue ;};if _ ,_gd :=_eeg [_fca ];_gd {continue ;};_eeg [_fca ]=struct{}{};_bga :=_fca .PdfObjectDictionary .Get (_fgf );_cbd ,_ebc :=_cg .GetName (_bga );if !_ebc ||string (*_cbd )!="\u0049\u006d\u0061g\u0065"{continue ;
};if _ac :=_fca .PdfObjectDictionary .Get ("\u0053\u004d\u0061s\u006b");_ac !=nil {_fdf [_ac ]=struct{}{};};_ff :=imageInfo {BitsPerComponent :8,Stream :_fca };_ff .ColorSpace ,_cee =_dg .DetermineColorspaceNameFromPdfObject (_fca .PdfObjectDictionary .Get ("\u0043\u006f\u006c\u006f\u0072\u0053\u0070\u0061\u0063\u0065"));
if _cee !=nil {return nil ,_cee ;};if _gg ,_addd :=_cg .GetIntVal (_fca .PdfObjectDictionary .Get ("\u0042\u0069t\u0073\u0050\u0065r\u0043\u006f\u006d\u0070\u006f\u006e\u0065\u006e\u0074"));_addd {_ff .BitsPerComponent =_gg ;};if _gba ,_adg :=_cg .GetIntVal (_fca .PdfObjectDictionary .Get ("\u0057\u0069\u0064t\u0068"));
_adg {_ff .Width =_gba ;};if _fgb ,_eec :=_cg .GetIntVal (_fca .PdfObjectDictionary .Get ("\u0048\u0065\u0069\u0067\u0068\u0074"));_eec {_ff .Height =_fgb ;};switch _ff .ColorSpace {case "\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_dc =true ;
_ff .ColorComponents =1;case "\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_dgbb =true ;_ff .ColorComponents =3;case "\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_aa =true ;_ff .ColorComponents =4;default:_ff ._fcg =true ;};_efd =append (_efd ,&_ff );
};if len (_fdf )> 0{if len (_fdf )==len (_efd ){_efd =nil ;}else {_abc :=make ([]*imageInfo ,len (_efd )-len (_fdf ));var _db int ;for _ ,_becd :=range _efd {if _ ,_bfa :=_fdf [_becd .Stream ];_bfa {continue ;};_abc [_db ]=_becd ;_db ++;};_efd =_abc ;};
};return &documentImages {_bec :_dgbb ,_cge :_aa ,_gc :_dc ,_bf :_fdf ,_cgb :_efd },nil ;};

// NewProfile2B creates a new Profile2B with the given options.
func NewProfile2B (options *Profile2Options )*Profile2B {if options ==nil {options =DefaultProfile2Options ();};_daad (options );return &Profile2B {profile2 {_fafg :*options ,_becece :_eff ()}};};

// DefaultProfile2Options are the default options for the Profile2.
func DefaultProfile2Options ()*Profile2Options {return &Profile2Options {Now :_a .Now ,Xmp :XmpOptions {MarshalIndent :"\u0009"}};};

// Profile1Options are the options that changes the way how optimizer may try to adapt document into PDF/A standard.
type Profile1Options struct{

// CMYKDefaultColorSpace is an option that refers PDF/A-1
CMYKDefaultColorSpace bool ;

// Now is a function that returns current time.
Now func ()_a .Time ;

// Xmp is the xmp options information.
Xmp XmpOptions ;};func _gecgd (_dcbe *_dg .CompliancePdfReader )[]ViolatedRule {return nil };func _gaba (_feee *_dg .CompliancePdfReader )(_defea []ViolatedRule ){for _ ,_aecda :=range _feee .GetObjectNums (){_cefgg ,_ddfff :=_feee .GetIndirectObjectByNumber (_aecda );
if _ddfff !=nil {continue ;};_egdg ,_ggbdd :=_cg .GetDict (_cefgg );if !_ggbdd {continue ;};_cebdb ,_ggbdd :=_cg .GetName (_egdg .Get ("\u0054\u0079\u0070\u0065"));if !_ggbdd {continue ;};if _cebdb .String ()!="\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"{continue ;
};_bbaf ,_ggbdd :=_cg .GetBool (_egdg .Get ("\u004ee\u0065d\u0041\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0073"));if _ggbdd &&bool (*_bbaf ){_defea =append (_defea ,_fd ("\u0036.\u0034\u002e\u0031\u002d\u0033","\u0054\u0068\u0065\u0020\u004e\u0065e\u0064\u0041\u0070\u0070\u0065a\u0072\u0061\u006e\u0063\u0065\u0073\u0020\u0066\u006c\u0061\u0067\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0069\u006e\u0074\u0065\u0072\u0061\u0063\u0074\u0069\u0076e\u0020\u0066\u006f\u0072\u006d \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u006e\u006f\u0074\u0020b\u0065\u0020\u0070\u0072\u0065se\u006e\u0074\u0020\u006f\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
};if _egdg .Get ("\u0058\u0046\u0041")!=nil {_defea =append (_defea ,_fd ("\u0036.\u0034\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064o\u0063\u0075\u006d\u0065\u006e\u0074\u0027\u0073\u0020i\u006e\u0074\u0065\u0072\u0061\u0063\u0074\u0069\u0076\u0065\u0020\u0066\u006f\u0072\u006d\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020t\u0068\u0061\u0074\u0020f\u006f\u0072\u006d\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065 \u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d \u006b\u0065\u0079\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0027\u0073\u0020\u0043\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006f\u0066 \u0061 \u0050\u0044F\u002fA\u002d\u0032\u0020\u0066ile\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065n\u0074\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0058\u0046\u0041\u0020\u006b\u0065y."));
};};_ffdae ,_bcgg :=_febce (_feee );if _bcgg &&_ffdae .Get ("\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067")!=nil {_defea =append (_defea ,_fd ("\u0036.\u0034\u002e\u0032\u002d\u0032","\u0041\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0027\u0073\u0020\u0043\u0061\u0074\u0061\u006cog\u0020s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u004e\u0065\u0065\u0064\u0073\u0052\u0065\u006e\u0064e\u0072\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u002e"));
};return _defea ;};func _daad (_aag *Profile2Options ){if _aag .Now ==nil {_aag .Now =_a .Now ;};};type documentImages struct{_bec ,_cge ,_gc bool ;_bf map[_cg .PdfObject ]struct{};_cgb []*imageInfo ;};